/***  big.c
***/
#define  BIG_C

#include "lisp.h"
#include <stdio.h>
/*** #include "GMP/gmp.h"          **All GMP programs need to include gmp.h */

mpz_t mpzwork1,mpzwork2;

ptr bignum(); 
ptr mpz2bignum();

init_big(){
mpz_init(mpzwork1);
mpz_init(mpzwork2);
}

/***  p must >0 and BIGINT  , return unsigned integer   04.4.24 ***/

unsigned long int GET32NUM(ptr p)
{
   return mpz_get_ui(BIGNUM(p));
}

ptr check16(p)
  Reg ptr p;
  /****  p MUST be   BIG  ,  if p is SINT then p--->SINT   ****/
{
  Reg long int n;
   if(SINTP(p)) return p;
   psh(p);
   if(mpz_fits_slong_p(BIGNUM(p))){
      n=mpz_get_si(BIGNUM(p));
      /** printf("check16 %x  n %x\n",p,n); ***/
      if((n<=SINTMAX)&&(n>=SINTMIN)){
         pull();
         return MAKESINT(n);
       }
    }
  pull();
  return p;
}


ptr mpz_check16(mpz_t x)
{
  Reg long int n;
   if(mpz_fits_slong_p(x)){
      n=mpz_get_si(x);
      if((n<=SINTMAX)&&(n>=SINTMIN))
         return MAKESINT(n);
    }
  return mpz2bignum(x);
}


ptr mpz2bignum(mpz_t num)
{
 ptr z;
   z=new_cell(BIGINT);
   psh(z);
 BIGNUM(z)=Mymalloc(sizeof(MP_INT));
 /*** printf("size MP_INT %x\n",sizeof(MP_INT));     0x0c ***/
 mpz_init_set(BIGNUM(z),num);
  pull();
 return z;
}

ptr ptr2bignum(ptr x)
{
 long val;
   if(SINTP(x)) {
     val=SINT_NUMB(x);
                 return  bignum(val);
    }
  else if(BIGINTP(x))
                 return x;
  else
     error(E_notint, x);
}

ptr bignum(long n)    
{
  ptr z;
   z=new_cell(BIGINT);
   psh(z);
  BIGNUM(z) = Mymalloc(sizeof(MP_INT)); 
  mpz_init_set_si(BIGNUM(z), n);
  pull();
  return z; 
}

/*** 2005.3.21  for big file size ***/
/***  64bit big positive integer -> bignum  ***/
ptr bignum64(unsigned long high, unsigned long low)
{
  ptr z;
   z=new_cell(BIGINT);
   psh(z);
  BIGNUM(z) = Mymalloc(sizeof(MP_INT));
  mpz_init_set_ui(BIGNUM(z), high);
  mpz_mul_2exp(BIGNUM(z),BIGNUM(z),32);
  mpz_add_ui(BIGNUM(z),BIGNUM(z),low);
  pull();
  return z;
}


/***
bigtest(){
ptr x;
printf("cell size %x\n",sizeof(struct _cell));
printf("double size %x\n",sizeof(double));
}
***/

