/*****
   callcc.c
 
   call/cc
   03.12.22
    only for MC
****/
#include "lisp.h"
#include <setjmp.h>

extern jmp_buf user_env[];  /****  0 is used for top-level always ***/

extern int level,narg;
extern ptr scm,*MPC;
extern ptr *get_vector();

static ptr make_adress(ptr p){
  ptr s;
  s=new_cell(MALLOC|MALLOC_BIN);
  CAR(s)=-1;  /*** indicate not adress by malloc ***/
  CDR(s)=p;
  return s;
}

static ptr MC_make_cc(){
  Reg ptr res,s,*p,*q=stack_base;
  int n;

  res=CONS(ATOMVAL(a_dynamic),a_env);
  res=SCONS(MAKESINT(level),res);
  res=SCONS(MAKESINT(narg),res);
  /** res=SCONS(MPC,res); ***/
  s=make_adress(MPC);
  res=SCONS(s,res); 
  s=make_adress(frame_stack);
  res=SCONS(s,res); 
  sys_pro(res);
  s=makevector(stack-stack_base,a_nil); /*** New ***/
  p=get_vector(s,&n);
  while(n--){
    *p++=*q++;
  }
  syspro--;
  *stack++=res=SCONS(s,res);
  /****
  s=makevector(pc_stack-(q=PC),a_nil);
  p=get_vector(s,&n);
   while(n--){
    *p++=*q++;
  }
  *(stack-1)=res=SCONS(s,res);
   ******/
  s=makevector(mpu_stack-(q=MPU),a_nil);  /**** New  ***/
   p=get_vector(s,&n);
   while(n--){
    *p++=*q++;
  }
  pull();
  res=SCONS(s,res);
  ATTR(res)=CWC;
  return res;
}

static ptr MC_restore_cc(ptr x,ptr scm,ptr rest){
 Reg ptr v,*p,*q;
 int n;
 /*** prin1(x,STDOUT); ***/
 v=CAR(x);
 p=get_vector(v,&n);
 mpu_stack=MPU+n;
 q=MPU;
 while(n--){
   *q++=*p++;
 }
/****
 x=CDR(x);
 v=CAR(x);
 p=get_vector(v,&n);
 pc_stack=PC+n;
 q=PC;
 while(n--){
   *q++=*p++;
 }
****/
 x=CDR(x);
 v=CAR(x);
 p=get_vector(v,&n);
 stack=(q=stack_base)+n;
 while(n--){
   *q++=*p++;
 }
x=CDR(x);
/** MPC=CAR(x); ***/
frame_stack=CDR(CAR(x));   /***  frame_stack is stored in malloc-data  ***/
x=CDR(x);
MPC=CDR(CAR(x));   /***   MPC is stored in malloc-data  (-1 .  MPC) ***/

x=CDR(x);
narg=SINT_NUMB(CAR(x));
x=CDR(x);
level=SINT_NUMB(CAR(x));
x=CDR(x);
ATOMVAL(a_dynamic)=CAR(x);
if(CAR(x)!=a_nil){
  funcall(CAR(x),0,a_nil);
  /*** PUSH(M_before);
       PUSH(CONS(CAR(x),a_nil)); 
   ***/
}
a_env=CDR(x);
if(rest!=a_nil){
    v=CONS(scm,rest);
   ATTR(v)=MULTI;
   multiscm=v;  /*** 04.4.26  ***/
  }
 /*** prin1(make_cc(),STDOUT); ***/
/*** narg++;
 return *stack++=scm;
 ***/
return scm;
}



static ptr MC_cc_jump(int narg,ptr env){
  ptr scm;
  int n;
  jmp_buf *jj;
  if(narg==1) scm=*(stack-1);
  else
    scm=s_values(narg,a_nil);
  /*** printf("cc_jump narg %d\n",narg); ***/
  MC_restore_cc(CAR(env),scm,a_nil);
  jj=CADR(env);
  /*** printf("cc_jump level %d  jmplevel %d\n",jj-user_env,jmp_level); ***/
  jmp_level=jj-user_env+1;   /** 04.4.30  for bug in IGO  catch-error ***/
  longjmp(CADR(env),scm);
  return NULL;  /*****   JUMP!  ***/
}

ptr MC_callcc(){
 ptr func,env;
ptr ret;
jmp_buf *jj;

  /** printf("call/cc 1 stack %x\n",stack); **/
  func=scm;   /***  (call/cc func )   ***/
  sys_pro(func);
  env=MC_make_cc();
  syspro--;
  psh(func);
  env=SCONS(env,a_nil); /*** CWCC,JMP  ***/
  psh(env);
  ret=CONS(a_nil,a_nil);
  ATTR(ret)=JMP;
  jj=user_env+jmp_level-1; /**** last created jump  ***/
  CAR(ret)=jj;
  CDR(env)=ret;   /*** CC, JMP     JMP=(jj,nil)   ***/
  env=make_subr(MC_cc_jump,(int)subr_argtype(1,1)|SLAMBDA,env);
  stack-=2;
  MC_func();
  psh(env);  /*** STACK-NARG  ***/
  narg=1;
  /***
  scm=funcall(func,1,a_env);
  stack-=3;
  ***/
  MPC--;   /***  behave like jsr narg ***/
  return MC_jsr();
  
 /**  return scm; ***/
}

/***
ptr MC_callcc_old(){
 ptr func,env;
ptr ret;
jmp_buf *jj;
  
  func=scm;  
  sys_pro(func);
  env=MC_make_cc();
  syspro--;
  psh(func);
  env=SCONS(env,a_nil);
  psh(env);
  ret=CONS(a_nil,a_nil);
  ATTR(ret)=JMP;
  jj=user_env+jmp_level-1; 
  CAR(ret)=jj;
  CDR(env)=ret;
  env=make_subr(MC_cc_jump,subr_argtype(1,1)|SLAMBDA,env);
  psh(env);  
  scm=funcall(func,1,a_env);
  stack-=3;
  return scm;
}
****/
