/*** package.c ***/
#define PACKAGE_C

#include "lisp.h"

/***  name->hash->(use-list . export-list)  04.5.16   ***/

#define package_name(x)  CAR(x)
#define package_hash(x)  CADR(x)
#define package_use_list(x)  CADDR(x)
#define package_export_list(x)  CDDDR(x)
#define list_export(x)  CDDDR(x)     /*** same above ***/
/*** #define EXPORTP(x)       (ATTR(CDR(x))&EXPORT) ***/
#define SYMBOLHOME(x)    (CDDDR(x))
#define SYMBOLSHADOW(x)    (CADDR(x))
#define HPACKAGE      ATOMVAL(a_package)

static ptr in_keyintern();
static ptr check_use ();
static void import_symbols();

make_prompt(){
  ptr x;
   x=package_name(HPACKAGE);
   PROMPT=str_append(x,prompt); /*** user>  ***/
}

ptr find_package(ptr name)
 {
   Reg ptr x,y;
   /** if(!STRINGP(name)) error(E_notstr,name); **/
   /** name=getstr(name); **/
   x=a_all_packages;
     while(x!=a_nil)
      {
        y=package_name(CAR(x));
           if(equal(name,y)!=a_f)
              return CAR(x);
         x=CDR(x);
      }
    return a_f;
 }

static ptr check_package(ptr s)
{
   if(SREGP(s))
     error (E_notpackage,s);
   if(STRINGP(s))
        s=find_package(s);
   if(PACKAGEP(s))
       return s;
   error (E_notpackage,s);
}

ptr s_find_package(int narg,ptr env)
 {
   return find_package(*(stack-1));
 }

ptr make_package( ptr name)   /*** name is str **/
 {
     ptr find_package();
  Reg ptr x;
   /** name=getstr(name);  ***/
   if(find_package(name)!=a_f)
         error(E_namecrash,name);
     x=CONS(a_nil,a_nil);
     psh(x);
     x=SCONS(make_hash(TWO,65),x);
     x=SCONS(name,x);
     ATTR(x)=APACKAGE;
    pull();
   a_all_packages=SCONS(x,a_all_packages);
   return x;
 }

ptr s_make_package(int narg,ptr env)
 {
  Reg ptr p;
   checknarg(narg-1);
   p=make_package(*(stack-1));   
  return p;
 }

ptr s_packagep(int narg,ptr env)
 {
     checknarg(narg-1);
     return PRED(PACKAGEP(*(stack-1)));
 }

ptr s_package_name(int narg,ptr env)
 {
  Reg ptr s;
     checknarg(narg-1);
   s=*(stack-1);
  if(!PACKAGEP(s))
     error (E_notpackage,s);
   return package_name(s);  
 }

ptr s_rename_package(int narg,ptr env)
 {
  Reg ptr s,new;
     checknarg(narg-2);
   new=*(stack-1);
   s=*(stack-2);
   s=check_package(s);
  if(!STRINGP(new))
     error (E_notstr,new);
   if(find_package(new)!=a_f) error(E_namecrash,new);
    package_name(s)=new;
   make_prompt();
   return s;
 }

ptr s_package_use_list(int narg,ptr env)
 {
  Reg ptr s;
    if(narg==0){
       s=HPACKAGE;
     }
    else if(narg==1)
       s=*(stack-1);
    else
       checknarg(narg-1);
   s=check_package(s);
   return package_use_list(s);
 }

ptr s_list_all_packages(int narg,ptr env)
 {
  Reg ptr s;
     checknarg(narg);
   return a_all_packages;
 }

ptr find_symbol(ptr s,ptr pack){   /***  s is PNAME  **/
  Reg ptr h;
   h=package_hash(pack);
   return gethash(s,h);
}

ptr s_find_symbol(int narg,ptr env)
 {
  Reg ptr s,p,x;
   ptr ss_find_symbol();
     if(narg==1){
       p=HPACKAGE;
       s=*(stack-1);
      }
     else if(narg==2){
       p=*(stack-1);
       s=*(stack-2);
       p=check_package(p);
      }
     else
        checknarg(narg-2);
    if(STRINGP(s))
        return ss_find_symbol(s,p);
    if(SYMBOLP(s)){
        p=ss_find_symbol(PNAME(s),p);
        if(p==s) return p;
        return a_f;
    }
    error(E_notstr,s);
 }

ptr ss_find_symbol(ptr s,ptr p)
 {  
   Reg ptr x; 
    x=find_symbol(s,p);
    if(x!=a_f) return x;
    if(p==ss_package) return a_f;
    return find_symbol(s,ss_package);
 }


static ptr package_used_by_list(ptr p)
{
  Reg ptr all,q,res=a_nil;
   all=a_all_packages;
   while(all!=a_nil){
      q=CAR(all);
      if(q!=p){
          if(memq(p,package_use_list(q))!=a_f)
               res=SCONS(q,res);
       }
     all=CDR(all);
   }
  return res;
}

ptr s_package_used_by_list(int narg,ptr env)
 {
  Reg ptr s;
   if(narg==0)
       s=HPACKAGE;
   else if(narg==1){
      s=*(stack-1);
       s=check_package(s);
    }
   else
       checknarg(narg-1);
   return package_used_by_list(s);
 }

static ptr use_package(ptr s,ptr home)  /** use s in home  **/
{
  Reg ptr p;
       p=package_use_list(home); /*** use-list **/
       if(s==alias_package)
            error(E_access,s);
       if(s==home||s==ss_package) return a_f;
       if(member(s,p)!=a_f) return a_f;
       /** ;;; need check of name-crashes by inherit symbols!!!! ***/
       import_symbols(check_use(s,home),home);
       package_use_list(home)=CONS(s,p);
       return s;
}


ptr s_use_package(int narg,ptr env)
 {
  Reg ptr x,y;
   y=HPACKAGE;
   if(narg==2)
    {
     y=*(stack-1);
     y=check_package(y);
     x=*(stack-2);
    }
   else if(narg==1)
     x=*(stack-1);
   else
       checknarg(narg-2);
     x=check_package(x);
 
   /***  need null check of use-list , comparing package named nill!!!***/
   if(x!=y)
      return use_package(x,y);
   return a_f;
 }

static ptr check_use (ptr s,ptr home)
     /*** s  use-package ***/
 {
   Reg ptr x,y,use,need=a_nil;

    use=list_export(s);
     /** list of inherited external symbols **/
    psh(use);
    while(use!=a_nil)
    { 
     y=CAR(use);
     x=find_symbol(PNAME(y),home);
     if(x==y)
        ;
     else if(x==a_f)
      {
        need=SCONS(y,need);
      }
    else
       error(E_namecrash,x);
     use=CDR(use);
    }
   pull();
  return need;
 } 

static void import_symbols(ptr slist,ptr home){
   /*** slist is checked list of external symbols ***/
  ptr h,x;
   h=package_hash(home);
   while(slist!=a_nil){
      x=CAR(slist); 
      sethash(PNAME(x),h,x);
      slist=CDR(slist);
   }
}

static export_symbol(ptr s,ptr plist){ /*** plist is checked list of use packages ***/
  ptr p;
   while(plist!=a_nil){
      p=CAR(plist);
      sethash(PNAME(s),package_hash(p),s);
      plist=CDR(plist);
   }
}
/***
ptr list_export(ptr pack){
  ptr s,q,res=a_nil,v;
  int n;
    v= get_hash_vector(package_hash(pack));
    get_vector(v,&n);
   while(n--){
     q=vector_ref(v,n);
       while(q!=a_nil)
         {
            s=CDR(CAR(q));
            if(EXPORTP(s))
               res=SCONS(s,res);
            q=CDR(q);
         }  
    }
   return res;
}  
****/

static ptr check_export(ptr s,ptr pack)
{
   Reg ptr p,used,pname,se,res=a_nil;
    used=package_used_by_list(pack);
     pname=PNAME(s);
     while(used!=a_nil){
       p=CAR(used);   
       se=find_symbol(pname,p);
       if(se==a_f)
            res=SCONS(p,res);
       else if(se!=s)
           return a_f;   /*** error name crash  **/
       else
          ;
      used=CDR(used);
    }
    return res;   /***  return list of package to import s **/
}

static ptr export(symbol, pack)
  Reg ptr symbol,pack;
 {
  Reg ptr name,s,expl;
      if(pack== ss_package) {
        lwritestr(STDERR,"can't export   ss:  symbols!\n");
        error(E_access,pack);
      }
      name=PNAME(symbol);
      s=find_symbol( name, pack);
      if(s!= symbol) error(E_access,symbol);
      expl=list_export(pack);
     if(memq(s,expl)!=a_f) return a_t;
     s=check_export(s,pack);
     if(s==a_f) 
         error(E_namecrash,symbol);
     list_export(pack)=CONS(symbol,expl);
     export_symbol(symbol,s);
     return a_t;
 }

static ptr export_aux(ptr x,ptr pack){
   Reg ptr y;
       if(SREGP(x)) error(E_notsymb,x);    
       if(SYMBOLP(x)){
           return export(x,pack);
       }
       else if(STRINGP(x)){
          y=find_symbol(x,pack);
          if(y== a_f) error(E_access,x);
          return export(y,pack);
       }
       else  if(CONSP(x)){
         while(x!=a_nil)
         {
            y=CAR(x);
           if(SREGP(y)||CONSP(y))
                error(E_notsymb,y);   
            export_aux(y,pack);
            x=CDR(x);
          }
          return a_t;
       }
       else
          error(E_notsymb,x);
}
  
/***  (export  symbol-or-string-or list-of-symbols  [pack])  ***/
ptr s_export(int narg,ptr env)
 {
   Reg ptr x,pack,y;
   if(narg==1){  /*** string or symbol or list of symbols **/
       pack=HPACKAGE;
       x=*(stack-1);
     }
   else if(narg==2){
      pack=check_package(*(stack-1));
       x=*(stack-2);
   }
   else
      checknarg(narg-2);
   return export_aux(x,pack);
 }

ptr s_exportp(int narg,ptr env)
 {
    ptr x,expl,pack;
     if(narg==1){  
       pack=HPACKAGE;
       x=*(stack-1);
     }
   else if(narg==2){
      pack=check_package(*(stack-1));
       x=*(stack-2);
   }
   else
      checknarg(narg-2);
      expl=list_export(pack);
   return memq(x,expl);
}

static ptr unexport(ptr symbol,ptr  pack,int rec_flag)
 {
  Reg ptr name,s,expl,used;
      if(pack== ss_package) {
        if(rec_flag) return a_f;
        lwritestr(STDERR,"can't unexport   ss:  symbols!\n");
        error(E_access,pack);
      }
      name=PNAME(symbol);
      s=find_symbol( name, pack);
      if(s!= symbol){
        if(rec_flag) return a_f;
        error(E_access,symbol);
      }
      expl=list_export(pack);
     if(memq(s,expl)==a_f) return a_f;
     list_export(pack)=ssremove(s,expl);
     used=package_used_by_list(pack);
     while(CONSP(used))
      {
       pack=CAR(used);
       if(rec_flag) unexport(symbol,pack,rec_flag);
       s=find_symbol(name,pack);
       if(s==symbol)
            remhash(name,package_hash(pack));
       else{
          SYMBOLSHADOW(s)=a_nil;
        }
       used=CDR(used);
      }
     return a_t;
 }


static ptr unexport_aux(ptr x,ptr pack,int rec_flag){
   Reg ptr y;
       if(SREGP(x)) error(E_notsymb,x);
       if(SYMBOLP(x)){
           return unexport(x,pack,rec_flag);
       }
       else if(STRINGP(x)){
          y=find_symbol(x,pack);
          if(y== a_f) error(E_access,x);
          return unexport(y,pack,rec_flag);
       }
       else  if(CONSP(x)){
         while(x!=a_nil)
         { 
            y=CAR(x);
           if(SREGP(y)||CONSP(y))
                error(E_notsymb,y);
            unexport_aux(y,pack,rec_flag);
            x=CDR(x);
          }
          return a_t;
       }
       else
          error(E_notsymb,x);
}

ptr s_unexport(int narg,ptr env)
 {
   Reg ptr x,pack,y;
   if(narg==1){  /*** string or symbol or list of symbols **/
       pack=HPACKAGE;
       x=*(stack-1);
     }
   else if(narg==2){
      pack=check_package(*(stack-1));
       x=*(stack-2);
   }
   else
      checknarg(narg-2);
   return unexport_aux(x,pack,NO);
 }

ptr s_unexport_rec(int narg,ptr env)
 {
   Reg ptr x,pack,y;
   if(narg==1){  /*** string or symbol or list of symbols **/
       pack=HPACKAGE;
       x=*(stack-1);
     }
   else if(narg==2){
      pack=check_package(*(stack-1));
       x=*(stack-2);
   }
   else
      checknarg(narg-2);
   return unexport_aux(x,pack,YES);
 }


ptr s_externalp(int narg,ptr env)
 {
   Reg ptr x,pack,y;
   if(narg==1){
       pack=HPACKAGE;
       x=*(stack-1);
     }
   else if(narg==2){
       pack=*(stack-1);
       x=*(stack-2);
       pack=check_package(pack);
     }
   else
      checknarg(narg-2);
   if(SREGP(x)) error(E_notsymb,x);
   if(STRINGP(x)){
       x=ss_find_symbol(x,pack);
       if(x==a_f) return x;
   }
   if(!SYMBOLP(x))
         error(E_notsymb,x);
    y=ss_find_symbol(PNAME(x),pack);
    if((y==a_f)||(x!=y)) return a_f;
    x=SYMBOLHOME(x);
    return PRED(x!=pack);
}

ptr s_symbol_home(int narg,ptr env)
 {
   Reg ptr x;
      checknarg(narg-1);
     x=*(stack-1);
   if(!SYMBOLP(x))
         error(E_notsymb,x);
   return SYMBOLHOME(x);
}


ptr s_find_export_symbols(int narg,ptr env)
 {
   Reg ptr pack;
      checknarg(narg-1);
       pack=*(stack-1);
       pack=check_package(pack);
     return list_export(pack);
  }

/*** intern  ***/
static ptr p_intern(name,pack,val)
  Reg ptr name,pack,val;
 {
  Reg ptr x,pname;
   x=find_symbol(name ,pack);
  /*** printf("p_intern  find %x\n",x);  ***/
   if(x==a_f)
     {
       return in_intern(name,pack,val);
     }
   return x;
  }

ptr k_intern(name,pack,val)
  Reg ptr name,pack,val;
 {
  Reg ptr x,pname;
   x=find_symbol(name ,pack);
  /*** printf("p_intern  find %x\n",x);  ***/
   if(x==a_f)
     {
       return in_keyintern(name,pack);
     }
   return x;
  }


ptr in_intern(name,pack,value)
  Reg ptr name,pack,value;
 {
  Reg ptr x=a_nil,pname;
  int n;
  /***  Ūintern  ***/
  /***
   printf("in_intern  enter name %x pack %x\n",get_string(name,&n),pack);
  ***/
       x=SCONS(x,pack);
       x=SCONS(name,x);
       x=SCONS(value,x);
       ATTR(x)=SYMBOL;
        psh(x);
        sethash (name ,package_hash(pack), x);
       pull(); 
   return x;
 }

static ptr in_keyintern(name,pack)
  Reg ptr name,pack;
 {
  Reg ptr x=a_nil,pname;
 /**  printf("in_intern  enter name %x pack %x\n",name,pack); ***/
       x=SCONS(name,x);
       x=SCONS(x,x);
       ATTR(x)=KEYWORD;
       CAR(x)=x;
       psh(x);
        sethash (name ,package_hash(pack), x);
      pull(); 
   return x;
 }


ptr s_intern(int narg,ptr env)
 {
  Reg ptr x,pack;
   if(narg==1){
       pack=HPACKAGE;
       x=*(stack-1);
     }
   else if(narg==2){
       pack=*(stack-1);
       x=*(stack-2);
       pack=check_package(pack);
     }
   else
      checknarg(narg-2);
   if(SREGP(x)) error(E_notstr,x);
   else if(STRINGP(x))
      return p_intern(x,pack,a_unbdd);
   else
      error(E_notstr,x);
 }

ptr s_shadow_intern(int narg,ptr env)
 {
  Reg ptr x,pack,y;
   if(narg==1){
       pack=HPACKAGE;
       x=*(stack-1);
     }
   else if(narg==2){
       pack=*(stack-1);
       x=*(stack-2);
       pack=check_package(pack);
     }
   else
      checknarg(narg-2);
   if(SREGP(x)) error(E_notstr,x);
   else if(STRINGP(x)){
      y=find_symbol(x,pack);
      if(y!=a_f){
           if(SYMBOLHOME(y)==pack)
               return y;
           /*** p_unintern(x,pack); ***/
           x=in_intern(x,pack,ATOMVAL(y));
           SYMBOLSHADOW(x)=y;
           return x;
       }
      y=find_symbol(x,ss_package);
      if(y==a_f) 
          return in_intern(x,pack,a_unbdd);
        x=in_intern(x,pack,ATOMVAL(y));
       SYMBOLSHADOW(x)=y;
       return x;
    }
   else
      error(E_notstr,x);
 }



static ptr p_unintern(name,pack)
  Reg ptr name,pack;
 {
  Reg ptr x,pname,y,hash;
   x=find_symbol(name ,pack);
   if(x==a_f) return a_t;

   hash=package_hash(pack);
   remhash(name,hash);
   if((y=SYMBOLSHADOW(x))!=a_nil)
      /*** if(memq(SYMBOLHOME(y),package_use_list(pack))!=a_f) ***/
         sethash(PNAME(y),hash,y);
   /*** prin1(SYMBOLHOME(x),STDOUT); ***/
   if(SYMBOLHOME(x)==pack){
       SYMBOLHOME(x)=a_f;  /*** Caution for write!!!  ***/
   }
   return x; /*** x exists in other package ***/     
 }  
 
ptr s_unintern(int narg,ptr env)
 {
  Reg ptr x,pack;
   if(narg==1){
       pack=HPACKAGE;
       x=*(stack-1);
     }
   else if(narg==2){
       pack=*(stack-1);
       x=*(stack-2);
       pack=check_package(pack);
     }
   else
      checknarg(narg-2);
   if(SREGP(x)) error(E_notstr,x);
   else if(STRINGP(x))
      return p_unintern(x,pack);
   else if(SYMBOLP(x))
      return p_unintern(PNAME(x),pack);
   else
      error(E_notstr,x);
 }

/***/
static ptr unuse_package(ptr s,ptr home)
{  
  Reg ptr p,ex,h,x,y,name;
       p=package_use_list(home); /*** use-list **/
       if(s==home||s==alias_package||s==ss_package)
            error(E_access,s);
       if(member(s,p)==a_f) return a_f;
        ex= list_export(s);
         h=package_hash(home);
       psh(ex);
       while(ex!=a_nil){
         x=CAR(ex);
         name=PNAME(x);
         y=gethash(name,h);
         if(y==x)
             remhash(name,h);
         else
            SYMBOLSHADOW(y)=a_nil;
         ex=CDR(ex);
       }
      pull();
     package_use_list(home)=ssremove(s,p);
    return s;
}  
   
 
ptr s_unuse_package(int narg,ptr env)
 {
  Reg ptr x,y;
   y=HPACKAGE;
   if(narg==2)
    {
     y=*(stack-1);
     x=*(stack-2);
      y=check_package(y);
    }
   else if(narg==1)
     x=*(stack-1);
   else
       checknarg(narg-2);
    x=check_package(x);

   /***  need null check of use-list , comparing package named nill!!!***/
   if(x!=y)
      return unuse_package(x,y);
   error(E_access,x);
 }

ptr s_map_package(int narg,ptr env)
 {
  Reg ptr x,y;
   y=HPACKAGE;
   if(narg==2)
    {
     y=*(stack-1);
     x=*(stack-2);
     y=check_package(y);
    }
   else if(narg==1)
     x=*(stack-1);
   else
       checknarg(narg-2);
   if(!CLOSUREP(x)) error(E_nullfunc,x);   /*** (lambda(symbol) ...)   **/
   psh(x);
   psh(package_hash(y));
   s_mapcdrhash(2,a_nil);
   sp_pull(2);
    return a_undef; 
 }

