/****  
   tail_m.c
   2003.12.18 created

   based on tail-m.ss
***/
#define  TAIL_M_C 

#include "lisp.h"
extern ptr get_value();

ptr let_expand();
static ptr TB_expand(),tc_expand(),if_expand(),begin_expand(), let_def_reduce();
static ptr macro_expand_2();

ptr tail_expand(ptr lam){  /*** lam=(lambda .....)   ***/
 ptr f,res,tmp;
  tmp=res=CONS(CAR(lam),a_nil);
  psh(tmp);
  lam=CDR(lam);
  tmp=CDR(tmp)=CONS(CAR(lam),a_nil);
  lam=CDR(lam);
  while(CONSP(lam)){
    f=macro_expand_2(CAR(lam));
    lam=CDR(lam);
    if(lam==a_nil){
      psh(f);
      f=tc_expand(f);
      pull();
    }
    tmp=CDR(tmp)=SCONS(f,a_nil);
  }
  pull();
  return res;
}

static ptr macro_expand_2(ptr f){
 ptr g,top;
 if(SREGP(f)) return f;
 if(!CONSP(f)) return f;
  top=CAR(f);
  if(!SREGP(top)&&SYMBOLP(top)){
    g=get_value(top);  /*** comp.c  ***/
    if(!SREGP(g)&&CLOSUREP(g)&&((int)FTYPE(g)&MACRO)){
       g=C_macro_expand(f);
       if(f!=g){
        psh(g);
         g=macro_expand_2(g);
        pull();
      }
     return g;
    }
 }
 return f;
}

static ptr function_call_p(ptr f){
  ptr top,x;
  int n;
   if(SREGP(f)) return a_f;
   if(!CONSP(f)) return a_f;
   top=CAR(f);
   if(SREGP(top)) return a_f;
   if(SYMBOLP(top)){
     x=get_value(top);
      n=get_ftype(x);
     if(n&MACRO) return a_f;
     if(n&SPECIAL) return a_f; /***  to be modify!!!!  ***/
    return a_t;
  }
  if(CONSP(top)) return a_t;  /*** ((lambda ...) ),((eval ...)  )   ***/
  return a_f;
}

static ptr tc_expand(ptr f){
  ptr top,res;
  if(SREGP(f)) return f;
   if(!CONSP(f)) return f;
   f=macro_expand_2(f);
   psh(f);
   /***
   if(CONSP(f)) 
          top=CAR(f);
   else
          top=a_undef;
    ***/
#ifdef DEBUG
   lwritestr(STDOUT,"tc_expand f: ");
  prin1(f,STDOUT);
    newline(STDOUT);
#endif

  if(CONSP(f))
          top=specialp(CAR(f));
   else
          top=a_undef;

  if(function_call_p(f)!=a_f){
     res=SCONS(a_tail_call,f);
  }
  else if(top==a_let||top==a_let_s||top==a_letrec){
   res=let_expand(f,YES);
   }
  else if(top==a_if)
     res= if_expand(f);
  else if(top==a_begin)
    res= begin_expand(f);
   else
      res= f;
   pull();
   return res;
}

static ptr if_expand(ptr f){
 ptr x,g;
  f=CDR(f);
  if(CDDR(f)==a_nil){
     x=tc_expand(CADR( f));
     psh(x);
     x=list3(a_if,CAR(f),x);
     pull();
     return x;
   }
  g=CDR(f);
  if(CDDR(g)==a_nil){
     x=tc_expand(CADR( g));
     psh(x);
     g=tc_expand(CAR( g));
     psh(g);
     g=list3(CAR(f),g,x);
     g=SCONS(a_if,g);
     stack-=2;
     return g;
  }
  error(E_argover,f);
}

static ptr begin_expand(ptr f){
   return tail_expand(f);
}

ptr let_expand(ptr f,int tail_f){
  ptr x,def;
  x=TB_expand(CDDR(f),tail_f);
  psh(x);
  def=let_def_reduce(CADR(f),CAR(x));
  psh(def);
  x=append(def,CDR(x));
  x=SCONS(CADR(f),x);
  x=SCONS(CAR(f),x);
  stack-=2;
  return x;
}

static ptr let_def_reduce(ptr letb,ptr def){
  ptr x,res,tmp,var;   
   tmp=res=CONS(a_nil,a_nil);
   psh(tmp);
   psh(tmp);
   def=CDR(def);
  while(CONSP(def)){
    x=CAR(def); 
    var=CADR(x);
   if(assq(var,letb)!=a_f){
       x=SCONS(var,CDDR(x));
       x=SCONS(a_setq,x);
     }
   else{  /*** New!! ***/
     *(stack-1)=letb=SCONS(CDR(x),letb);
   }
   tmp=CDR(tmp)=SCONS(x,a_nil);
   def=CDR(def);
  }
  stack-=2;
  return CDR(res);
}

static ptr TB_expand(ptr f,int tail_f){
 ptr x,top,tmp,res,TB_def;
 int def;
/***
   printf("TB_expand \n");
   prin1(f,STDOUT);
   getchar();
***/
   def=1;
   TB_def=a_nil;
   tmp=res=CONS(a_nil,a_nil);
   psh(tmp);
   psh(tmp);
   psh(tmp);
   psh(tmp);
  while(CONSP(f)){
    *(stack-1)=x=macro_expand_2(CAR(f));
#ifdef DEBUG
   lwritestr(STDOUT,"TB_expand x: ");
  prin1(x,STDOUT);
    newline(STDOUT);
#endif

    f=CDR(f);
    if(!SREGP(x)&&CONSP(x)){   /*** bug fix 04.4.23  **/
       /** top=CAR(x);***/
       top=specialp(CAR(x));
       if(def&&((top==a_define)||(top==a_setq))){
           *(stack-2)=TB_def=SCONS(x,TB_def);
        }
       else{
         if(top==a_begin)
               *(stack-3)=f=append(CDR(x),f);
         else{
           if(top==a_define) error(E_define,x);
            def=0;
            if(tail_f&&(f==a_nil))
               x=tc_expand(x);
            tmp=CDR(tmp)=SCONS(x,a_nil);
         }
      }
    }
   else{
    def=0;
    tmp=CDR(tmp)=SCONS(x,a_nil);
   }
 }
  res=CDR(res);
  *(stack-2)=TB_def=reverse_list(TB_def);
   /**** res=append(TB_def,res);  **  to be modify????  ***/
    TB_def=SCONS(a_define,TB_def);
    res=SCONS(TB_def,res);
  stack-=4;
  /***
   printf("TB_expand  end\n");
   prin1(res,STDOUT);
   getchar();
   ***/
  return res;
}
   
  
 
