/*****   glob_ss.c
    04.6.20   ****/
/*****  05.3.26  for WIn, FBSD  ****/

/***
#ifdef WIN32
#define GLOB_ONLYDIR   (1<<13)   **  toriaezu, no effect!**
#endif
***/
#define  GLOB_PROG

#include "lisp.h"
#include <glob.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#ifndef  GLOB_ONLYDIR
#define  GLOB_ONLYDIR  -1
#endif

#ifndef  GLOB_TILDE
#define    GLOB_TILDE  0  
#endif

extern ptr make_str_c();
extern int get_file_mode();

static char allf[]="*";

ptr glob_files(char *pat,ptr prev,int flag)
{
  ptr res,file;
  glob_t globfile;
  char **p;
  int n,glob_dir,gflag=0;
   /*** return prev;     for debug   ***/
     if(flag==GLOB_ONLYDIR){
         glob_dir=1;   /** for win, fbsd  ***/
     }
    else
       glob_dir=0;
    /***  glob all  ***/
   n=glob(pat,GLOB_TILDE,0,&globfile); /***  ~/.  -> /home/sato/.  ***/
 /*** printf("*** Glob addr %x\n",globfile);  ***/
   /***  cygwin  n=0 errno =0  for no match ,  need  check gl_matchc  ***/
#ifdef __WIN32__
   if(n||(globfile.gl_matchc==0)) {
#else
   if(n){
#endif
      /***  printf("glob No match! glob_dir %d\n",glob_dir);   debug **/
       globfree(&globfile);  /***  need?  **/
      return prev;
   }
   /*** printf("glob debug  n %d errno %d globfile %x \n",n,errno,globfile); *  debug **/
  res=CONS(a_nil,a_nil);
  psh(res);
  p=globfile.gl_pathv;
  while(*p){
    /** printf("%s\n",*p++); ***/
    file=1;
    if(flag){
       n=get_file_mode(*p);
       if(flag==GLOB_MARK){
         /*** if(is_directory(*p)) file=0;
            if(is_slink(*p)) file=1;
           ***/
        if((n&S_IFMT)==S_IFDIR) file=0;
        }
       else if(glob_dir){
         /*** file=is_directory(*p); ***/
         file=((n&S_IFMT)==S_IFDIR);
       }
    }
    if(file)
        res=CDR(res)=SCONS(make_str_c(*p),a_nil);
    p++;
  }
  globfree(&globfile);  
/***  printf("glob addr %x\n",globfile);  ***/
 CDR(res)=prev;
 res=*(stack-1);
 pull();
 return CDR(res);
}

ptr s_glob(int narg,ptr env){
  ptr res=a_nil,s,*p=stack;
  int size;
 if(narg==0){
    return  glob_files(allf,res,0);
  }
  psh(res);
  while(narg--){
    s=*--p;
    if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
    *(stack-1)=res=glob_files(get_string(s,&size),res,0);
  }
  return *pull();
}

ptr s_glob_dir(int narg,ptr env){
  ptr res=a_nil,s,*p=stack;
  int size;
 if(narg==0) {
    return glob_files(allf,res,GLOB_ONLYDIR);
  }
  psh(res);
  while(narg--){
    s=*--p;
    if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
    *(stack-1)=res=glob_files(get_string(s,&size),res,GLOB_ONLYDIR);
  }
  return *pull();
}

ptr s_glob_file(int narg,ptr env){
  ptr res=a_nil,s,*p=stack;
  int size;
 if(narg==0) {
    return  glob_files(allf,res,GLOB_MARK);
  }
  psh(res);
  while(narg--){
    s=*--p;
    if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
    *(stack-1)=res=glob_files(get_string(s,&size),res,GLOB_MARK);
  }
  return *pull();
}

extern ptr s_is_slink();

ptr s_glob_slink(int narg,ptr env){
  ptr all,res=a_nil,s;
  all=s_glob(narg,env);
  psh(all);
  psh(all);
  psh(all);
  while(all!=a_nil){
    *(stack-1)=s=CAR(all);
    if(s_is_slink(1,a_nil)!=a_f)
       *(stack-2)=res=SCONS(s,res);
    all=CDR(all);
  }
  sp_pull(3);
  return res;
}

