/***   write.c
***/
#define WRITE_C

#include "lisp.h"
#include <stdio.h>
/****  Circle print version 03.9.6   ***/
/****  stream version   03.9.9  ***/

#define prin_s(p)   lwritestr(lpath,p)
#define format(p,obj)   sprintf(iobuff,p,obj)
#define WRITE         lwritestr(lpath,iobuff)

#define HPACKAGE      ATOMVAL(a_package)
#define package_name(x)  CAR(x)

extern ptr lfflush(),list_print(),prin_circle();   
extern char *info_hostip();
extern int info_portnumber();
static void princstr(),prin_str(),prin_symbol();
ptr print();

/*** 04.5.3  see below ***/
/*** 07.9.24  revised for  1e-05  **/
right_space_off(char *p){
   char c,*q;
   q=NULL;
   while(c=*p){
     if(q==NULL)
       if(c==' ') q=p;
     else
        if(c!=' ') q=NULL;
     p++;
  }
  /***  q is the top of space continue to the end of string.  ***/
  if(q)  *q=0;
}
    
   
      

cstr_right(char *p){
  char c,d;
  c=*p;
 while(c){
   d=*++p;
   *p=c;
   c=d;
}
 *++p=c;
}

void force_float(char *p){
  int c,n=0,k=-1;
  char *q=p;
  while(c=*p++){
    if(c=='.') {
        k=n;
        break;
    }
    n++;
  }
  if(n==0) return;
  if(k>=0){
      /*** case  dot .  exists ***/
        /***  %-11.8g add space ***/
     while(c=*q++){
      if(c==' '){
          *(q-1)=0;
          return;
       }
    }
     return;
   }
  if(*q=='+'||*q=='-') q++;
  while(isdigit(*q)) q++;
  /*** exists case 1e-5  **/
  cstr_right(q);
  cstr_right(q);
  *q++='.';
  *q++='0';
  /** *q=0;  **/
  right_space_off(q);
} 


ptr prin1(ptr q,ptr lpath){
 print_base=SINT_NUMB(ATOMVAL(print_radix));
 print(q,lpath,YES);
   /*** lfflush(lpath); ***/ 
  return a_undef;
}
ptr princ(ptr q,ptr lpath){  /*** display ***/
 print_base=SINT_NUMB(ATOMVAL(print_radix));
 print(q,lpath,NO);
   /*** lfflush(lpath); ***/ 
  return a_undef;
}

void  pr_INT(ptr lpath,ptr p,int radix){
 char *pp;
    /*** printf("pr_INT %d\n",radix); ***/
 if(SINTP(p)){
   if(radix==10){
         format("%d",(int)SINT_NUMB(p));
       WRITE;
       return;
    }
   p=bignum(SINT_NUMB(p));
 }
 if(BIGINTP(p)){
     psh(p);
     pp=mpz_get_str(0,radix,BIGNUM(p));
          lwritestr(lpath,pp);
          Myfree(pp);
     pull();
    }
 else{  /** RATIO **/
      psh(p);
       pp=mpq_get_str(0,radix,RATIONAL(p));
          lwritestr(lpath,pp);
          Myfree(pp);
      pull();
 }
}

/*** for debug etc  ***/
void pr_INTEGER(ptr lpath,int x,int radix){
 ptr p;
   p=number2str(bignum(x),radix);
  psh(p);
  print(p,STDOUT,NO);
  pull();
}


ptr print(Reg ptr q,Reg ptr lpath,Reg int wflag) /*** wflag NO=display ***/
{   
  ptr memo;
  int n,m;
  char *pp;
  if(q==0) {
      return  prin_s("<#NULL---system---abnormal!!!>");
  }
  if(q==NIL) return  prin_s("()");
  if(q==a_undef) return  prin_s("<#undef#>");
  if(q==a_unbdd) return  prin_s("<#unbdd#>");  /***  to be error  Never occur for user!  ***/
  if(SINTP(q)){
       pr_INT(lpath,q,print_base);
       /***
       format("%d",(int)SINT_NUMB(q));
       WRITE;
       ***/
       goto out;
     }
  if(CHARP(q)){
          w_char(q,lpath,wflag);
      goto out;
      }
    n=TYPE(q);
    /*** for debug ***/
     if(n&TKOBJ){
        /*** prin_s("write TK-OBJ\n"); ***/
       if(CADR(q))
          format("<#TKLINK %s#>",CADR(q));
       else
          format("<#TKLINK %s#>","");
       WRITE;
       goto out;
      }
         
  if(n&NUMBER){
      if(n&BIGINT){
         /** n=gmp_asprintf(&pp,"%Zd",BIGNUM(q));**/
          /*** printf("bigint print size %d\n",n);
          printf("direct bigint print  %s\n",pp);
            ***/
       pr_INT(lpath,q,print_base);
           goto out;
        }
       else if(n&RATIO){
       pr_INT(lpath,q,print_base);
           goto out;
        }
      else if(n&DOUBLE){
           format("%-11.8g",FLONUM(q));
           /*** printf("format %s\n",iobuff);  ***/
           force_float(iobuff);
           /***  04.5.2  No good 2.0  ->  2 
               because  OGL needs  float number Not integer! 
               and compiler ouput will be 2 Not 2.0, this may cause some error!!!
          ***/
           WRITE;
           goto out;
       }
      else if(n&COMPLEX){
           /** prin_s("#c("); **/
          if(CAR(q)!=ZERO)
              print(CAR(q),lpath,wflag);
          q=CDR(q);
          if(gen_eq(q,ZERO)) goto out; /*** 04.1.2  **/
           if(gsign(q))
               lwritec(lpath,'-');
           else
               lwritec(lpath,'+');
           lwritec(lpath,'i');
           psh(q=ABS(q));
           if(q!=ONE)
                print(q,lpath,wflag);
           pull();
               /** lwritec(lpath,')'); **/
          goto out;
       }
       goto err;
    }
  else if(n&STRING)
   {
    if(wflag) lwritec(lpath,'\"');
    if(wflag) prin_str(q,lpath);
    else
       princstr(q,lpath);
    if(wflag) lwritec(lpath,'\"');
   }
  else if((n&SYMBOL)||(n&KEYWORD)){
    if(wflag) 
        prin_symbol(q,lpath,n&KEYWORD);
    else
        princstr(PNAME(q),lpath);
    }
  else if(n==BOOLEAN)
   {
      if(q==a_t) prin_s("#t");
       else
           prin_s("#f");

   }
 else if(n==CELL)
    {
      return list_print(q,lpath,wflag);
    }
    else if(n&VECTOR)
   {
    w_vector(q,lpath,wflag);
    }
     else if(n&MATRIX)
   {
    w_matrix(q,lpath,wflag);
    }    

  else if(n&CLOSURE)
   {
      if(n&EXTEND)
           w_sr2(n,q,lpath);
      else
           w_closure(n,q,lpath);
    }
  else if(n==CWC)
   {
     w_cwc(q,lpath);
   }
  else if (n==JMP)
   {
     w_jmp(q,lpath);
   }
   else if (n==STREAM)
   {
     w_stream(q,lpath,wflag);
   }
   else if (n&MULTI)
   {
     w_multi(q,lpath,wflag);
   }
   else if (n&MALLOC)
  {
     w_malloc(q,lpath,n&MALLOC_BIN);
  }
   else if (n&SSPACKAGE){
       w_package(q,lpath);
  }
  else if (n&HASH){
       w_hash(q,lpath);
  }
   else if (n&EXTEND){
           w_extend(q,lpath,wflag);
  }
  else if (n&NETSOCKET){
      w_netsocket(q,lpath,wflag);
  }
  else if (n&SUBRADD){
      w_subradd(q,lpath);
  }
  else
  {
   err:
   printf("unprintable obj %x attr %x\n",q,n);
   printf("nil %x undef %x\n",a_nil,a_undef);
    return error( E_unprint,q);
   }
 out:
 return a_undef;
}
/**
princstr(ptr q,ptr lpath)
 {
   int n;
   unsigned char *p,c;
   p=(char *)get_string(q,&n);
   q=alloc_str(p,n);
    psh(q);
   p=CAR(q);   *** Caution alloc adress **
   while(n--){
      c=*p++;
      lwritec(lpath,c);
   }
   pull();
   free_alloc_cell(q);
  }
***/

static void princstr(ptr q,ptr lpath)
 {
   int n;
   unsigned char *p,c;
   p=(char *)get_string(q,&n);
   while(n--){
      c=*p++;
      lwritec(lpath,c);
   }
}

/***
prin_str(ptr q,ptr lpath)
 {
   int n;
   unsigned char *p,c;

   p=(char *)get_string(q,&n);
   q=alloc_str(p,n);
   psh(q);
   p=CAR(q);   *** Caution alloc adress ** 
   while(n--){
      c=*p++;
      if(c=='\"')
          lwritec(lpath,'\\');
      lwritec(lpath,c);
   }
   pull();
   free_alloc_cell(q);
  }
***/

static void prin_str(ptr q,ptr lpath)
 {
   int n;
   unsigned char *p,c;

   p=(char *)get_string(q,&n);
   while(n--){
      c=*p++;
      if((c=='\"')||(c=='\\'))   /*** 2004.10.22 **/
          lwritec(lpath,'\\');
      lwritec(lpath,c);
   }
}


static void prin_symbol(ptr q,ptr lpath,int key)
 {  
   int n,m,esc=0;
   unsigned char *p,*r,c;
   ptr pk,sym;
   /*** package ***/
    sym=q;
    q=PNAME(q);
    if(key)
       pk=sym;
    else
       pk=ss_find_symbol(q,HPACKAGE);
    /*** printf("pk %x HPACKAGE %x\n",pk,HPACKAGE); ***/
     
   if(sym==a_dot) esc=1;
   r=p=(char *)get_string(q,&n);
   m=n;
  
   while(m--){
      c=*r++;
      if(c==' '||c=='#'||c==39||((c>=91)&&(c<=93))||c==96||c>=123){
          esc=1;
          break;
       }
   }
   if(esc)
      lwritec(lpath,'|');
   if(pk!=sym){
      pk=CDDDR(sym);  /*** symbol 's original package **/
      /** if(pk!=ss_package){   * maybe ss:symbol is shadowed ***/
      /***  need print ss: if it is shadowed! ***/
        if(pk!=a_f)
           pk=package_name(pk);
        else
           pk=a_none;  /*** ghost symbol ***/
         princstr(pk,lpath);
         lwritec(lpath,':');
      /*** }  ***/
    }
   while(n--){
      c=*p++;
      if(esc&&(c=='|'))
         lwritec(lpath,'\\');
      lwritec(lpath,c);
   }     
   if(esc)
      lwritec(lpath,'|');
  }



w_closure(int m,Reg ptr q,ptr lpath){
  ptr memo=q;
  int n;
      if(CIRCLEP(q)){
          return prin_circle(q,lpath);
       }
      SETCIRCLE(q);
     n=FTYPE(q);
     if(m&LAMBDA){
         if(n&TKFUNC)
              prin_s("#[TK ");
         else if(m&SUBR){
              if(n&ALLOC)
                 prin_s("#[closure user ");
              else
                 prin_s("#[closure system ");
          }
          else
              prin_s("#[closure ");
       }
     else if(m&SPECIAL)
          prin_s("#[special ");
     else if(m&MACRO){
          if(m&SUBR)
              prin_s("#[macro system ");
          else
              prin_s("#[macro ");
        }
       n&=0xffff;
     n=GETNUM(n);
     m=n&1;
     n>>=1;
     prin1(MAKESINT(n),lpath);
          lwritec(lpath,' ');
     prin1(MAKESINT(m),lpath);
          lwritec(lpath,' ');

      /*** prin1(CAR(q),lpath); ***/
      q=CDR(q);
      if(SUBRADDP(q)){        /*** ver 1.7   ***/
          w_subradd(q,lpath);
       }
      else
       {
         prin1(CDR(q),lpath); /*** body ****/
             /**** env  this may be includes self,
                       because   env is included in closure **/ 
       }
         prin1(CAR(q),lpath);  /*** recursive list , check ***/ 
            lwritec(lpath,']');
     CLRCIRCLE(memo);
}

w_subradd(ptr q,ptr lpath){
     prin_s("#[subraddress ");
     format("%8x",CDR(q));/***   address print ***/
           WRITE;
          lwritec(lpath,']');
}


ptr write_cc(ptr x,ptr lpath){

if(!CWCP(x))  return error(E_cwc,x);
return a_undef;  /***  debug  ***/
/***
  write_cc_sub(CAR(x),lpath); ** MPU 
x=CDR(x);
 prin1(x,lpath);  ** stack  etc.  ***
****/ 
  /** lwritec(lpath,']');  ***/
}

/***
write_cc_sub(ptr x,ptr lpath){
 ptr *p,s;
 int n;
extern char *m_obj_str;
 prin_s(" ( ");
    p=get_vector(x,&n);
  while(n--){
   if(s=m_obj(*p++)){
        prin1(s,lpath);
       lwritec(lpath,' ');
        }
   else{
    format("%s ",m_obj_str);
    WRITE;
   }

  }
  lwritec(lpath,')');
}
****/


w_cwc(Reg ptr q,ptr lpath){
      if(CIRCLEP(q)){
          return prin_circle(q,lpath);
       }
      SETCIRCLE(q);
         prin_s("#[cc ");
     /*** prin1(CDR(CDR(q)));  env **/
       write_cc(q,lpath);
         prin_s("] "); /***  **/
        CLRCIRCLE(q);
}

w_malloc(Reg ptr q,ptr lpath,int bin){
       if(bin)
         prin_s("#[alloc-bin ");
        else
         prin_s("#[alloc ");
     sprintf(iobuff," %x . %x",CAR(q),CDR(q));
       WRITE;
         prin_s("] "); /***  **/
}

w_jmp(Reg ptr q,ptr lpath){
      if(CIRCLEP(q)){
          return prin_circle(q,lpath);
       }
      SETCIRCLE(q);
         prin_s("#[jmp ");
     /*** prin1(CDR(CDR(q)));  env **/
       format(" %x ",CAR(q));
       WRITE;
       /**
       w_cwc(CDR(q),lpath);
         **/
         prin_s("] "); /***  **/
      CLRCIRCLE(q);
}



w_jmp_org(Reg ptr q,ptr lpath){
      if(CIRCLEP(q)){
          return prin_circle(q,lpath);
       }
      SETCIRCLE(q);
         prin_s("#[jmp ");
     /*** prin1(CDR(CDR(q)));  env **/
       format("jmp_buf %x ",CAR(q));
       WRITE;
       w_cwc(CDR(q),lpath);
         prin_s("] "); /***  **/
      CLRCIRCLE(q);
}

static char charw[8]={'#','\\'};

set_charw(int n){
 char *p=charw+2;
  if(n&0xff0000)  /**  utf-8 ***/{
        *p++=n>>16;       
        *p++=n>>8;
}
  else if(n&0xff00)  /**  euc ***/
        *p++=n>>8;
  *p++=n;
  *p=0;
}

w_char(Reg ptr q, ptr lpath,int flag){
  Reg int n,m;
    if(q==SEOF){
       prin_s("<#eof-obj#>");
       return;
     }
   n= CHAR_CODE(q);
   set_charw(n);
      /***  printf("prin1 char %x char_code %x\n",q,n);  ***/
  if(flag){
        q=rassq(q,CAR(a_name_char));
        if(q!=a_f){
            prin_s("#\\");
            princstr(CAR(q),lpath);
        }
       else{
              prin_s(charw);
            }
   }
   else{
          prin_s(charw+2);
   }
}

void newline(ptr lpath){
  lwritec(lpath,'\n');
}

w_vector(ptr q,ptr lpath,int wflag){
Reg ptr *p;
int n;
 p=get_vector(q,&n);
 /** printf("vect q %x p %x n=%d\n",q,p,n); **/
  prin_s("#(");
  while(n--){
    print(*p++,lpath,wflag);
    lwritec(lpath,' ');
  }
  lwritec(lpath,')');
}

w_matrix(ptr q,ptr lpath,int wflag){
Reg ptr *p;
int n,m,m2;
  extern ptr *get_matrix();

 p=get_matrix(q,&n,&m);
 /** printf("vect q %x p %x n=%d\n",q,p,n); **/
  prin_s("#a(");
  m2=m;
  while(n--){
    m=m2;
    prin_s("(");
    while(m--){
       print(*p++,lpath,wflag);
       lwritec(lpath,' ');
    }
  prin_s(")");
  }
  lwritec(lpath,')');
}


w_stream(ptr q,ptr lpath,int wflag){
Reg ptr *p;
int n;
 /** printf("stream  q %x \n",q); ***/
  n=CAR(q);
  if(n&SOCKET_PORT)prin_s("#[network-port ");
  else if(n&write_ac){
       if(n&read_ac)
            prin_s("#[read-write-port ");
        else
            prin_s("#[write-port ");
  }
  else  if(n&append_ac){
       if(n&read_ac)
          prin_s("#[read-append-port ");
       else
           prin_s("#[append-port ");
   }
  else prin_s("#[input-port ");
 if(n&CLOSED) prin_s("closed ");
 else{
       if(n&STR_PORT) prin_s("str "); 
       else if(n&FUNC_PORT) prin_s("func "); 
       else  if(n&SOCKET_PORT){
              if(n&listen_ac)
                 prin_s("listen ");
              else
                 prin_s("connect ");
        }
       else  prin_s("file ");
      /**  print(MAKESINT(n&0xf),lpath,wflag); **/
    }
 q=CDR(q); 
  print(MAKESINT((int)CAR(q)),lpath,wflag); /*** location ***/
    lwritec(lpath,' ');
  q=CDR(q);
  print(MAKESINT(CAR(q)),lpath,wflag);  /***   LOC print as SINT  **/
  print(CDR(q),lpath,wflag);  /***   body,  can 't  write LOC  **/
  lwritec(lpath,']');
}

w_multi(ptr q,ptr lpath,int wflag){
Reg ptr *p;
int n;
  while(q!=a_nil){
  print(CAR(q),lpath,wflag);
  newline(lpath);
 q=CDR(q);
 }
}

w_package(ptr q,ptr lpath){
 /** printf("stream  q %x \n",q); ***/
   prin_s("#[package ");
  print(CAR(q),lpath,NO); /*** location ***/
  /**  lwritec(lpath,' ');
      print(CDR(q),lpath,YES);  ***/
  lwritec(lpath,']');
}
w_hash(ptr q,ptr lpath){
 /** printf("stream  q %x \n",q); ***/
   prin_s("#H(");
  print(CAR(q),lpath,NO); /*** location ***/
    lwritec(lpath,' ');
    lwritec(lpath,'.');
    lwritec(lpath,' ');
  print(CDR(q),lpath,NO); /*** location ***/
  lwritec(lpath,')');
}

w_sr2(int attr,ptr q,ptr lpath){
  if(attr&LAMBDA)
      prin_s("#[closure sr2 ");
  else
      prin_s("#[closure sr2macro ");
   print(CADR(q),lpath,NO); /*** information ***/
  lwritec(lpath,']');
}
  
w_extend(ptr q,ptr lpath,int wflag){
  ptr *p,name,x;
  int n;
 /** printf("stream  q %x \n",q); ***/
   prin_s("#s(");
  print(name=CAR(q),lpath,wflag); /*** structure name ***/
    lwritec(lpath,' ');
  /*** print(CDR(q),lpath,NO); 
  lwritec(lpath,']');
   ***/
  /*** name=assq(name,ATOMVAL(a_structure_inits));  ****/
  name=assq(name,ATOMVAL(a_structure_slots_name));
  if(name!=a_f) name=CDR(name);
 p=get_vector(CADR(q),&n);
  while(n--){
    if(CONSP(name)){
      /*** x=CAR(CAR(name));   ***/
      x=CAR(name);
      name=CDR(name);
      print(x,lpath,wflag);
    lwritec(lpath,' ');
   }
    /*** print(*p++,lpath,wflag);    2010.5.1 Circle print not supported  ****/
    lwritec(lpath,' ');
  }
  lwritec(lpath,')');

}

w_netsocket(ptr q,ptr lpath,int wflag){
  int attr;
  struct sockaddr_in *net;
   attr=(int)CAR(q);
   if(attr!=sock_addr){
      prin_s("#<socket ");
      attr=(int)CDR(q);
      print(MAKESINT(attr),lpath,wflag);
    }
   else{
      prin_s("#<netport ");
      net=(struct sockaddr_in *)CDR(q);
      print(MAKESINT(info_portnumber(net)),lpath,wflag);
      lwritec(lpath,' ');
      prin_s(info_hostip(net));
    }
    lwritec(lpath,'>');
}
