/*** s_char.c
  2005.1.20  modified
*****/

#define  S_CHAR_C

#include "lisp.h"


int ss_isalpha(unsigned int n)
{ 
  if(n>127) return NO;
  return isalpha(n);
}

int ss_isdigit(unsigned int n)
{
  if(n>127) return NO;
  return isdigit(n);
}

int ss_isspace(unsigned int n)
{
  if(n>127) return NO;
  return isspace(n);
}

int ss_isalnum(unsigned int n)
{
  if(n>127) return NO;
  return isalnum(n);
}

ptr s_char_eq(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    if(CHARP(x)){
       if(CHARP(y))
           return PRED(x==y);
       error(E_notchar,y);
    }
   error(E_notchar,x);
 }

ptr s_char_lt(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    Reg int n,m;
    checknarg(narg-2);
    if(CHARP(x)){
        n=CHAR_CODE(x);
       if(CHARP(y)){
           m=CHAR_CODE(y);
           return PRED(n<m);
       }
       error(E_notchar,y);
    }
   error(E_notchar,x);
 }

ptr s_char_gt(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    Reg int n,m;
    checknarg(narg-2);
    if(CHARP(x)){
        n=CHAR_CODE(x);
       if(CHARP(y)){
           m=CHAR_CODE(y);
           return PRED(n>m);
       }
       error(E_notchar,y);
    }
   error(E_notchar,x);
 }
ptr s_char_le(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    Reg int n,m;
    checknarg(narg-2);
    if(CHARP(x)){
        n=CHAR_CODE(x);
       if(CHARP(y)){
           m=CHAR_CODE(y);
           return PRED(n<=m);
       }
       error(E_notchar,y);
    }
   error(E_notchar,x);
 }
ptr s_char_ge(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    Reg int n,m;
    checknarg(narg-2);
    if(CHARP(x)){
        n=CHAR_CODE(x);
       if(CHARP(y)){
           m=CHAR_CODE(y);
           return PRED(n>=m);
       }
       error(E_notchar,y);
    }
   error(E_notchar,x);
 }

lowercode(ptr p){
Reg int n;
 if(!CHARP(p)) error(E_notchar,p);
 n=CHAR_CODE(p);
 if(ss_isalpha(n)) n=tolower(n);
 return n;
}

_lowercode(int n){
 if(ss_isalpha(n)) n=tolower(n);
 return n;
}   

ptr s_char_ci_eq(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    Reg int n,m;
    checknarg(narg-2);
    n=lowercode(x);
    m=lowercode(y);
    return PRED(n==m);
}

ptr s_char_ci_lt(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    Reg int n,m;
    checknarg(narg-2);
    n=lowercode(x);
    m=lowercode(y);
    return PRED(n<m);
}
ptr s_char_ci_gt(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    Reg int n,m;
    checknarg(narg-2);
    n=lowercode(x);
    m=lowercode(y);
    return PRED(n>m);
}
ptr s_char_ci_le(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    Reg int n,m;
    checknarg(narg-2);
    n=lowercode(x);
    m=lowercode(y);
    return PRED(n<=m);
}
ptr s_char_ci_ge(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    Reg int n,m;
    checknarg(narg-2);
    n=lowercode(x);
    m=lowercode(y);
    return PRED(n>=m);
}

ptr s_kanjip(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    Reg int n;
    checknarg(narg-1);
    if(!CHARP(x)) error(E_notchar,x);
    n=CHAR_CODE(x);
    return PRED(euc_code(n>>8,n&0xff));
}


ptr s_char_alphabetic(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    Reg int n;
    checknarg(narg-1);
    if(!CHARP(x)) error(E_notchar,x);
    n=CHAR_CODE(x);
    return PRED(ss_isalpha(n));
}


ptr s_char_numeric(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    Reg int n;
    checknarg(narg-1);
    if(!CHARP(x)) error(E_notchar,x);
    n=CHAR_CODE(x);
    return PRED(ss_isdigit(n));
}

ptr s_char_alphanumeric(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    Reg int n;
    checknarg(narg-1);
    if(!CHARP(x)) error(E_notchar,x);
    n=CHAR_CODE(x);
    if(ss_isdigit(n)) return a_t;
    if(ss_isalpha(n)) return a_t;
    return a_f;
}

ptr s_char_word(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    Reg int n;
    checknarg(narg-1);
    if(!CHARP(x)) error(E_notchar,x);
    n=CHAR_CODE(x);
    if(ss_isalpha(n)) return a_t;
    if(ss_isdigit(n)) return a_t;
    if(n=='_') return a_t;
    return a_f;
}


ptr s_char_whitespace(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    Reg int n;
    checknarg(narg-1);
    if(!CHARP(x)) error(E_notchar,x);
    n=CHAR_CODE(x);
    return PRED(ss_isspace(n));
}
ptr s_char_upper(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    Reg int n;
    checknarg(narg-1);
    if(!CHARP(x)) error(E_notchar,x);
    n=CHAR_CODE(x);
    return PRED(isupper(n));
}
ptr s_char_lower(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    Reg int n;
    checknarg(narg-1);
    if(!CHARP(x)) error(E_notchar,x);
    n=CHAR_CODE(x);
    return PRED(islower(n));
}

ptr s_char_upcase(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    Reg int n;
    checknarg(narg-1);
    if(!CHARP(x)) error(E_notchar,x);
    n=CHAR_CODE(x);
    if(islower(n)){
        n=toupper(n);
        return MAKECHAR(n);
     }
   else
      return x;
}

ptr s_char_downcase(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    Reg int n;
    checknarg(narg-1);
    if(!CHARP(x)) error(E_notchar,x);
    n=CHAR_CODE(x);
    if(isupper(n)){
        n=tolower(n);
        return MAKECHAR(n);
     }
   else
      return x;
}

/***  s_str.c   ***/
extern ptr s_str_eq(),s_str_lt(), s_str_gt(), s_str_le(), s_str_ge();
extern ptr s_str_ci_eq(),s_str_ci_lt(), s_str_ci_gt(), s_str_ci_le(), s_str_ci_ge();

struct  sys_subr  char_func[]=
  {
{"char=?", s_char_eq, 2,0},
{"char<?", s_char_lt, 2,0},
{"char>?", s_char_gt, 2,0},
{"char<=?", s_char_le, 2,0},
{"char>=?", s_char_ge, 2,0},
{"char-ci=?", s_char_ci_eq, 2,0},
{"char-ci<?", s_char_ci_lt, 2,0},
{"char-ci>?", s_char_ci_gt, 2,0},
{"char-ci<=?", s_char_ci_le, 2,0},
{"char-ci>=?", s_char_ci_ge, 2,0},

{"char-alphabetic?", s_char_alphabetic, 1,0},
{"char-numeric?", s_char_numeric, 1,0},
{"char-whitespace?", s_char_whitespace, 1,0},
{"char-upper-case?", s_char_upper, 1,0},
{"char-lower-case?", s_char_lower, 1,0},
{"char-word?", s_char_word, 1,0},
{"char-kanji?", s_kanjip, 1,0},
{"char-alphanumeric?", s_char_alphanumeric, 1,0},

{"char-upcase", s_char_upcase, 1,0},
{"char-downcase", s_char_downcase, 1,0},

{"string=?", s_str_eq, 2,0},
{"string<?", s_str_lt, 2,0},
{"string>?", s_str_gt, 2,0},
{"string<=?", s_str_le, 2,0},
{"string>=?", s_str_ge, 2,0},
{"string-ci=?", s_str_ci_eq, 2,0},
{"string-ci<?", s_str_ci_lt, 2,0},
{"string-ci>?", s_str_ci_gt, 2,0},
{"string-ci<=?", s_str_ci_le, 2,0},
{"string-ci>=?", s_str_ci_ge, 2,0},
{"string-ci>=?", s_str_ci_ge, 2,0},

 {NULL,NULL,0,0},
 };

init_char(){
init_sub(char_func,SLAMBDA);
}



