/***  dbl.c
***/
#define  DBL_C

#include "lisp.h"
#include <stdio.h>
#include <math.h>

extern ptr rational();

ptr MAKEDBL(s)
  Reg double s;
 {
   Reg ptr x;
    x=new_cell(DOUBLE);
   FLONUM(x)=s;
   return x;   
  }

double getdbl(n)  /*** ???? ***/
   Reg int n;
 {
    /*   32 bit int (ABS)-->dbl  */
    Reg double s;
      if(n>=0) s=n;
      else
        {
           s=(n>>1)&0x7fffffff;
           s=s*2+(n&1);
        }
     return s;
  }

double get_float(x)
    Reg ptr x;
 {
    /*    int   ->double  */
    double s=0.0;
    
    if(SINTP(x))
        s=(double)SINT_NUMB(x);
    else if(BIGINTP(x))
      {
        psh(x);
        s= mpz_get_d(BIGNUM(x));
        pull();
        return s;
      }  
   else if(RATIOP(x))
     {
         psh(x);
         s=mpq_get_d(RATIONAL(x));
         pull();
         return s;
     }
    else if(DOUBLEP(x)) 
          return FLONUM(x);
    else
         error(E_notreal,x);
    return (s);
 }

ptr _float(x)
    Reg ptr x;
 {
    /*     -->double ptr   */
    Reg double s;
     double get_float();
    if(INTP(x))
        s=SINT_NUMB(x);
    else if(DOUBLEP(x)) 
            return x;
   else if(BIGINTP(x))
      {
        psh(x);
        s=mpz_get_d(BIGNUM(x));
        pull();
      }
   else if(RATIOP(x))
     {
        psh(x);
        s=mpq_get_d(RATIONAL(x));
        pull();
     }
   else
         error(E_notnum,x);
   return MAKEDBL(s);
 }

ptr floatadd(p,q)
  Reg ptr p,q;
 {
   Reg double s;
     s=FLONUM(p)+FLONUM(q);
    return MAKEDBL(s);
 }

ptr floatsub(p,q)
  Reg ptr p,q;
 {
   Reg double s;
     
     s=FLONUM(p)-FLONUM(q);
    return MAKEDBL(s);
 }

ptr floatmul(p,q)
  Reg ptr p,q;
 {
   Reg double s;
     
     s=FLONUM(p)*FLONUM(q);
    return MAKEDBL(s);
 }

ptr floatdiv(p,q)
  Reg ptr p,q;
 {
   Reg double s;
     
     s=FLONUM(p)/FLONUM(q);
    return MAKEDBL(s);
 }

ptr floatmod(p,q)
  Reg ptr p,q;
 {
   /*** double floor();   *********  !!!!   **********/
   Reg double s,n,m;
     m=FLONUM(q);
     s=FLONUM(p)/m;
     n=floor(s);
     s=FLONUM(p)-n*m;
     if(m<0.0){
                if( s<= 0.0) goto owa;
            }
           else if(s>= 0.0) goto owa;
      s+=m;
  owa:
    return MAKEDBL(s);
 }

ptr floatremain(p,q)
  Reg ptr p,q;
 {      
   /*** double floor();   *********  !!!!   **********/
   Reg double s,n,m,x;
     x=FLONUM(p);
     m=FLONUM(q);
     s=x/m;
     n=floor(s);
     s=x-n*m;
     if(x<0.0){ 
                if( s<= 0.0) goto owa;
                if(m<0.0) s+=m;
                 else s-=m;
            }
      else if(s>= 0.0) goto owa;
          if(m<0.0) s-=m;
          else s+=m;
  owa:
    return MAKEDBL(s);
 }      


/****  double ι¤
   δؿ
   OS-9 Ǥ
   1(sign)+exp(11bits)+52bits
  =sign*2^(exp-1023)*1.[52bits]   :1023=0x3ff
  ****/
static ptr s_float_digits(arg)
  Reg ptr *arg;
 {
  return MAKENUM(53);
 }

static ptr s_float_precision(arg)
  Reg ptr *arg;
 {
   Reg ptr x=*arg;
   double f;

   if(!FLOATP(x)) error(E_notreal,x);   
   f=*(double *)x;
   if(f==0.0) return ZERO;
  return MAKENUM(53);
 }
/*****  exact ***/
ptr s_exact2inexact(int narg,ptr env){
Reg ptr x=*(stack-1);
 checknarg(narg-1);

if(INTEGERP(x)||RATIOP(x)){
  return MAKEDBL(get_float(x));
}
else if(DOUBLEP(x)) return x;
else if(COMPLEXP(x)){
  psh(CAR(x));
  *(stack-1)=s_exact2inexact(1,a_nil);
  psh(CDR(x));
  *(stack-1)=s_exact2inexact(1,a_nil);
  x=s_complex(2,a_nil);
 stack-=2;
 return x;
}
error(E_notnum,x);
}

ptr s_inexact2exact(int narg,ptr env){
Reg ptr x=*(stack-1);
 checknarg(narg-1);

if(INTEGERP(x)||RATIOP(x)){
  return x;
}
else if(DOUBLEP(x)) return rational(x);
else if(COMPLEXP(x)){
  psh(CAR(x));
  *(stack-1)=s_inexact2exact(1,a_nil);
  psh(CDR(x));
  *(stack-1)=s_inexact2exact(1,a_nil);
  x=s_complex(2,a_nil);
 stack-=2;
 return x;
}
error(E_notnum,x);
}


