/***  gbc.c
***/
#define  GBC_C
#include "lisp.h"
#include  <stdio.h>
#ifdef USE_TK
#include <tk.h>
#endif

#define LEFT 0
#define RIGHT 1


#define SETMARK(p)  (MARK(p)|=GBCMARK)
#define CLRMARK(p)  (MARK(p)&=0xfffffff)
#define ISMARK(p)  (MARK(p)&GBCMARK)
#define B_ISMARK(p)  ((p)&GBCMARK)
#define SETFREE(p)  (MARK(p)|=FREECELL)


#define is_obj(p)  (!SREGP(p))  
extern ptr PC[],*pc_stack;
extern ptr MPU[],*mpu_stack;
/**  V2.0  ***/
extern ptr SYSREG[];
extern ptr SCM,VMENV,ARGS,VPC,MULTIVAL,ST,BA;
/*** compiler ***/
extern ptr CPC[],*cpc_stack;
extern ptr OUTCOMP[],*comp;/***  scm needs !!! ***/

extern ptr chistory[];
extern int check_cell();
extern int cell_bank;
extern ptr cell_begin[],cell_end[];
extern ptr after_cmd[];
extern ptr *get_alloc();

static int verbos=0;   
static int gbc_count=0;   
static double gbc_time=0.0;   
extern double my_time();
extern int cell_total;

void markit();
void free_num();
void free_tklink(); 
   
ptr gbc()
  {
   Reg ptr q,*pst;
   Reg int i;
   Reg char *cp;
   double gbc_sec;
    //verbos=1;  //Debug 1  
   gbc_sec=my_time();
   if((gbc_sec>0.0)&&((gbc_sec-gbc_time)<5.0))
      gbc_count++;
   else
      gbc_count=0;
   gbc_time=gbc_sec;
   
    if(verbos) 
 printf("gbc start .... \n");

  /**** special   ***/ 
    SETMARK(a_nil);
    SETMARK(a_f);
    SETMARK(a_t);
    SETMARK(a_undef);
    SETMARK(a_unbdd);
    /**  printf("gbc a_env %x\n",a_env);  **/
    /** markit(a_env);   * environment ***/
   if(verbos)  printf("gbc env end\n");
    /*** markit(scm);**/
   /**  markit(multiscm);***/
  /*** sysprotect   nullstr, etc  ***/
  pst=sysprotect;
  i=0;
  while(i++<syspro) markit(*pst++);
   if(verbos)  printf("gbc syspro end\n");
  /*** interned symbol  ***/
  symbol_setmark();
   if(verbos)  printf("gbc symbol end\n");
   /*** PC stack  m.c **/
   /***
     i=0;
    pst=pc_stack;
    while(--pst>=PC)
     {
       i++;
      q=*pst;
      if(OBJP(q))
      {
        markit(q);
      }
     }
   if(verbos)  printf("gbc PC-stack end %d\n",i);
   ***/
  /***   MPU stack  ***/
   i=0;
   pst=mpu_stack;
    while(--pst>=MPU)
     {
       i++;
      q=*pst;
      if(OBJP(q))
      {
        markit(q);
      }
     }
   if(verbos)  printf("gbc MPU-stack end %d\n",i);
  /*** CPC stack ***/
 /***pst=cpc_stack;
    while(--pst>=CPC)
     {
      q=*pst;
      if(OBJP(q))
      {
        markit(q);
      }
     }
   if(verbos)  printf("gbc CPC-stack end\n");
***/
 /*** OTCOMP  **
     pst=comp;
    while(--pst>=OUTCOMP)
     {
      q=*pst;
      if(OBJP(q))
      {
        markit(q);
      }
     }
   if(verbos)  printf("gbc OUTCOMP end\n");
***/
 
  /*** stack  **/
    pst=stack;
    while(--pst>=stack_base)
     {
      if(is_obj(*pst))
      {
        markit(*pst);
      }
     }
   if(verbos)  printf("gbc stack end\n");
   /** V2.0  ***/
    pst=SYSREG;
      while(q=*pst++)
     {
        markit(q);
     }
    markit(SCM);
    markit(ST);
    markit(BA);
    markit(VMENV);
    markit(ARGS);
    markit(VPC);
    markit(MULTIVAL);

   if(verbos)  printf("gbc SYSREG end\n");

  /*** frame  
    pst=frame;
    while(--pst>=frame_base)
     {
      if(is_obj(*pst))
      {
        markit(*pst);
      }
     }
   if(verbos)  printf("gbc frame end\n");
  ***/
   /***  after_cmds  ***/
  pst=after_cmd+AFTERMAX;
    while(--pst>=after_cmd)
     {
        markit(*pst);
     }
   if(verbos)  printf("gbc after_cmd  end\n");

   pst=chistory;
   i=0;
    while(i<HISMAX)
     {
      if(is_obj(*pst))
      {
        markit(*pst);
      }
      pst++;
     i++;
     }
   if(verbos)  printf("gbc combination history end\n");

  i=sweep();
   if(verbos)  printf("gbc sweep end\n");
  if(free_cell==a_nil){
     extends_cell();
     gbc_count=0;
    /** fatal_error(E_cell,a_nil);  **  Cell runs out:fatal  ****/
  } 
   if((gbc_count>=2)&&((i+i)<cell_total)){
              extends_cell();
              gbc_count=0;
      }
     if(verbos) printf("......  gbc  end\n"); 
    return a_t;
  }

symbol_setmark(){
   markit(a_all_packages);
}

void markit(p)
  Reg ptr p;
 {
  loop:
    if(!virgin(p)) return; 
    SETMARK(p);
    markit(CAR(p));
    /** markit(CDR(p));  ***/
    /*** tail recursion  ***/
    p=CDR(p);
    goto loop;
}
    
virgin(p)
  Reg ptr p;
 {
   Reg ptr q,*r;
   int n;
 
    if(p==NULL||SREGP(p)) return NO;  
    if(!OBJP(p)) return NO;  /***  to be error!!!  toriaezu!!! ****/
    n=(int) MARK(p);
    if(B_ISMARK(n)) return NO;  
    n&=TYPEMASK;
   /**  printf("  gbc virgin p %x  n %x\n",p,n); **/
    if(B_CONSP(n)) return YES;
    if(B_NUMBERP(n))
      {
        if(B_COMPLEXP(n)){
           return YES;
        }
       else
          SETMARK(p);
        return NO;
      }
     else  if(B_SYMBOLP(n)||B_KEYWORDP(n)) 
      {
          /***  printf("  gbc SYMBOL %x ",p); **/
         return YES;
      }
     else  if(B_STRINGP(n)) 
      {
          SETMARK(p);
          q=CAR(p);   /****   in space area ***/
          SETMARK(q);
          return NO;
           /***  CDR(p)=length No mark needs **/
      }
     else  if(B_VECTORP(n))
      {
          SETMARK(p);
          n=(long)CDR(p);
          q=CAR(p);   /****   in space area ***/
          SETMARK(q);
          /***  n=CDR(p);   size  in short !**/
          r=(ptr *)(++q);
          while(n--) markit(*r++);
          return NO;
      }
      else  if(n&MATRIX)
      {
          SETMARK(p);
          SETMARK(CDR(p));
          n=SINT_NUMB(CADR(p))*SINT_NUMB(CDDR(p));
          q=CAR(p);   /****   in space area ***/
          SETMARK(q);
          /*** n=CDR(p);   size **/
          r=(ptr *)(++q);
          while(n--) markit(*r++);
          return NO;
           /***  CDR(p)=length No mark needs **/
      }

       else  if(B_CLOSUREP(n))
      {
          SETMARK(p);
          p=CDR(p);   /****   skip type ***/
          SETMARK(p);
          /*** if(!SUBRADDP(p))
          ***/
          markit(CDR(p));  /***  safe ??? ***/ 
          markit(CAR(p));  /*** env  ***/
          return NO;
      }
      else if(n==SYNTAX)   /*** SYNTAXLAMBDA checked by CLOSURE ***/
      {
          return YES;
      }
      else  if(B_STREAMP(n))
      {
          SETMARK(p);
          SETMARK(p=CDR(p));  /*** needs mark each cell ***/
          SETMARK(p=CDR(p));
          /*** file,string,lamba  ***/
          markit(CDR(p)); 
          return NO;
      }
     /*** special
     else  if(B_BOOLEANP(n))
      {
         SETMARK(p);
         return NO;
      }
    ***/
/****
     else if(B_CWCP(n))
     {
         SETMARK(p);
         SETMARK(CAR(p));
         r=get_vector(CAR(p),&n); *** copy of PC stack   ***
         while(n--){
            q=*r++;
            if(OBJP(q))
             {
                  markit(q);
               }
           }
         markit(CDR(p));
         return NO;   ** vector,vector, env-stack *
     }
***/  
  /****
     else if(B_JMPP(n))
      {
         SETMARK(p);
         *** markit(CDR(p));    CAR is buffer adress, CDR is nil  ***
         return NO;
      }
   ****/
     else if(B_EXTP(n))    /***  ***/
         return YES;
   /***  else if (n&MULTI)
         return YES;
        V2.0 Not use ***/
#ifdef USE_TK
     else if(n&TKOBJ){
           SETMARK(p);
           SETMARK(CDR(p));
           virgin(CDDR(p));  /*** name-string ***/
          return NO;
      }    
#endif
     else if(n&MALLOC){
           SETMARK(p);
           if(n&MALLOC_BIN) return NO;
           r=get_alloc(p,&n);
           /*** printf("gbc MALLOC alloc %x %d\n",r,n); ***/
           if(r!=(ptr *)-1){
              while(n--){
                 q=*r++;
                 if(OBJP(q)) markit(q);
               }
           }
          return NO;
     }
     else if(n&NETSOCKET){
           SETMARK(p);
           if(SINTP(CAR(p))) return NO;
           markit(CAR(p));
           return NO;
      }
     else
        ;
      printf("gbc not in system %lx  attr %x \n",(unsigned long)p,n);
      printf("a_undef %lx   \n",(unsigned long)a_undef);
      fatal_error(E_system,p);
      
      SETMARK(p);
    return NO;
 }

int sweep()
{
  Reg int n=cell_bank;
 sweep_aux(fc_begp,fc_endp);
  while(n--){
     sweep_aux(cell_begin[n],cell_end[n]);
  }
    n=check_cell(free_cell,-1);
 if(verbos){
       printf(" cell total free %d in %d\n",n,cell_total);
     }
   return n;
}

static int check_complex(ptr p){
   ptr x;
   if((!SINTP(CAR(p))&&ISMARK(CAR(p)))||(!SINTP(CDR(p))&&(ISMARK(CDR(p))))){
       fprintf(stderr,"gbc Found not stacked complex  number!\n");
     return 1;
   }
   return 0;
}

int sweep_aux(ptr begin,ptr end)
 {
  /***  CELL sweep   ***/
  Reg ptr p;
  Reg int s=0,n;
  p=end;
  /***  free_cell=a_nil;     ***/
  do
   {
     n=MARK(--p);
     //2018.3.10  Bug of Math
     //  Need math  debug!
     //if(B_COMPLEXP(n)){
         //if(check_complex(p))
         //  n=GBCMARK;  //Not sweep!
      //}
     if(B_ISMARK(n)) 
      {
           CLRMARK(p);   /***clear gbc mark ***/
      }
     else if(n&FREECELL)
       ;
     else
      {
         if(NUMBERP(p)) free_num(p);
#ifdef USE_TK
         else if(n&TKOBJ) free_tklink(p);
#endif
         else if(n&MALLOC) free_malloc(p);
         else if(B_STRINGP(n)||B_VECTORP(n)||(n&MATRIX)){
                 if(OBJP(CAR(p))){
                     if(verbos){  /***  error? ***/
                         printf("gbc  %lx addr %lx  attr %x\n",(UL)p,(UL)CAR(p),n);
                         prin1(CAR(p),STDOUT);
                     }
                   }
                 else
                    Myfree(CAR(p));
          }
         else if(n&NETSOCKET){
              if(SINTP(CAR(p)))
                      Myfree(CDR(p));
              /***  the following  no good, may be reopen
                 else
                   close((int)CDR(p));
                ***/
          }
         s++;
         CAR(p)=a_f;
         //CAR(p)=a_t;
         CDR(p)=free_cell;
         MARK(p)=FREECELL;    /**  FREECELL;  ** ***/
         free_cell=p;
      }
    }  while(p!=begin);
  if(verbos){
       printf(" cell begin %lx end %lx \n",(UL)begin,(UL)end);
       printf(" cell  free added %d \n",s);
     }
  return s;
}

void free_num(Reg ptr p){  /****  GMP clear  needs   ****/
Reg int n=ATTR(p);

if(B_BIGINTP(n)){
  /*** 04.1.3  **/
  /*** if(BIGNUM(p)==a_nil) printf("myfree error bignum\n");  ***/
  mpz_clear(BIGNUM(p));
  Myfree(BIGNUM(p));
 
}
else if(B_RATIOP(n)){
  /*** 04.1.3  **/
  /*** if(RATIONAL(p)==a_nil) printf("myfree error rational\n");  ***/
  mpq_clear(RATIONAL(p));
  Myfree(RATIONAL(p));
}
else if(B_COMPLEXP(n)){
   //  2018.3.10  needs????
  
}
else
  ;
 return;
}

#ifdef USE_TK

void free_tklink(Reg ptr p){ 
 char *q;
 int n;
 extern Tcl_Interp *myInterp;

if((long)CAR(p)==STRING) return;
if(CAR(p)){
     q=get_string(CDR(p),&n);
     Tcl_UnlinkVar(myInterp,q);
     Tcl_Free((char *)CAR(p)); /*** this is cdr cell of TKOBJ  ***/
 }
}
#endif

free_alloc_cell(Reg ptr p){
  free_malloc(p);
   CAR(p)=a_nil;
   CDR(p)=free_cell;
   MARK(p)=FREECELL;    /**  FREECELL;  ** ***/
   free_cell=p;
}


free_malloc(Reg ptr p){ 
  /*** if(CAR(p)==a_nil) printf("myfree error malloc %x %x %x\n",p,CAR(p),CDR(p)); ***/
   if(CAR(p)!=(ptr)-1){
      Myfree((void *)CAR(p));
      CAR(p)=(ptr)-1;
   }
}


ptr s_gbc(int narg,ptr env){
 if(narg==1)
       verbos=(*(stack-1)!=a_f);
 else
       verbos=1;
  gbc();
 verbos=0;
 return a_undef;
}
         

        
         
    
