/***   glob     ****/
/***   service program  in ss  ***/
/***  05.3.29  revised  ***/

#include <glob.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>


#ifndef  GLOB_ONLYDIR
#define  GLOB_ONLYDIR  -1
#endif

#ifndef  GLOB_TILDE
#define    GLOB_TILDE  0
#endif
 
static struct stat   stat_buf;
void help();
void glob_files();

int main(int argc,char **argv){
 int flag=0;
 while(*++argv){
  if(strcmp(*argv,"--help")==0) help();
  else if(strcmp(*argv,"-d")==0) flag=GLOB_ONLYDIR;
  else if(strcmp(*argv,"-f")==0) flag=GLOB_MARK;
  else
      glob_files(*argv,flag);
  }
}

void help()
  {
    printf("\n usage:  glob [-d|-f] pat1 pat2 ...   \n");
    printf("     -d  directory only  \n");
    printf("     -f  regular file only  \n");
    printf("   ex.  glob -d \"*\"  \n");
    printf("    --help   \n");
    exit(0);
  }

int is_directory(char *p){
  int n;
  n=get_file_mode(p);
  if(n==-1) return 0;
  return ((n&S_IFMT)==S_IFDIR);
}
/***  return -1 if not exists  ***/
int get_file_mode(char *p){
   int n;
   n=stat(p,&stat_buf);
   if(n==-1) return n;
   return stat_buf.st_mode;
}

void glob_files(char *pat,int flag)
{
  int file;
  glob_t globfile;
  char **p;
  int n,glob_dir;
     if(flag==-1){
         glob_dir=1;   /** for win, fbsd  ***/
         flag=0;
     }
    else
       glob_dir=0;
                                                                                                           
   n=glob(pat,GLOB_TILDE|flag,0,&globfile); /***  ~/.  -> /home/sato/.  ***/
   /***  cygwin  n=0 errno =0  for no match ,  need  check gl_matchc  ***/
#ifdef __WIN32__
   if(n||(globfile.gl_matchc==0)) {
#else
   if(n){
#endif
      /***  printf("glob No match! glob_dir %d\n",glob_dir);   debug **/
      return ;
   }
   /*** printf("glob debug  n %d errno %d globfile %x \n",n,errno,globfile); *  debug **/
  p=globfile.gl_pathv;
  while(*p){
    /** printf("%s\n",*p++); ***/
    file=1;
    if(flag==GLOB_MARK){
         if(is_directory(*p)) file=0;
     }
    else if(glob_dir){
         file=is_directory(*p);
    }
                                                                                                           
    if(file)
        printf("%s\n",*p);
    p++;
  }
 globfree(&globfile);
 return ;
}

