
#define GREAD
#include "lisp.h"
#include <stdio.h>
#include <stdlib.h>

#define READ_MAIN
#include "clread.h"
/**** New read  with readtable
     name gread
****/

/*****   
   extended   read routine using  COMMON LISP type of READ MACRO  */

   
#define ATOMLENGTH  256

   /***  system  reallocは、うまくいかない！
         Myrealloc OK! ***/
extern ptr get_type(),read_char(),makestring_p();

ptr inchar(ptr stream);
static ptr get_macro();
static ptr esc_key();

void init_gread(){ 
    tok_max=512;
           tokstr=(char *)Mymalloc((size_t)tok_max);
           esc_tokstr=(char *)Mymalloc((size_t) tok_max);
           if(tokstr==NULL||esc_tokstr==NULL)  fatal_error(E_malloc,a_undef);
        }

void add_tok(ptr x)
 {
   Reg  char  *p;
   Reg int n;
      if(loc_tok>=tok_max-4){ 
           n=2*tok_max;
           /*** tokstr=init_realloc(tokstr,tok_max,n); ***/
           tokstr=Myrealloc(tokstr,tok_max,n);
           /*** esc_tokstr=init_realloc(esc_tokstr,tok_max,n); ***/
           esc_tokstr=Myrealloc(esc_tokstr,tok_max,n);
           tok_max=n;
           if(tokstr==NULL||esc_tokstr==NULL)  fatal_error(E_malloc,a_undef);
   /**  printf("realloc buff %x  new %d\n",tokstr,tok_max); ***/
        }
      p=tokstr+loc_tok++;
      n=CHAR_CODE(x);
      if(n<256)
         *p++=n;
      else if (n&0xff0000){ /** utf8  ***/
          *p++=(n>>16);
          *p++=(n>>8);
          *p++=n;
          loc_tok++;
          loc_tok++;
         } 
      else { /** euc  ***/
          *p++=(n>>8);
          *p++=n;
          loc_tok++;
       }
     *p=0;
     /** 91.10.7  memo esc-flag ***/
      p=esc_tokstr+loc_tok-1;
     *p=esc_flag?'Y':'\0';
  }   

ptr s_gread(int narg,ptr env ){
 ptr lpath;
  if(narg==0) lpath=STDIN;
  else if (narg==1) lpath=*(stack-1);
  else checknarg(narg-1);
  return gread(lpath);
}

ptr gread(ptr lpath){
 Reg ptr x;
 esc_flag=loc_tok=0;
    rm_error=0;
    read_vector=SVAL(a_readtable);
  x=g_read(lpath);
  if(rm_error){
        error(rm_error,x);
     }
  return x;
}

ptr g_read(stream)
  Reg ptr stream;
 {
  Reg ptr x,y,type;
  Reg ptr res,lower;
  /* cell param[2]; */
   /** x=g_skip();
    if(x!=SEOF) 
        unreadchar(x,stream);
    else
         if(l_feof(stream)) 
      {
        return SEOF;   
      }
    ***/
    /*** clear_readerr(stream); ***/

    esc_flag=0;  /*******    5.6    include esc  to be SYMBOL   *****/
    /** rm_error=0; ***/ 
    open_tok();
          
  loop:
    x=inchar(stream);
    if(x==SEOF) return x;
    type=get_type(x);
    /*** printf("type %x\n",type); **/
    if(type==(ptr)illegal) error(E_ill_char,x);
    if((long)type&space) goto loop;
    if(is_macro(type)) 
      {
        if(dispatch&(long)type){
           /**  printf("dispatch %x\n",type); **/
           *stack++=get_macro(x);  /*** dispatch-func vector, is not macro  ***/
           *stack++=stream;
           /**  printf("dispatch vector %x\n",*(stack-2));**/
           res=s_rm_dispatch(2,a_nil);
           stack-=2;
          }
         else{
           *stack++=stream; 
            res=funcall(get_macro(x),1,a_nil);
            stack--;
          }
         if(res==a_undef){
           if(rm_error) return res;
           goto loop;
         }
        /** if(*multivalue==ZERO_VALUE) goto loop; **/
        return res;
      }
    if(type==s_escape)
      {
        y=esc_key(stream);
        esc_flag=1;  
        add_tok(y);
        extoken(stream);
        goto quit;
      }
    if(type==m_escape)
      {
        mxtoken(stream);
        /* res=mxtoken(a_nullstr);*/
        esc_flag=1;  
      }
    else
     {
      /* res=extoken(MAKECHAR(x));*/
       lower=ATOMVAL(a_auto_case);
       if(lower!=a_f){
          psh(x);
          if(lower==a_t) x=s_char_downcase(1,a_nil);
           else  x=s_char_upcase(1,a_nil);
          pull();
       }
       add_tok(x);
       extoken(stream);
     }
    quit:
      if(esc_flag)  
        return pack_make_symbol(tokstr,loc_tok);
      else
         return analyze(tokstr);
     return   pack_make_symbol(tokstr,loc_tok);
   }

static ptr c_get_syntax(ptr c)
 {
    return get_tbl_syntax(c,read_vector);
 }

/***   see read_m.c   
get_type(x)
  Reg int x;
 {
   return CAR(c_get_syntax(x));
 }
***/
 
static ptr get_macro(x)
  Reg ptr x;
 {
   return CDR(c_get_syntax(x));
 }
    
ptr extoken(ptr stream)  
 {
   Reg ptr y,type,lower;
   
   /* token_stream=str_open_w(x,BSIZE);*/
    loop:
     y=inchar(stream);
     if(y==SEOF) return y;
     type=get_type(y);
     /** printf("extoken %c type %x\n",CHAR_CODE(y),type); **/
     if(type==constituent||is_non_t(type))
      {
       /*** x=addtoken(x,y);   ****/
      /*** if(CAR(a_auto_upcase)!=a_nil) y=toupper(y); ***/
       lower=ATOMVAL(a_auto_case);
       if(lower!=a_f){
           psh(y);
          if(lower==a_t) y=s_char_downcase(1,a_nil);
           else  y=s_char_upcase(1,a_nil); 
          pull();
       }
       add_tok(y);
       goto loop;
      }
     if(type==s_escape)
      {
        esc_flag=1;  
        y=esc_key(stream);
       /**** x=addtoken(x,y);  ****/
       add_tok(y);
        goto loop;
      }
    if(type==illegal) 
      {
       /*   close_str(token_stream);*/
        error(E_ill_char,a_nil);
      }
    if(type==t_space)
      {
        goto quit;
      }
    if(is_t_macro(type))
      {
          unreadchar(y,stream);
        goto quit;
      }
    return mxtoken(stream);
   quit:
      /***  return x****/
     return a_nil;
  }
ptr mxtoken(ptr stream)
 {
   Reg ptr  y,type;
   /* token_stream=str_open_w(x,BSIZE); */
     esc_flag=1;  
    loop:
     y=inchar(stream);
     if(y==SEOF) 
        {
          error(E_eof,a_nil);
        }
     type=get_type(y);
     if(type==(ptr)s_escape)
      {
        y=esc_key(stream);
         add_tok(y);
        goto loop;
      }
     if(type==(ptr)m_escape)
      {
       return extoken(stream);
       /**return extoken(x);***/
      }
    if(type==(ptr)illegal)
       {
          error(E_ill_char,a_nil);
       }
        /* x=addtoken(x,y); */
         add_tok(y);
       goto loop;
  }

static ptr s_extoken(int narg,ptr env)
 {
   Reg ptr s,stream;
   
      stream=*(stack-1);/*** heck_read(*argbuf) ; ***/

   /**** if((s=argbuf[1])==a_nil)  ***/
        s=a_nullstr;
      loc_tok=pstrcpy(tokstr,s);
       extoken(stream);
      return close_tok();
 }
static ptr s_mxtoken(int narg,ptr env)
 {
   Reg ptr s,stream;
   
      stream=*(stack-1);/*** heck_read(*argbuf) ; ***/

   /*** if((s=argbuf[1])==a_nil) ***/
        s=a_nullstr;
      loc_tok=pstrcpy(tokstr,s);
       mxtoken(stream);
      return close_tok();
 }

ptr inchar(ptr stream)
  {
     Reg int c;
     Reg ptr ch;
        if(c=sigcode)
           {
             sigcode=0;
                  error(E_intrupt,MAKESINT(c));
           }
     if((ch=read_char(stream))==SEOF)
       {
        if((long)ch==sigcode)
           {
             sigcode=0;
                  error(E_intrupt,MAKESINT(sigcode));
           }
       }
     return ch;
 }
 
 /***   \^A -> ctrl-A  \^? -> $7f  ***/
static ptr esc_key(ptr stream)
 {
   Reg ptr y;
     y=inchar(stream);
     if(y==SEOF) error(E_eof,y);
   return y;
}

