/*** pred.c
***/
#include "lisp.h"

ptr s_charp(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
     return PRED(CHARP(x));
 }

ptr s_stringp(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
     if(SREGP(x)){
       return a_f;
     }
    return PRED(STRINGP(x));
 }

ptr s_vectorp(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
     if(SREGP(x)){
       return a_f;
     }
    return PRED(VECTORP(x));
 }

ptr s_symbolp(int narg,ptr env)
  
 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
     if(SREGP(x)){
       return a_f;
     }
    return PRED(SYMBOLP(x));
 }  
    
ptr s_keywordp(int narg,ptr env)
  
 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
     if(SREGP(x)){
       return a_f;
     }
    return PRED(KEYWORDP(x));
 }

ptr s_floatp(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    checknarg(narg-1);

    if(!SREGP(x)&&DOUBLEP(x))
        return a_t;
     else
        return a_f;
 }

ptr s_realp(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-1);
    checknarg(narg-1);
     if(SREGP(x)){
       return PRED(SINTP(x));
     }
    return PRED(REALP(x));
 }

ptr s_integerp(int narg,ptr env)

 {
    /*   expr 1 ,  integer?  */
    Reg ptr x=*(stack-1);
    checknarg(narg-1);
    if(SREGP(x)){
       if(SINTP(x))
           return a_t;
        else
           return a_f;
     }
    if(BIGINTP(x))
        return a_t;
     else
        return a_f;
 }

ptr s_rationalp(int narg,ptr env)
{ 
  Reg ptr x=*(stack-1);
   checknarg(narg-1);
   if(SREGP(x)) return PRED(SINTP(x));
   if(BIGINTP(x)) return a_t;
   return PRED(RATIOP(x));
}

ptr s_ratiop(int narg,ptr env)
{
  Reg ptr x=*(stack-1);
   checknarg(narg-1);
   if(SREGP(x)) return a_f;
   return PRED(RATIOP(x));
}

int exact(Reg ptr x){

   if(SREGP(x)) {
      if(SINTP(x)) return YES;
      goto err;
   }
   else if(BIGINTP(x)) return YES;
   else if(RATIOP(x)) return YES;
   else if(DOUBLEP(x)) return NO;
   else if(COMPLEXP(x))
     return (exact(CAR(x))&&exact(CDR(x)));
err:
  error(E_notnum,x);   
}

ptr s_exactp(int narg,ptr env)
{
  Reg ptr x=*(stack-1);
   checknarg(narg-1);
   return  PRED(exact(x));
}
ptr s_inexactp(int narg,ptr env)
{
  Reg ptr x=*(stack-1);
   checknarg(narg-1);
   return  RPRED(exact(x));
}


ptr s_fixnump(int narg,ptr env)

 {
    /*   expr 1 ,  integer?  */
    Reg ptr x=*(stack-1);
    checknarg(narg-1);

    if(SINTP(x))
        return a_t;
     else
        return a_f;
 }
ptr s_bignump(int narg,ptr env)

 {
    /*   expr 1 ,  integer?  */
    Reg ptr x=*(stack-1);
    checknarg(narg-1);

    if(!SREGP(x)&&BIGINTP(x))
        return a_t;
     else
        return a_f;
 }

ptr s_numberp(int narg,ptr env)

 {
    /*   expr 1 ,  integer?  */
    Reg ptr x=*(stack-1);
    checknarg(narg-1);

    if(SREGP(x)){
      return PRED(SINTP(x));
   }
    return PRED(NUMBERP(x));
 }

ptr s_complexp(int narg,ptr env)

 {
    /*   expr 1   */
    Reg ptr x=*(stack-1);
    checknarg(narg-1);

    if(SREGP(x)){
      return a_f;
   }
    return PRED(COMPLEXP(x));
 }

ptr s_booleanp(int narg,ptr env)

 {
    /*   expr 1 ,  integer?  */
    Reg ptr x=*(stack-1);
    checknarg(narg-1);

    if(SREGP(x)){
      return a_f;
   }
    return PRED(BOOLEANP(x));
 }

