/****  sint.c
     SINT  math 
  2014.5.8 modified for 64bit-OS
      and Bug fix!
***/
/***  correct check overflow!!! ***/
#define  SINT_C

#include "lisp.h"

#define unsafe 0xf0000000 
#define unsafemul  0xffffC000 
#define INT       long int
#define MSB 0x80000000  //32bit MSB 
#define MSB30 0x20000000  //30bit MSB 
#define MSB32 0xc0000000  //30bit negative int 
#define OVERF 0xffffffffe0000000  //pos mul overflow for30bit  
extern mpz_t mpzwork1,mpzwork2;

ptr add(ptr p,ptr q){
INT n,m,s,sig;
  n=(INT)p;
  m=(INT)q;
  sig=n&MSB;
      s=n+m;
  if(sig==(m&MSB)){
     if(sig!=(s&MSB)){
        s>>=2;
        if(sig) s|=MSB32;
#ifdef SYSTEM64
        s=(INT)((int)s);
#endif
        return bignum(s);
     }
   }
 return (ptr)(s^3);  //...01 SINT
}

ptr sub(ptr p,ptr q){
INT n,m,s,sig;
  n=(INT)p;
  m=(INT)q;
  sig=n&MSB;
      s=n-m;
  if(sig!=(m&MSB)){
     if(sig!=(s&MSB)){
        s>>=2;
        if(sig) s|=MSB32;
#ifdef SYSTEM64
        s=(INT)((int)s);
#endif
        return bignum(s);
     }
   }
 return (ptr)(s|1);  //...01 SINT
}

ptr mul(ptr p,ptr q){
#ifdef SYSTEM64
INT n,m,sig=1;
  n=(INT)p;
  n>>=2;
  if(n&MSB30){
      sig=-sig;
      n=(INT)(-((int)n));
  }
  m=(INT)q;
  m>>=2;
 if(m&MSB30){
      sig=-sig;
      m=(INT)(-((int)m));
  }
  n=n*m;
  if(OVERF&n){
     if(sig<0) n=-n;
      return bignum(n);
  }
 if(sig<0) n=-n;
 return MAKESINT(n);
}
#else
INT n,m,sig=1;
  n=SINT_NUMB(p);
  if(n<0){
      sig=-sig;
      n=-n;
  }
  m=SINT_NUMB(q);
 if(m<0){
      sig=-sig;
      m=-m;
  }
  if((n&unsafemul)||(m&unsafemul)){
   if(sig<0) n=-n;
   mpz_set_si(mpzwork1,n);
   mpz_set_si(mpzwork2,m);
   mpz_mul(mpzwork1,mpzwork1,mpzwork2);
   return mpz_check16(mpzwork1);
  }
 if(sig<0) n=-n;
 return MAKESINT(n*m);
}
#endif

ptr mod(ptr p,ptr q){
INT n,m;
 n=SINT_NUMB(p);
 m=SINT_NUMB(q);
 n=n%m;
 if(m>0&&(n<0)) n+=m;
 if(m<0&&(n>0)) n+=m;
 return MAKESINT(n);
}

ptr remain(ptr p,ptr q){
INT n,m;
 n=SINT_NUMB(p);
 m=SINT_NUMB(q);
 return MAKESINT(n%m);
}


ptr intdiv_sint(ptr p,ptr q){
INT n,m,r;
  n=SINT_NUMB(p);
  m=SINT_NUMB(q);
  r=n%m;
  if(r==0) return MAKESINT(n/m);
   mpz_set_si(mpzwork1,n);
   mpz_set_si(mpzwork2,m);
  return mpz2rational(mpzwork1, mpzwork2);
}

/** quotient ***/
ptr div_sint(ptr p,ptr q){
INT n,m,r;
  n=SINT_NUMB(p);
  m=SINT_NUMB(q);
   return MAKESINT(n/m);
}
