/***  strbm.c ****/
/***  2005.8.15 created   Boyer-Moore Algorithm  ***/
/**   see BM2.ss  ***/

#include "lisp.h"
#include <ctype.h>
#include <math.h>


static int bmBc[256];
static int case_i,repeat_f,prev_case_i,last_f;
extern ptr k_end,k_nocase,k_repeat,k_ci,k_last;
extern ptr *get_alloc();

static ptr prev_str=(ptr)0;


void pre_bmBc(Reg unsigned char *pat, Reg int m){
  Reg int *p=bmBc,md=m-1,i;
   for(i=0;i<256;i++)
      *p++=m;
   for(i=0;i<m;i++){
     bmBc[pat[i]]=md;
     if(case_i) {
           bmBc[tolower(pat[i])]=md;
           bmBc[toupper(pat[i])]=md;
      }
      md--;
   }
}
/*** i < k    return count of same bytes  from last  ***/
int str_lastcmp(Reg  unsigned char *p,Reg int i, Reg int k){
  Reg  unsigned char* q=p+i,*r=p+k;
   i=0;
   while(q>=p){
     if(*q--!=*r--) break;
     i++;
  }
return i;
}

int str_lastcmp_ci(Reg  unsigned char *p,Reg int i, Reg int k){
  Reg  unsigned char* q=p+i,*r=p+k;
   i=0;
   while(q>=p){
     if(tolower(*q--)!=tolower(*r--)) break;
     i++;
  }
return i;
}

/****
int scm_strcmp_ci(Reg char *p,Reg char *q,Reg int n){
   while(n--){
     if(tolower(*p++)!=tolower(*q++)) return NO;
  }
return YES;
}
****/

void suffixes( unsigned char *pat, int m, Reg int suff[]){
 int i,h,m1=m-1,m2=m-2,g,g1;
       suff[m1]=m;
       if(case_i)
           g=h=str_lastcmp_ci(pat,m2,m1);
       else
            g=h=str_lastcmp(pat,m2,m1);
       suff[m2]=g;
       g1=g+1;
     for(i=m2-1;i>=0;i--){
       if((h>0)&&((g>0)||(h>1))){
         if(h<=g1)
             h--;
         else
            h=g;
       }
      else{
        if(case_i)
             h=str_lastcmp_ci(pat,i,m1);
            else
             h=str_lastcmp(pat,i,m1);
         }
      suff[i]=h;
    }  
  }

void pre_bmGs( unsigned char *pat, int m, Reg int bmGs[]){
 Reg int *suff;
      ptr v;
    Reg int i;
     int j,m1=m-1;
      v=make_alloc_bin(m*sizeof(int));
      suff=(int *)get_alloc(v,&j);
       psh(v);
      suffixes(pat,m,suff);
      j=0;
     for(i=0;i<m;i++)
         bmGs[i]=m;
     for(i=m1;i> -2;i--){
       if((i==-1)||(suff[i]==i+1)){
         while(j< m1-i){
            if(m==bmGs[j]) bmGs[j]=m1-i;
            j++;
         }
        }
      }
     for(i=0;i<m1;i++)
       bmGs[m1-suff[i]]=m1-i;
    pull();
  }

/***   index is the top of euc ???  ***/
int euc_index( Reg unsigned char *p,Reg int ind){
  int x=p[ind],k=0;
  if(x<0x80) return YES;
  while(1){
    x=p[--ind];
    k++;
    if(x<0x80) return (k&1);
    if(ind==0) return ((k&1)==0);
    }
}

ptr conv_euc_index(ptr indlis,unsigned  char *txt){
  ptr lis=indlis,prev;
  unsigned char *dest=txt,*now=txt;
  int ind=0,x;
    prev=lis;
    lis=CDR(lis);
  while(CONSP(lis)){
    x=GETNUM(CAR(lis));
    dest=txt+x;
    while(now<dest){
     x=*now++;
     if(x>=0x80) now++;
     ind++;
   }
  if(now==dest)
      CAR(lis)=MAKESINT(ind);
  else
     CDR(prev)=CDR(lis);
   prev=lis;
  lis=CDR(lis);
 }
  return CDR(indlis);
}  

int strcmpBM(unsigned char *pat,unsigned char *txt, int ind){
  if(case_i)
    while((ind>=0)&&(tolower(*pat--)==tolower(*txt--))) ind--;
  else
     while((ind>=0)&&(*pat--==*txt--)) ind--;
  return ind;
}

ptr BM (unsigned char *pat, int m, unsigned  char *txt,int n,int prev){
  int i,j=0,sh;
  Reg int *bmGs;
      ptr v,res;
        /*** printf("BM m %d  n %d\n",m,n);  ***/
   if(!prev){
    v=make_alloc_bin(m*sizeof(int));
      bmGs=(int *)get_alloc(v,&i);
         CDR(prev_str)=v;
      psh(v);
      res=v=CONS(a_nil,a_nil);
      psh(v);
     pre_bmGs(pat,m,bmGs);
     pre_bmBc(pat,m);
     }
    else{
         v= CDR(prev_str);
         bmGs=(int *)get_alloc(v,&i);
         psh(v);
         res=v=CONS(a_nil,a_nil);
         psh(v);

     }
    while(j<=n-m){
      i=m-1;
        /*** printf("loop 1  i %d  j %d\n",i,j);  ***/
      i=strcmpBM(pat+i,txt+i+j,i);
     if(i<0){
        /**** printf("Found! %d\n",j);  ****/
       if(kanji_mode){
          if(euc_index(txt,j)){
             v=CDR(v)=CONS(MAKESINT(j),a_nil);
            if(!repeat_f) goto bmend;
          }
       }
      else{
         v=CDR(v)=CONS(MAKESINT(j),a_nil);
         if(!repeat_f) goto bmend;
      }
       j+=bmGs[0];
     }
     else{
         sh=bmBc[txt[i+j]]+i+1-m;
         if(sh<bmGs[i]) sh=bmGs[i];
       /*** printf("Not Found sh %d\n",sh);  ***/
         j+=sh;
      }
    }
  pull();
  pull();
 if(!repeat_f) return a_f;
  if(kanji_mode) res=conv_euc_index(res,txt);
  else
       res=CDR(res);
  if(last_f){
        res=last_pair(res);
        if(res!=a_f) return CAR(res);
   }
  return res;
bmend:
   pull();
   pull();
   if(kanji_mode){
      res=conv_euc_index(res,txt);
   }
   else
      res=CDR(res);
  if(res!=a_nil) return CAR(res);
   return a_f;
}

static void BM_flag(ptr key)
{
    if(key==k_nocase) {
             case_i=1;
     }
    else if(key==k_ci) {
             case_i=1;
     }
    else  if(key==k_repeat) {
             repeat_f=1;
     }
    else  if(key==k_last) {
             repeat_f=1;
             last_f=1;
      }
   else 
     error(E_keyword,key);
}

ptr simple_search(Reg int c, unsigned char *p, int n){
  Reg unsigned char *q=p;
  ptr res,v;
  res=v=CONS(a_nil,a_nil);
  psh(res);
  if(case_i){
     c=tolower(c);
     while(n>0){
      if(tolower(*q++)==c){
          v=CDR(v)=CONS( MAKESINT((int)(q-p-1)),a_nil);
         if(!repeat_f) goto end;
      }
      n--;
     }
    
   }
  else{
    while(n>0){
       if(*q++==c){ 
          v=CDR(v)=CONS( MAKESINT((int)(q-p-1)),a_nil);
         if(!repeat_f) goto end;
       }
      n--;
     }
  }
  pull();
  if(!repeat_f) return a_f;
  if(kanji_mode) res=conv_euc_index(res,p);
  else
       res=CDR(res);
  if(last_f){
        res=last_pair(res);
        if(res!=a_f) return CAR(res);
   }
  return res;
end:
  pull();
  if(kanji_mode) 
       res= conv_euc_index(res,p);
   else
       res=CDR(res);
    if(res!=a_nil) return CAR(res);
   return a_f;
}

void get_s2(int narg,int len2,int *s2,int *e2)
{
  int index,k,end,kmode=kanji_mode,n;
  ptr *base,start,endp;
  *s2=0;
  *e2=len2;
  if(narg==0) return;
  base=stack-narg;
  start=*base++;
  narg--;
  end=len2;
  if(SINTP(start))
     *s2=SINT_NUMB(start);
  else if(start==k_end){
     if((narg>0)&&(SINTP(*base))) {
         n=SINT_NUMB(*base);
         if(n<0){
            end+=n;
            base++;
            narg--;
         }
     }
     *s2=end;
 }
else {
      BM_flag(start);
   goto BMFLAG;
}
if(*s2>len2) error(E_range,start);
if(narg==0) return;
 start=*base++;
  narg--;
  end=len2;
  if(SINTP(start))
     *e2=SINT_NUMB(start);
  else if(start==k_end){
     if((narg>0)&&(SINTP(*base))) {
         n=SINT_NUMB(*base);
         if(n<0){
            end+=n;
            base++;
            narg--;
         }
     }
     *e2=end;
 }
else
      BM_flag(start);
if(*s2>*e2) error(E_range,start);
BMFLAG:
  while(narg>0){
      BM_flag(*base++);
      narg--;
  }
}


ptr s_stringBM(int narg,ptr env){
 Reg ptr pat,txt,k,*base;
 Reg  unsigned char *p,*q;
 int n,m,prev=1,kmode=kanji_mode,end2,s2;
     case_i=0;
     repeat_f=0;
     last_f=0;
   if(narg<2)
   checknarg(narg-2);
    base=stack-narg;
    pat=*base++;
  if(SREGP(pat)||!STRINGP(pat)) error(E_notstr,pat);
    txt=*base++;
  if(SREGP(txt)||!STRINGP(txt)) error(E_notstr,txt);
  p=get_string(pat,&m);
  q=get_string(txt,&n);
  end2=n;
  narg-=2;
  if(kmode){
        kmode=1;
        end2=jstrlength(q,n);
          if((end2==-1)||(end2==n)) {
               end2=n;
               kmode--;
          }
    }
   get_s2(narg,end2,&s2,&end2);
  /*** printf("s2 %d end2 %d \n",s2,end2); ***/
  if(m==0){
       k=ZERO;
       goto BMOUT;
   }
  if(kmode){
      q=jindex(q,s2,n);
      n=jindex(q,end2-s2,n)-q;
   }
   else{
    q+=s2;
    n=end2-s2;
   }
  /** printf("q %s  n %d \n",q,n); ***/

  if(m==1){
         k=simple_search(*p,q,n);
         goto BMOUT;
   }
  if(prev_str){
         if((prev_case_i!=case_i)||(CAR(prev_str)!=pat)) prev=0;
   }
  else{  /*** only once ***/
      prev=0;
       sysprotect[syspro++]=prev_str=CONS(a_nil,a_nil);
   }
  k=BM(p,m,q,n,prev);
   CAR(prev_str)=pat;
   prev_case_i=case_i;
 BMOUT:
  if(s2&&SINTP(k)){
     s2+=GETNUM(k);
     k=MAKESINT(s2);
  }
   return k;
}


