/***  system.c    ***/
/***  2005.3.21   stat()  ->  stat64()  for big file!!! ***/
/***  see Makefile.am   we use  -D_FILE_OFFSET_BITS=64   for gcc ***/
/*** struct stat64  is defined in /asm/stat.h  ***/

/***  ???  correct???? ***/
/***
#define __USE_LARGEFILE64
#define __USE_FILE_OFFSET64
#define _LARGEFILE64_SOURCE
***/
/***  ***/

#include "lisp.h"
#include <errno.h>
/** #include <glob.h>  ***/
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <stdlib.h>
#include <unistd.h>    /*** for copy-file read,write  ***/
#include <fcntl.h>    /*** for copy-file read,write  ***/
#include <stdio.h>
#include <signal.h>
#include <string.h>

#define ARGMAX 255

extern ptr setpwd();

extern ptr k_wait;

static char *argv[ARGMAX+1];

int sh_system (const char *command) {
        extern char **environ;
           int pid, status;
    
           if (*command == 0)
               return 1;
           pid = fork();
           if (pid == -1)
               return -1;
           if (pid == 0) {
               argv[0] = "sh";
               argv[1] = "-c";
               argv[2] = (char *)command;
               argv[3] = 0;
               execve("/bin/sh", argv, environ);
               exit(127);
           }
           do {
               if (waitpid(pid, &status, 0) == -1) {
                   if (errno != EINTR)
                       return -1;
               } else
                   return status;
           } while(1);
       }

static int check_arg(ptr x)
{
   if(SREGP(x)) error(E_illegal,x);
   if(STRINGP(x)) return 0;
   if(x==k_wait)  return 1;
   error(E_illegal,x);
}

ptr run_process(int narg,ptr env) {
         extern char **environ; 
           int n,pid, status,len,waitf,args;
           ptr *sfree;
           char *p;
           if(narg>ARGMAX) error(E_argover,MAKESINT(ARGMAX));
           sfree=stack-narg;
           args=waitf=n=0;
              while(n<narg){
                if(check_arg(*sfree)){
                     waitf=1;
                     sfree++;
                }
               else{
                   p = (char *)get_string(*sfree++,&len);
                   if(len){
                     argv[args++] =p;
                     /** printf("argv %d %s \n",args-1,argv[args-1]);***/
                   }
                }
                n++;
              }
               argv[args] = NULL;
           if(args==0) error(E_shortarg,ZERO);

           pid = fork();
           if (pid == -1){
               error(E_fork,SEOF);
               return SEOF;
           }
           if (pid == 0) {
               /*** I am child process! ***/
               /*** execve(argv[0], argv,environ); ***/
               execvp(argv[0], argv);
               printf("error exit %s\n",argv[0]);
               exit(127);/*** terminated children by a error ***/
           }
         if(waitf)
           do {
               if (waitpid(pid, &status, 0) == -1) {
                   if (errno != EINTR)
                       return SEOF;
               } else{
                   if(status){
                        perror("run-process");
                        return a_f;
                    }
                   return a_undef;  /** MAKESINT(status); ***/
               }
                   /*** return a_t;  * status ***/
            } while(1);
         
      return CONS(MAKESINT(pid),a_f);  /*** #f is alive ***/
       }

ptr s_system(int narg,ptr env){
 ptr s=*(stack-1);
 char *p;
 int n;
   checknarg(narg-1);
   if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
   p=(char *)get_string(s,&n);
   n=sh_system(p);
   if(n==-1){
      error(errno,s);
   }
   return MAKESINT(n);
}


ptr s_chdir(int narg,ptr env){
 ptr s=*(stack-1);
 char *p,*q;
 int n;
   checknarg(narg-1);
   if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
   p=(char *)get_string(s,&n);
   if(*p=='~'){
       q=(char *)get_string(CAR(a_home),&n);
       strncpy(iobuff,q,n);
       strncpy(iobuff+n,p+1,200);
       p=iobuff;
   }
   n=chdir(p);
   if(n){
      /** error(errno,s); ***/
      error(E_illegal,s);
   }
   setpwd();
   return a_undef;
}
  
ptr s_getcwd(int narg,ptr env){
 char *p=iobuff;
 int n;
   checknarg(narg);
   return setpwd();
  /*** getcwd(p,MAXIO);
   return make_str_c(p);
   ***/
}


ptr s_getenv(int narg,ptr env){
 ptr s=*(stack-1);
 char *p;
 int n;
   checknarg(narg-1);
   if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
   p=(char *)get_string(s,&n);
   p=getenv(p);
   if(p){
      /** printf("env %s\n",p);  **/
      /** p=index(p,'='); **/
      return make_str_c(p);
   }
   return a_f;
}

ptr s_setenv(int narg,ptr env){
 ptr s=*(stack-2),v;
 char *p,*q;
 int n;
   checknarg(narg-2);
   if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
   v=*(stack-1);
   if(SREGP(v)||!STRINGP(v)) error(E_notstr,v);
   p=(char *)get_string(s,&n);
   q=(char *)get_string(v,&n);
   setenv(p,q,YES);  /*** overwite ***/
   return a_undef;
}

/*****     file stat, time   ***/
static struct stat   stat_buf;

/***  return -1 if not exists  ***/
int get_filestat(char *p){
   return lstat(p,&stat_buf);
}

int get_file_mode(char *p){
   int n;
   n=lstat(p,&stat_buf);   /***  stat ->lstat for symbolic link  ***/
   if(n==-1) return n;
   return stat_buf.st_mode;
}

int is_directory(char *p){
  int n;
  n=get_file_mode(p);
  if(n==-1) return 0;
  return ((n&S_IFMT)==S_IFDIR);
}

int is_regular(char *p){
  int n;
  n=get_file_mode(p);
  if(n==-1) return 0;
  return ((n&S_IFMT)==S_IFREG);
}

int is_slink(char *p){
  int n;
  n=get_file_mode(p);
  if(n==-1) return 0;
  return ((n&S_IFMT)==S_IFLNK);
}

int is_fifo(char *p){
  int n;
  n=get_file_mode(p);
  if(n==-1) return 0;
  return ((n&S_IFMT)==S_IFIFO);
}

int is_executable(char *p){
  int n;
  n=get_file_mode(p);
  if(n==-1) return 0;
  return ((n&S_IFMT)==S_IFREG)&&((n&S_IEXEC)!=0);
}


char *get_date(time_t *timep){
  char *p,*q=iobuff;
  struct tm *loc;
   loc=localtime(timep);
  /** printf("get_data  timep %x loc %x\n",timep,loc); ***/
   p=asctime(loc);
   while(*q++=*p++);
   *(q-2)=0;/*** erase \n  ***/
   return iobuff;
}

ptr s_filestat(int narg,ptr env){
 ptr s=*(stack-1),m,size,date;
 char *p;
 unsigned int big;
 char *get_date();
 time_t n;  /***  unsigned int in 32 bit system , but in 64 bit OS its 64 bit  **/
   /*** that is long!***/

#ifdef __USE_FILE_OFFSET64
/*** printf("Large  file Supported\n"); * debug ***/
#endif
   checknarg(narg-1);
   if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
   p=(char *)get_string(s,&n);
   n=lstat(p,&stat_buf);
   if(n==-1){
      return a_f;
   }
 n=stat_buf.st_mode;  
  m=MAKESINT(n); /*** 16bit ***/
  n=stat_buf.st_size;
   /** printf("size %d\n",sizeof(stat_buf.st_size));    return 8 =64 bits stat64 ***/
#ifdef __USE_FILE_OFFSET64
 big=*(((int *)(&stat_buf.st_size))+1); /*** lower 32 bit is the high!  **/
   /*** printf("big %x size %x\n",big,n);  ***/
#else
 big=0;
#endif
  if(big||(n>0x1fffffff))  /*** over 29 bit **/
    size=bignum64(big,n);
  else
     size=check16(bignum(n));
  psh(size);
  n=stat_buf.st_mtime;
  date=check16(bignum(n));
  psh(date);
  p=get_date(&n); 
   /*** printf("time ascii %s\n",p);  ***/
  s=make_str_c(p);
  psh(s);
  s=CONS(s,a_nil);
  s=SCONS(date,s); 
  s=SCONS(size,s); 
  s=SCONS(m,s); 
  stack-=3;
   return s;
}

ptr s_pidstate(int narg,ptr env)
{
  ptr spid,res;  /*** new ***/
  int n,pid,statloc;
   checknarg(narg-1);
   spid=*(stack-1);
   if(SREGP(spid)){
       pid=GETNUM(spid);
       spid=0;
   }
   else {   /*** (pid . state) ***/
      if(CDR(spid)!=a_f) return CDR(spid);
       pid=GETNUM(CAR(spid));
  }
   n=waitpid(pid,&statloc,WNOHANG);
   /*** printf("%d %d %d %d %X\n",n,pid,   **/
   /***      WIFEXITED(statloc),WIFSIGNALED(statloc),statloc);***/
   if(n==pid){
          /*** end  ***/
        if(WIFEXITED(statloc)) res=a_t;
        else if(WIFSIGNALED(statloc))
             res=MAKESINT(WTERMSIG(statloc));
        else res=ZERO;
       if(spid) CDR(spid)=res;
       return res;
   }
   return a_f;
}
    
ptr s_kill(int narg,ptr env)
{
  ptr spid;
  int n,pid,sig;
   if(narg==1) {
      spid=*(stack-1);
      sig=SIGTERM; 
   }
   else{
      checknarg(narg-2);
      spid=*(stack-2);
      sig=GETNUM(*(stack-1));
   }
   if(SREGP(spid))
       pid=GETNUM(spid);
   else
       pid=GETNUM(CAR(spid));
   n=kill(pid,sig);
   if(n) return a_f;
   return a_t;
}   

ptr s_is_directory(int narg,ptr env)
{
 int n;
 ptr file;
 char *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  n=is_directory(p);
 return PRED(n>0);
}

ptr s_is_regular(int narg,ptr env)
{
 int n;
 ptr file;
 char *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  n=is_regular(p);
 return PRED(n>0);
}

ptr s_is_fifo(int narg,ptr env)
{
 int n;
 ptr file;
 char *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  n=is_fifo(p);
 return PRED(n>0);
}


ptr s_is_executable(int narg,ptr env)
{
 int n;
 ptr file;
 char *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  n=is_executable(p);
 return PRED(n>0);
}

ptr s_is_slink(int narg,ptr env)
{
 int n;
 ptr file;
 char *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  n=is_slink(p);
 return PRED(n>0);
}

ptr s_read_slink(int narg,ptr env)
{
 int n;
 ptr file;
 char *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  n=readlink(p,iobuff,MAXIO);
  if(n<0) return a_f;
  *(iobuff+n)=0; 
  return CMAKESTR(iobuff);
}

/****  file operation  ***/
ptr s_remove_file(int narg,ptr env)
{
 int n;
 ptr file;
 char *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  n=remove(p);
  if(n<0) return a_f;   /**** to be modify errror!!! ***/
 return a_t;
}

ptr s_rename_file(int narg,ptr env)
{
 int n;
 ptr file,new;
 char *p,*q;
 checknarg(narg-2);
  file=*(stack-2);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  new=*(stack-1);
  if(SREGP(new)||!STRINGP(new)) error(E_notstr,new);
  q=(char *)get_string(new,&n);
  n=rename(p,q);
  if(n<0) return a_f;   /**** to be modify errror!!! ***/
 return new;
}

ptr s_copy_file(int narg,ptr env)
{
 int n,in,k;
 ptr file,new;
 char *p,*q;
 checknarg(narg-2);
  file=*(stack-2);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  new=*(stack-1);
  if(SREGP(new)||!STRINGP(new)) error(E_notstr,new);
  q=(char *)get_string(new,&n);
  /*** if(get_filestat(q)!=-1)  error(E_open,new);    copy is always allowed !!! ****/
  /***  if safety is need, it should be handled in user program  ***/
  in=open(p,O_RDONLY);
  k=open(q,O_WRONLY|O_CREAT,get_file_mode(p));
  if(in<0)  error(E_open,new);
  if(k<0)  error(E_open,new);
  while(1){
   n=read(in,iobuff,MAXIO); 
   if(n<=0) break;
   write(k,iobuff,n);
  }
  close(in);
  close(k);
  /*** if(n<0) return a_f;  *** to be modify errror!!! ***/
 return new;
}

ptr s_mkdir(int narg,ptr env)
{
 int n;
 ptr file;
 char *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  n=mkdir(p,S_IRUSR|S_IWUSR|S_IXUSR|S_IRGRP|S_IXGRP|S_IROTH|S_IXOTH);
  if(n<0) return a_f;   /**** to be modify errror!!! ***/
 return file;
}

ptr s_rmdir(int narg,ptr env)
{
 int n;
 ptr file;
 char *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  n=rmdir(p);
  if(n<0) return a_f;   /**** to be modify errror!!! ***/
 return a_t;
}

ptr s_unlink(int narg,ptr env)
{
 int n;
 ptr file;
 char *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=(char *)get_string(file,&n);
  n=unlink(p);
  if(n<0) return a_f;   /**** to be modify errror!!! ***/
 return a_t;
}

ptr s_link(int narg,ptr env)
{
 int n;
 ptr file,new;
 Uchar *p,*q;
 checknarg(narg-2);
  file=*(stack-2);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  new=*(stack-1);
  if(SREGP(new)||!STRINGP(new)) error(E_notstr,new);
  p=get_string(file,&n);
  q=get_string(new,&n);
  n=link((char *)p,(char *)q);
  if(n<0) return a_f;   /**** to be modify errror!!! ***/
 return a_t;
}
static char temp_file[]="Temp-XXXXXX";

ptr s_make_temp(int narg,ptr env)
{
 char  file[256];
 int n=-1;
 Uchar *p;
 checknarg(narg);
  strncpy(file,temp_file,13);
  n=mkstemp(file);
  if(n<0){
      p=get_string(a_startdir,&n);
      strncpy(file,(char *)p,n);
      p=(Uchar *)(file+n);
      *p++='/';
      strncpy((char *)p,temp_file,13);
      n=mkstemp(file);
  }
  if(n<0){
      p=get_string(ATOMVAL(a_home),&n);
      strncpy(file,(char *)p,n);
      p=(Uchar *)(file+n);
      *p++='/';
      strncpy((char *)p,temp_file,13);
      n=mkstemp(file);
  }
  if(n<0) {
       getcwd(iobuff,100); 
       printf("system error %d %s %s  %s \n ",errno,strerror(errno),iobuff,file);
       s_bye();
   }
  /***  if(n<0) return a_f;   ** to be modify errror!!! ***/
  close(n);
  /*** printf("path %d file %s\n",n,file);***/
 return CMAKESTR(file);
}

ptr s_getpid(int narg,ptr env)
{
 int n;
 char *p;
 checknarg(narg);
  n=getpid();
 return MAKESINT(n);
}

ptr s_mkfifo(int narg,ptr env)  /** 2005.3.17  P.107 unix system call prog ***/
{
 int n;
 ptr file;
 Uchar *p;
 checknarg(narg-1);
  file=*(stack-1);
  if(SREGP(file)||!STRINGP(file)) error(E_notstr,file);
  p=get_string(file,&n);
  n=mknod((char *)p,S_IFIFO|0666,0);
  if(n<0) return a_f;   /**** to be modify errror!!! ***/
 return file;
}

ptr s_startdir(int narg,ptr env)
{
 int n;
 char *p;
 checknarg(narg);
 return a_startdir;
}

