/****  tk_eval.c
    use tcl_Invoke version
   created 03.10.30 
***/
#define  TK_EVAL_C

#include "lisp.h"
#include <tcl.h>
#include <string.h>

extern Tcl_Interp *myInterp;
#define B_SIZE  8000    /***  all tk-cmds take 2600 bytes ***/ 
extern ptr get_ss_obj(),k_T;

extern ptr Tcl_Invoke();

#define ECHO if(tcl_echo)

static int tclbusy=0; 
/***  tcleval look this don't work because tkwait exists ***/

int bind_plus;
ptr bind_func;
int conv_level=-1;
static int toplevel_flag=0;

char tkcmdbuf[B_SIZE]; /*** ss cmds & use for debug of tcl return  ***/
ptr tcleval();

int tkreturn=0;  /****  tk  return bytes  for debug ***/

ptr s_tcleval();
static ptr tk_make_cmd(),s_tk_invoke_create(),s_tk_eval_create();

root_deiconify(){
   char  p[]="wm deiconify .";
   psh(CMAKESTR(p));
   s_tcleval(1,a_nil);
   /** update(); **/
   pull();
}

update(){  /** tcl update **/
   int memo=tcl_echo;
   tcl_echo=0;
   psh(a_update);
   s_tcleval(1,a_nil);
   pull();
   tcl_echo=memo;
}

int tk_visible(int k){
   int n;
/***      p="wm deiconify \".\"";
      Tcl_Eval(myInterp, p);
   Tcl_ResetResult(myInterp);
      p="update";
      Tcl_Eval(myInterp, p);
   Tcl_ResetResult(myInterp);
  ***/
     n=top_visible; /*** k>0 then in mc.c , event update occur ***/
   if(n==2)
       return 2;  /*** allready  all visible  **/
   else     
     top_visible=k; /*** k>0 then in mc.c , event update occur ***/
   return n; /*** previous value ***/
}

ptr s_top_visible(int narg,ptr env){
  return PRED(top_visible);
}

ptr s_tcleval(int narg,ptr env){
 Reg ptr s;
 char *p,*q=tkcmdbuf;
 int n,len;
   ptr tcleval();

  checknarg(narg-1);
  s=*(stack-1);
     if(SREGP(s)||!STRINGP(s)){
               lwritestr(STDERR,"tcleval error! ");
               error(E_notstr,s);
         }
   p=(char *)get_string(s,&n);
    ECHO
    printf("  TCL-command   %s\n",p); 
     return  tcleval(s,p,n);
}

ptr tcleval(ptr s,char *p,int len){
 int code;
 char *q=tkcmdbuf;
 const char *result;
 int n=len;
  Tcl_DString argString;
    /****  contents of p may be changed by interp , so copy used ***/
  if(n<B_SIZE-1){
     while(n--) *q++=*p++;
     *q=0;
     p=tkcmdbuf;
     n=len;
  }
 else{
      s=copy_str(s);
     p=(char *)get_string(s,&n);
  }

  /****  convert to UTF code used in TCL  ***/
  
  p=Tcl_ExternalToUtfDString(NULL, p, len, &argString);
  code=Tcl_Eval(myInterp, p);
  Tcl_DStringFree(&argString);
  /******   result  ***/
     result=Tcl_GetStringResult(myInterp);  //8.6 
   if (code != TCL_OK) {
     lwritestr(STDOUT,"**** TCL error ****\n");
     //lwritestr(STDOUT,myInterp->result);
     lwritestr(STDOUT,result);  //8.6
     newline(STDOUT);
     Tcl_ResetResult(myInterp);
     error(E_tcl,s);
     return a_undef;
   }
 ECHO
 { 
  //printf(" tcleval result address %lx\n",(UL)myInterp->result);
  printf(" tcleval result address %p\n",result);  //8.6
  //printf(" tcleval result %s\n",myInterp->result);
  printf(" tcleval result %s\n",result);  //8.6
 }

  //n=strlen(myInterp->result);
  n=strlen(result); //8.6
    /**  printf(" tcleval result length %d\n",strlen(myInterp->result));***/
    /****  see error.c  ***/
     tkreturn=n;
     //strncpy(tkcmdbuf,myInterp->result,B_SIZE-1);
     strncpy(tkcmdbuf,result,B_SIZE-1);
    /***  these two lines for debug ***/
  //s=get_ss_obj(myInterp->result,conv_level);
  s=get_ss_obj(result,conv_level);  //8.6
  ECHO
    printf(" get_ss_obj  %lx\n",(UL)s);   
   Tcl_ResetResult(myInterp);
  /*** Tk_UpdateObjCmd(NULL, myInterp, 1, NULL);  ***/
  return s;
}

static ptr bind_env_set(ptr key,ptr env){
  ptr x,b,c;
  psh(key);
  x=assq(k_bind,env);
  b=assoc(key,CDR(x));
  if(b==a_f){
     c=SCONS(key,SCONS(bind_func,a_nil));
      CDR(x)=SCONS(c,CDR(x));
   }
  else if(bind_plus==0)
    CDR(b)=SCONS(bind_func,a_nil);
  else  /*** plus  ***/
    CDR(b)=SCONS(bind_func,CDR(b));  
  pull();
  return env;
}
  
static ptr key_env_set(ptr key,ptr s,ptr env){
  ptr x;
  x=assq(key,env);
  if(CONSP(x)) CDR(x)=s;
  else{
    psh(env);
    x=SCONS(key,s);
    env=SCONS(x,env);
    pull();
  }
  return env;
}

static ptr key_env_set_econf(ptr key,ptr s,ptr env,ptr ent){
      /****  entryconfigure  entry :command   ***/
  ptr x,y;
  x=assq(key,env);
  if(CONSP(x)) {
       y=assoc(ent,CDR(x));
       if(CONSP(y))
           CDR(y)=s;
       else{
         y=SCONS(ent,s);
         CDR(x)=SCONS(y,CDR(x));
      }
  }
  else{
    psh(env);
    y=SCONS(ent,s);
    y=SCONS(y,a_nil);
    x=SCONS(key,y);
    env=SCONS(x,env);
    pull();
  }
  return env;
}

static ptr key_env_set_addmenu(ptr key,ptr s,ptr env){
      /****  entryconfigure  entry :command   ***/
  ptr x,y;
  x=assq(key,env);
  if(CONSP(x)) {
         CDR(x)=SCONS(s,CDR(x));
  }
  else{
    psh(env);
    y=SCONS(s,a_nil);
    x=SCONS(key,y);
    env=SCONS(x,env);
    pull();
  }
  return env;
}


static ptr key_env_noset(ptr key,ptr env){
  ptr x;
  x=assq(key,env);
  if(!CONSP(x)){
    psh(env);
    x=CONS(key,a_nil);
    env=SCONS(x,env);
    pull();
  }
  return env;
}

static ptr make_fenv(ptr name,ptr env){
  psh(env);
   name=SCONS(k_T,name);
   env=SCONS(name,env);
  pull();
 return env;
} 

static ptr key_env_init(ptr env){
  env=key_env_noset(k_command,env); /***  at least :command  must be saved!  ***/
  env=key_env_noset(k_xscroll,env); 
  env=key_env_noset(k_yscroll,env); 
  env=key_env_noset(k_invalid,env); 
  env=key_env_noset(k_invcmd,env); 
  env=key_env_noset(k_validate,env); 
  env=key_env_noset(k_vcmd,env); 
  env=key_env_noset(k_bind,env); 
  env=key_env_noset(k_postcommand,env); 
  env=key_env_noset(k_tearoffcommand,env); 
  return env;
}

/**** exec  (tcl "name arg1....")  name is taken from env typically  button,
  after this
  if return-value is same as arg1 & arg1 is widget-name
  arg1 (widget-name) 's value is set to  s_tk_make_exec arg1 ....  

 ***/

int key_command(ptr key){
 if((key==k_command)||(key==k_xscroll)||(key==k_yscroll)) return YES;
 if((key==k_invalid)||(key==k_invcmd)||(key==k_validate)||(key==k_vcmd)) return YES;
 if((key==k_postcommand)||(key==k_tearoffcommand)) return YES;
 return NO;
}

static ptr s_tk_exec_create(int narg,ptr env){
 Reg ptr s,*sfree;
 Reg int n,c;
 n=narg;
   ECHO
     printf("tk_exec_create\n");
   s=CDR(assq(k_widget_name,env));
   if(s==a_bind||s==a_after) 
         return s_tk_eval_create(narg,env);   /****  bind   ***/

   if(s==a_toplevel){
       /** printf("toplevel executed!\n"); **/
      toplevel_flag=1;
    }
   else
      toplevel_flag=0;

 sfree=stack-narg;
 if(narg>3){
    if(*sfree==a_bind||*(sfree+1)==a_bind)
         return s_tk_eval_create(narg,env);   /****  canvas bindi,txt tag bind ***/
 }
 c=0;
 while(n--){
  s=*sfree++;
  if(!SREGP(s)&&KEYWORDP(s)){
           c=key_command(s);
        if(c) break;
  }
}
 if(c) 
     return s_tk_eval_create(narg,env);   /****  bind   ***/
   return s_tk_invoke_create(narg,env);   /****  bind   ***/
}

static ptr s_tk_eval_create(int narg,ptr env){
 Reg ptr s,v,name,wname,arg1,arg3,res,*sfree,*memo,key=0,op,class,lkvar;
 int n,len,flag,econfig,offvalue,canvas_bind,addmenu,memonarg;
 Uchar *p;
   ptr assq(),assq2();
   arg1=arg3=NULL;
   name=CDR(assq(k_widget_name,env));
   ECHO
     prin1(name,STDOUT);
   wname=CDR(assq2(k_widget_name,env));
   if(tcl_echo&&(wname!=a_f)){
       newline(STDOUT);
       prin1(wname,STDOUT);
   }
   if(name==a_bind) bind_plus=0;   /**** for bind  + script   ***/
   else bind_plus=-1;
   bind_func=(ptr)0;
   offvalue=canvas_bind=0;
   conv_level=-1;
   memo=sfree=stack-narg;
   memonarg=narg;
   if(narg)
      op=*sfree;
   else
      op=a_undef;
   if(op==a_bind) {
        bind_plus=0;  /*** canvas bind ***/
        canvas_bind=1;
   }
   if((narg>3)&&(*(sfree+1)==a_bind)){
       bind_plus=0;
       canvas_bind=2;/*** txt tag bind ***/
   }
   if(op==a_configure&&narg==1) conv_level=2;  /*** (path 'configure) ***/
   if((econfig=(op==a_entryconfigure))&&narg==2){
             conv_level=2;  /*** (path 'entryconfigure <entry>) ***/
    }
   if(op==a_get){
     if(wname==a_listbox)
           conv_level=narg-2;
     else  if(wname==a_entry||wname==a_text)
           conv_level=0;
   }
   if(op==a_dump)  /*** txt 'dump :command  ***/
       conv_level=-4000;
   addmenu=(op==a_add);

   env=key_env_init(env);
   psh(a_nil);  /*** for v ***/
   psh(a_nil);  /*** for arg1 ***/
   psh(env);
   res=ss_tkstr(name,env,NO);
   psh(res);
   len=narg;
   while(narg--){
   *(stack-1)=res=str_append(res,a_str_space);
    s=*sfree++;
    if(key) {
         if(econfig)  /*** entryconfigure ***/
            *(stack-2)=env=key_env_set_econf(key,s,env,*(memo+1));   /***  save command etc ***/
         else if(addmenu)
            *(stack-2)=env=key_env_set_addmenu(key,s,env);   /***  save command etc ***/
         else
            *(stack-2)=env=key_env_set(key,s,env);   /***  save command etc ***/
         if(key==k_offvalue&&(s==a_f)) offvalue=1;
          if(key==k_variable||key==k_textvar||key==k_textvariable||key==k_listvar||key==k_var){
                flag=1;    /**** とりあえず  ****/
               v=ATOMVAL(s);
               if(SREGP(v)||!(ATTR(v)&TKOBJ)){
                  if(v==a_unbdd||v==a_undef)
                      ATOMVAL(s)=lkvar=make_tklink(s,a_nullstr,flag);
                  else
                      ATOMVAL(s)=lkvar=make_tklink(s,v,flag);  /****  to be modified?  ***/
               }
           }
           v=ss_tkstr(s,env,key_command(key));
         key=0;
    }
   else{
       v=ss_tkstr(s,env,NO);  /*** may be bind_func set here  ***/
       if(bind_func){
           psh(v);
           class=a_nil;
           psh(class);
           if(canvas_bind){   /**** there were bugs for text tag bind fixed 2005.2.21 ***/
                s=*(memo+3);
               narg=memonarg-canvas_bind-1;
               memo+=canvas_bind;
               while(narg>0){
                  class=*(stack-1)=SCONS(*memo++,class);
                  narg--;
               }
           }
           else{
               *(stack-1)=class=ss_tkstr(*memo,env,NO);
               *(stack-1)=class=SCONS(class,s=*(memo+1));
           }
           bind_env_set(class,env);
          pull();
          pull();
       }
   }
     if(!SREGP(s)&&KEYWORDP(s)){
       key=s;
       if(op==a_cget&&key==k_text) conv_level=0;  /*** cget ***/
     }
    if(arg1==NULL) {
           arg1=v;
           *(stack-3)=v;
       }
   *(stack-4)=v;
   *(stack-1)=res=str_append(res,v);
   }
   if(offvalue) CAR(lkvar)=(ptr)(STRING|BOOLEAN);    /****  BOOlean linkvar ***/
  res=s_tcleval(1,env);
  conv_level=-1;
  if(name==a_image&&len>2&&*memo==a_create){
     arg3=*(memo+2);
   }
  stack-=4;
 /*** prin1(arg1,STDOUT); ***/
  /*** printf("after tcleval res %x\n",res); ***/
  if(res==a_undef) return a_undef;   /**** this is TCL error  ***/
  /*** if((arg1==0)||(string_equal(arg1,res)==a_f)) return res;***/
  if(SREGP(res)) return res;
  if(res==a_nil||NUMBERP(res)||KEYWORDP(res)||CONSP(res)) return res;
  /*** printf("after1.5\n");  ***/
  if(arg3)
     s=arg3;
  else{
    if((arg1==0)||(string_equal(arg1,res)==a_f)) return res;
      s=*memo;
   }
  if(SREGP(s)||!SYMBOLP(s)) return res;  /** rror(E_notsymb,s); ***/
  p=get_string(PNAME(s),&n);
  if(*p!='.'&&(arg3==NULL)) return res;  /***   not widget! ***/
  /** printf("tcl make cmd %x\n",res); **/
  if(arg3) len-=2;
   env=make_fenv(s,env);
  res=tk_make_cmd(len,env);  /**** must keep env for gbc, check tk_make_cmd  below****/
  ATOMVAL(s)=res;   /*** always global bind  ***/
  return s;
}


/***  10.20   set conversion level for some 
  special calls,   see note-tk
***/

/****  ONLY simple conversion needs ***/
static ptr s_tk_invoke_create(int narg,ptr env){
 Reg ptr s,v,name,wname,arg1,arg3,res,*sfree,*memo,key=0,op,class,lkvar,*pro;
 int n,len,flag,econfig,offvalue;
 Uchar *p;
   ptr assq(),assq2();
   arg1=arg3=NULL;
   name=CDR(assq(k_widget_name,env));
   ECHO
     {
      printf("tk_invoke_create\n");
      prin1(name,STDOUT);
    }
   wname=CDR(assq2(k_widget_name,env));
   if(tcl_echo&&(wname!=a_f)){
       newline(STDOUT);
       prin1(wname,STDOUT);
   }
  /**** bind is tk_eval  ***/
   offvalue=0;
   conv_level=-1;
   memo=sfree=stack-narg;
   op=*sfree;
   if(op==a_configure&&narg==1) conv_level=2;  /*** (path 'configure) ***/
   if((econfig=(op==a_entryconfigure))&&narg==2){
             conv_level=2;  /*** (path 'entryconfigure <entry>) ***/
    }
   if(op==a_get){
     if(wname==a_listbox)
           conv_level=narg-2;
     else  if(wname==a_entry||wname==a_text)
           conv_level=0;
   }
  if(name==a_winfo&&op==a_exists) conv_level=-1000; /*** logical value ***/
  if(op==a_compare) conv_level=-1000; /*** logical value ***/
  if((wname==a_text)&&(op==a_index||op==a_search)) conv_level=-2000; /**** text index ***/
  if(op==a_tag){
      class=*(sfree+1);
      if(class==a_ranges||class==a_nextrange||class==a_prevrange)
          conv_level=-3000;
  }
    if(op==a_dump)  /*** txt 'dump <op> ***/
       conv_level=-4000;

   env=key_env_init(env);
   psh(a_nil);  /*** for v ***/
   psh(a_nil);  /*** for arg1 ***/
   psh(env);
   res=ss_tkstr_simple(name,env,0);
   psh(res);
   pro=stack;  /***  protect base ***/
   len=narg;
   *stack++=res; /*** push cmd ***/
   while(narg--){
    s=*sfree++;
    if(key) {
         if(econfig)  /*** entryconfigure ***/
            *(pro-2)=env=key_env_set_econf(key,s,env,*(memo+1));   /***  save command etc ***/
         else   
            *(pro-2)=env=key_env_set(key,s,env);   /***  save command etc ***/
         if(key==k_offvalue&&(s==a_f)) offvalue=1;
          if(key==k_variable||key==k_textvar||key==k_textvariable||key==k_listvar||key==k_var){
                flag=1;    /**** とりあえず  ****/
               v=ATOMVAL(s);
               if(SREGP(v)||!(ATTR(v)&TKOBJ)){
                  if(v==a_unbdd||v==a_undef)
                      ATOMVAL(s)=lkvar=make_tklink(s,a_nullstr,flag); 
                  else
                      ATOMVAL(s)=lkvar=make_tklink(s,v,flag);  /****  to be modified?  ***/
               }
           }
           v=ss_tkstr_simple(s,env,0);
         key=0;
    }
   else{
       v=ss_tkstr_simple(s,env,0); 
       if(bind_func){
           psh(v);
           psh(class=ss_tkstr_simple(*memo,env,0));
           *(pro-1)=class=SCONS(class,*(memo+1));
           bind_env_set(class,env);
          pull();
          pull();
       }
   }
     if(!SREGP(s)&&KEYWORDP(s)){
       key=s;
       if(op==a_cget&&key==k_text) conv_level=0;  /*** cget ***/
     }
    if(arg1==NULL) {
           arg1=v;
           *(pro-3)=v;
       }
   *(pro-4)=v;
       *stack++=v;
   }
   if(offvalue) CAR(lkvar)=(ptr)(STRING|BOOLEAN);    /****  BOOlean linkvar ***/
   res=Tcl_Invoke(stack-pro);
   ECHO
     {printf("Invoke end res ");
     prin1(res,STDOUT);
     newline(STDOUT);
     }
  conv_level=-1;
  if(name==a_image&&len>2&&*memo==a_create){
     arg3=*(memo+2);
   }
  stack=pro-4;
  /*** printf("after tcleval res %x\n",res); ***/
  if(res==a_undef) return a_undef;   /**** this is TCL error  ***/
  /*** if((arg1==0)||(string_equal(arg1,res)==a_f)) return res;***/
  if(SREGP(res)) return res;
  if(res==a_nil||NUMBERP(res)||KEYWORDP(res)||CONSP(res)) return res;
  if(res==a_t||res==a_f) return res;  /*** conv_level=-1000  logical ***/
  if(arg3)
     s=arg3;
  else{
    if((arg1==0)||(string_equal(arg1,res)==a_f)) return res;
      s=*memo;
   }
  if(SREGP(s)||!SYMBOLP(s)) return res;  /** rror(E_notsymb,s); ***/
  p=get_string(PNAME(s),&n);
  if(*p!='.'&&(arg3==NULL)) return res;  /***   not widget! ***/
  /** printf("tcl make cmd %x\n",res); **/
  if(arg3) len-=2;
   env=make_fenv(s,env);
  res=tk_make_cmd(len,env);  /**** must keep env for gbc, check tk_make_cmd  below****/
  ATOMVAL(s)=res;   /*** always global bind  ***/
  return s;
}



static ptr s_tk_exec_arg(int narg,ptr env){
 Reg ptr s,v,name,res,*sfree;
 int n,len,code;
   ptr assq();
   name=CDR(assq(k_widget_name,env));
   prin1(name,STDOUT);
   sfree=stack-narg;
   res=CONS(a_tcl,a_nil);
   psh(res);
    res=CDR(res)=SCONS(name,a_nil);
   while(narg--){
    s=*sfree++;
    v=ss_tkstr(s,env,NO);
    res=CDR(res)=SCONS(v,a_nil);
   }
  return *pull();
}


ptr s_tk_make_exec(int narg,ptr env){
 Reg ptr s,v,name,*sfree;
 int n,len,code;
 if(narg==0) error(E_shortarg,a_nil);
 sfree=stack-narg;
 name=*sfree++;
  env=key_env_init(env);
 narg--;
 while(narg-->0){
  s=*sfree++;
  if(KEYWORDP(s)){
    env=key_env_set(s,*sfree++,env);
   narg--;
  }
}
  s=CONS(k_widget_name,name);
  env=SCONS(s,env);
  psh(env);
  s=make_subr(s_tk_exec_create,(int)(long)subr_argtype(0,1)|TKFUNC|SLAMBDA, env);
  pull();
  return s;
}

int check_toplevel(ptr name){
  ptr s;
  Uchar *p;
  int n,c;

  s=PNAME(name);
  p=get_string(s,&n);
  if(*p++!='.') return NO;
  while(c=*p++){
   if(c=='.') s=a_nil;
  }
  return (s!=a_nil); 
}

/****   tcl-name arg1 arg2 ....   *****/
static ptr tk_make_cmd(int narg,ptr env){
 Reg ptr s,v,name,*sfree;
 int n,len,code,check,visible;
 if(narg==0) error(E_shortarg,a_nil);
 sfree=stack-narg;
 name=*sfree++;
 check=check_toplevel(name);
  /*** printf("tk_make_cmd %d\n",(!toplevel_flag)&&check); **/
 if(check) visible=tk_visible(1);
   /***  prin1(name,STDOUT);  ***/
  if(check&&(visible!=2)){
       if(!toplevel_flag){
            tk_visible(2);
           root_deiconify();   /*** only call once!  **/
        }
  }
 psh(env);
  *(stack-1)=env=key_env_init(env);
 narg--;
 while(narg-->0){
  s=*sfree++;
  if(KEYWORDP(s)){
   /***  env=key_env_set(s,*sfree++,env);    No good! because, original env changed! ***/
   v=SCONS(s,*sfree++);
   *(stack-1)=env=SCONS(v,env);
   narg--;
  }
}
  s=CONS(k_widget_name,name);
  *(stack-1)=env=SCONS(s,env);
  s=make_subr(s_tk_exec_create,(int)(long)subr_argtype(0,1)|TKFUNC|SLAMBDA, env);
  pull();
  return s;
}

/****  use  (tk-make-cmd ss-name tcl-name arg1 arg2 ....) ***/
ptr s_tk_make_cmd(int narg,ptr env){
 Reg ptr v,name;
 /*** env=a_nil; *****   !!!  perhaps No problem ****/
 if(narg<=1) error(E_shortarg,a_nil);
 name=*(stack-narg);
   env=make_fenv(name,env);
 v=tk_make_cmd(narg-1,env);
 ATOMVAL(name)=v;  /**** Caution!!!    top-value set! ***/
 return name;
}

/***  TCL ECHO  on off ***/
ptr s_tclecho(int narg,ptr env){
 checknarg(narg-1);
 tcl_echo=(*(stack-1)!=a_f);
 return *(stack-1);
}
 
/****  for error.c   for debug only  ****/
ptr s_print_last_tcl(int narg,ptr env){
 ptr lpath;
 if(narg==0){
  lpath=STDERR;
 }
 else if(narg==1)
   lpath=*(stack-1);
 else
   checknarg(narg-1); 

 sprintf(iobuff,"Last tcl_eval  return  %d bytes conversion_level %d: ",tkreturn ,conv_level);
      lwritestr(lpath,iobuff);
      lwritestr(lpath,tkcmdbuf);
      newline(lpath);
  return a_undef;
}
  
ptr s_last_tcl(int narg,ptr env){
 ptr res;
   checknarg(narg);
  res=SCONS(CMAKESTR(tkcmdbuf),a_nil);
  res=SCONS(MAKESINT(conv_level),res);
  /*** res=SCONS(MAKESINT(tkreturn),res);   length of tkcmdbuf ***/
  return res;
}

 
