
/************************************************
    tk_lisp.c
    ss with TCL/TK version main program
    2003.10.5 Created 

  by Sato 
****/
#define MAIN_PROGRAM
/***
#ifdef WIN32
#include <windows.h>
#endif
****/

#include "lisp.h"
#include <stdio.h>
#include <setjmp.h>
#include <stdlib.h>

#include <tk.h>
#include <signal.h>

extern jmp_buf user_env[];

ptr make_symbol_c(),make_str_c();

extern ptr *pc_stack;
extern int verbose_mode;

int regcmd=0;  /*****   TCL cmd define flag ***/

int Tk_AppInit(Tcl_Interp *interp);

/*
* Token and handler procedure for async event. See page 534.
*/
static Tcl_AsyncHandler sig_Token;
/*
 * Needed if entering the debugger from the idle loop.
 */

Tcl_Interp *myInterp;

/*
 * A table for command line arguments.
 */
char *myoption1 = NULL;
/***
static Tk_ArgvInfo argTable[] = {
	{"-myoption1", TK_ARGV_STRING, (char *) NULL,
	(char *) &myoption1, "Explain myoption1"},
	{"-debug", TK_ARGV_CONSTANT, (char *) 1, (char *) &debug,
		"Enable the Tcl debugger"},
	{"", TK_ARGV_END, },
};
***/

main(int argc, char *argv[]) {
	Tcl_Interp *interp;
          Tcl_Channel inChannel;
  Reg ptr p,q,*r,lis,env;
   Reg int n;

    tk_flag=1;
    tcl_echo=0;  /*** No echo default ***/

	/*
	 * Save a copy of the command line args for debugger.
	 */
	/* argv = Dbg_ArgcArgv(argc, argv, 1); */
	/*
	 * Create an interpreter for the error message from
	 * Tk_ParseArgv. Another one is created by Tk_Main.
	 * Parse our arguments and leave the rest to Tk_Main.
	 */
        /***
	interp = Tcl_CreateInterp();
	if (Tk_ParseArgv(interp, (Tk_Window) NULL, &argc, argv,
			argTable, 0) != TCL_OK) {
		fprintf(stderr, "%s\n", interp->result);
                fprintf(stderr,"***** Tcl/Tk  failed,  use ss  ****\n"); 
		exit(1);
	}
	Tcl_DeleteInterp(interp);
        ***/
	/*
	 * Set up a signal handler so we can enter the Tcl 
	 * debugger.
	 */
         /****   stream.c  support TCL/TK stdin by this ***/
          load_verbose_set(NO);
          ss_init(argc,argv);
          /** if(istty) load_verbose_set(YES); ***/
          /* paraload(argc,argv); **/
          /****/
      init_sig();
      n=calljmp();
      block=0;  /****  top level  ****/
    if(n){  /***  jump!  ***/
            lwritestr(STDERR,"\n top level jump occured  \n");
            p=number2str(MAKESINT(n),16);
            princ(p,STDERR);
            newline(STDERR);

          stack=stack_base;
         /*** frame=frame_base;   ***/
      block=0;  /****  top level  ****/
      init_gread();
      jmp_level=1;
      /** init_sig(); ***/
	Tcl_DeleteInterp(myInterp);
    }
    else if(verbose_mode){
            sprintf(iobuff,"jump set level=%d \n",jmp_level-1);
            lwritestr(STDMSG,iobuff);
   }
   env=a_nil;


	myInterp=interp = Tcl_CreateInterp();
        /** printf("interp %x\n",interp); ***/
        inChannel = Tcl_GetStdChannel(TCL_STDIN);
 /*** printf("inChannel %x\n",inChannel); ***/
   /** Tcl_SetChannelOption(NULL, inChannel, "-buffering", "line"); ***/
       if(verbose_mode)
           lwritestr(STDMSG,"\n call Tk_Mainex  \n");
	Tk_Mainex(argc, argv, Tk_AppInit,interp); /***  call sslisp Tk_Main  ,not original ***/
	exit(0);
}


int
Tk_AppInit(Tcl_Interp *interp) {
	/*
	 * Initialize packages
	 */
        int result;
        ptr s;
        extern int tk_ssCmd();

        /*** printf("Appinit interp %x\n",interp); ***/
	if (Tcl_Init(interp) == TCL_ERROR) {
		return TCL_ERROR;
	}
	if (Tk_Init(interp) == TCL_ERROR) {
	/** 	return TCL_ERROR; ***/
	}
        /**  2014 **/
        Tcl_StaticPackage(interp,"Tk",Tk_Init,(Tcl_PackageInitProc *)NULL);
	/* if (Dbg_Init(interp) == TCL_ERROR) {
		return TCL_ERROR;
	}
        */
	myInterp = interp;
	/*
	 * Define application-specific commands here.
	 */
        Tcl_CreateCommand(interp, "ss", tk_ssCmd,
                        (ClientData)NULL, (Tcl_CmdDeleteProc *)NULL);
	/*
	 * Define start-up filename. This file is read in
	 * case the program is run interactively.
	 */
       /*** printf("appinit 1\n");
getchar();
***/
	Tcl_SetVar(interp, "tcl_rcFileName", "~/.mytcl",
		TCL_GLOBAL_ONLY);
        /*** Tcl_SetStdChannel(NULL,TCL_STDIN);
        Tcl_SetStdChannel(NULL,TCL_STDOUT);
       ***/
 
         /*****    test of Invoke  *****/
         /*** result=Tcl_Invoke(interp, "set", "foo", "wow", NULL);
        fprintf(stderr,"%d\n",result);
         ***/
        /*****   TCL/TK commands define  ,  see libtk.scm  *****/
        /***  regcmd=1;   * debug **/
          top_visible=-1;  /***** first unvisible until initialize finish ****/

        /*** printf(LOGINMSG);  ***/
	return TCL_OK;
}

