/***  trace.c
***/

#include "lisp.h"

ptr untrace_all(),untrace();

ptr s_trace(int narg,ptr env)
{
  /*** (trace 'x x) ***/
  ptr res,x,y,v;
  checknarg(narg-2);
    v=*(stack-2);
    x=*(stack-1);
  res=ATOMVAL(a_trace);
  psh(res);
    y=assq(x,res);
   if(y==a_f){
      if(CLOSUREP(x)&&((long)FTYPE(x)&(LAMBDA|MACRO))){
          trace_mark(x);
          *(stack-1)=res=SCONS(SCONS(x,CONS(v,ZERO)),res);
         }
       else
         error(E_typemis,x);
    }
   else
      CDR(y)=CONS(v,ZERO);
  return  ATOMVAL(a_trace)=*pull();
 }

trace_mark(ptr x){
   FTYPE(x)=(ptr)((long)FTYPE(x)|TRACE);
}

untrace_mark(ptr x){
   FTYPE(x)=(ptr)((long)FTYPE(x)&(~TRACE));
}

ptr s_untrace(int narg,ptr env)
{
  ptr res,x,y,*sfree;
  res=ATOMVAL(a_trace);
  sfree=stack-narg;
  if(narg==0) return untrace_all();
  while(narg--){
    x=*sfree++;
    untrace(x);
  }
 return a_undef;
}

ptr untrace(ptr x){
  ptr res,y,f;
    res=ATOMVAL(a_trace);
    y=assq(x,res);
   if(y!=a_f){
          f=CADR(y);
          if(f==a_apply){
              /***  apply uses apply tric, change to original   ***/
              ATOMVAL(f)=a_sysapply;
          }
          untrace_mark(x);
          
          if(CAR(CAR(res))==x)
              ATOMVAL(a_trace)=CDR(res);
          else
            while(CONSP(res)){
                y=res;
                res=CDR(res);
                if(CAR(CAR(res))==x){
                   CDR(y)=CDR(res);
                   return a_undef;
                }
              }
     }
    else
         error(E_typemis,x);
    return a_undef;
 }

ptr untrace_all(){
   ptr res,f;
     res=ATOMVAL(a_trace);
            while(CONSP(res)){
              f=CADR(CAR(res));
               if(f==a_apply){
              /***  apply uses apply tric, change to original   ***/
              ATOMVAL(f)=a_sysapply;
               }
              untrace_mark(CAR(CAR(res)));
                res=CDR(res);
              }

     ATOMVAL(a_trace)=a_nil;
   return a_undef;
}

trace_in(ptr func,ptr cdrs){ 
 ptr z;
 int ind;         
   /**  printf("trace-in %x %x %x\n",func,name,cdrs);
    return;  **/

    psh(cdrs);
         z=assq(func,ATOMVAL(a_trace));
         z=CDR(z);
           ind=SINT_NUMB(CDR(z));
                CDR(z)=MAKESINT(ind+1);
           ind_out(ind);
           lwritec(STDOUT,'-');
           lwritec(STDOUT,'>');
           lwritec(STDOUT,' ');
           prin1(CAR(z),STDOUT);
           lwritec(STDOUT,' ');
           prin1(cdrs,STDOUT);
           newline(STDOUT);
   pull();
 }
  
trace_out(ptr func,ptr value){
 ptr z;
 int ind;

   psh(value);
         z=assq(func,ATOMVAL(a_trace));
         if(z==a_f) error(99993,func);
         z=CDR(z);
           ind=SINT_NUMB(CDR(z));
               CDR(z)=MAKESINT(--ind);
  /***
  printf("trace-out ind %x  value %x \n",ind,value);
    scm=*pull();
    return;
  ***/
           ind_out(ind);
           lwritec(STDOUT,'<');
           lwritec(STDOUT,'-');
           lwritec(STDOUT,' ');
           prin1(CAR(z),STDOUT);
           lwritec(STDOUT,' ');
           prin1(value,STDOUT);
           newline(STDOUT);
   /***  scm may be changed by prin1 , to output function port !!! 04.1.20 ****/
  /*** scm=*pull(); **/
  *pull();
 }

ind_out(int n){
  int k;
  n*=2;
  k=n%50;
  while(k--){
    lwritec(STDOUT,' ');
  }
  n/=50;
   while(n--){
    lwritec(STDOUT,'|');
  }
}
/***  trace var  04.7.20  ***/
trace_var_prev(ptr s)
{
           prin1(s,STDOUT);
           lwritec(STDOUT,'=');
           prin1(ATOMVAL(s),STDOUT);
           newline(STDOUT);
}

trace_var_cmds(ptr s)
{
  Reg ptr p;
  while (CONSP(s)){
    p=CAR(s);
   if(CLOSUREP(p))
     funcall(p,0,a_nil);
   else
      vm_eval(p,a_nil);  /**** V2.0 ***/
    s=CDR(s);
  }
}


