;;;  ss ver2.0 optimize
;;;  2007.9.10
;;;  From Compile list  return a new list.
;;;     This file is used by makesr  only!!!
;;;  
(load "vm-op-table")
;;;  The followings may change SCM
;;;  But other OP does not
;;;  FALSE2  (No Label)   also keep SCM  in  FALSE2
;;;  JMP  (Label)   necessarily
;;;  
(define op-opt (make-vector 50 #f))
(vector-set! op-opt (NUM 'LOAD) 'LOAD)
(vector-set! op-opt (NUM 'IMM)  'LOAD)
(vector-set! op-opt (NUM 'LOADENV) 'LOAD)
(vector-set! op-opt (NUM 'LAMBDA) 'LOAD)
(vector-set! op-opt (NUM 'MACRO) 'LOAD)
(vector-set! op-opt (NUM 'JSR) 'JSR)
;;;(vector-set! op-opt (NUM 'TAIL-JMP) 'TAIL)
;;;(vector-set! op-opt (NUM 'Pull-ENV) 'Pull-ENV)
(vector-set! op-opt (NUM 'MULTI->SCM) 'LOAD)
(vector-set! op-opt (NUM 'ST->SCM) 'LOAD)
(vector-set! op-opt (NUM 'BA->SCM) 'LOAD)
;;;(vector-set! op-opt (NUM 'JMP2) 'JMP)
;;;;(vector-set! op-opt (NUM 'FALSE2) 'JMP)
(vector-set! op-opt (NUM 'COPY-CC) 'COPY-CC)
(vector-set! op-opt (NUM 'RESTORE-CC) 'RESTORE-CC)

(define IMM  (NUM 'IMM) )
(define  LOADENV  (NUM 'LOADENV))
(define  SETENV  (NUM 'SETENV))
(define  LOAD  (NUM 'LOAD))
(define  SET  (NUM 'SET))
;;;;  JMP info
(define op-jmp (make-vector 50 #f))
(vector-set! op-jmp (NUM 'TAIL-JMP) 'TAIL)
;;;(vector-set! op-jmp (NUM 'Pull-ENV) 'Pull-ENV)
;;;(vector-set! op-jmp (NUM 'Push-ENV) 'Push-ENV)
(vector-set! op-jmp (NUM 'JMP2)   'JMP)
(vector-set! op-jmp (NUM 'FALSE2) 'JMP)
(vector-set! op-jmp (NUM 'TRUE2) 'JMP)
(define JMP2 (NUM 'JMP2))
(define FALSE2 (NUM 'FALSE2))
(define TRUE2 (NUM 'TRUE2))
(define TAIL (NUM 'TAIL-JMP))
;;;  Block info
(define op-block (make-vector 50 #f))
(vector-set! op-block (NUM 'LAMBDA-BIND) 'LAMBDA-BIND)
(vector-set! op-block (NUM 'LAMBDA-LAST) 'LAMBDA-BIND)
(vector-set! op-block (NUM 'BIND) 'BIND)
(vector-set! op-block (NUM 'Push-ENV) 'Push-ENV)
(vector-set! op-block (NUM 'Pull-ENV) 'Pull-ENV)
(vector-set! op-block (NUM 'TAIL-JMP) 'TAIL)
 
(define (c-opt clis)
   (let* ((n (length clis))
          (n1 (+ n 1))
         (vcomp (make-vector n1 #f))  ;;; need last position for jmp
         (vinfo (make-vector n1  #f))
         (vjmp (make-vector  n1  #f))
         (vlabel (make-vector  n1  #f))
         (vblock (make-vector  n1  #f))
         (opt  1)
           )
      (make-vcomp clis vcomp)
      (make-info  op-opt vcomp vinfo n1)
      (make-info  op-block vcomp vblock n1)
      (update-vjmp  vcomp  vinfo vjmp vlabel n)
     (while (> opt 0)
        (set! opt  (opt-exec vcomp vinfo vjmp vlabel  vblock n1))
     )
    (vec->clis vcomp n)
))

(define    (vec->clis vcomp n)
   (let* ((x 0)(i 0) (cont #t) (top (cons () ()) ) (work top))
       (while cont
          (set! x (vector-ref vcomp i))
          (inc i)
          (if x
              (begin
                 (set-cdr! work (cons x ()))
                 (set! work (cdr work))
                 (set! cont (< i n)) 
              )
             (set! cont #f)
           )
        )
     (cdr top)
))

(define (make-vcomp clis vcomp ) 
   (let* ((x 0)(i 0)(c 0))
     (while (pair? clis)
        (set! x (pop clis))
        (set! c (car x))
         (if (or (eq? c (NUM 'LAMBDA))  (eq? c (NUM 'MACRO)))
             (vector-set! vcomp i (list c (c-opt (cadr x))))
             (vector-set! vcomp i x)
         )
        (inc i)
    )
))

(define (make-info  info-vector vcomp vec n)
     (do ((x 0)(i 0 (+ i 1)));;;    (break #f) no good!, for erase some
         ((= i n) vec )
        (set! x (vector-ref vcomp i))
        (if x
          (vector-set! vec i (vector-ref info-vector (car x)))
          (vector-set! vec i #f)  ;;;erase old data
        )
    )
)


(define (jmp-info op)
  (if op
     (vector-ref op-jmp (car op))
     #f
   )
)

(define (update-vjmp vcomp vinfo vjmp vlabel n)
   (let* ((x 0)(y 0)(c 0)(info 0)(M 0))
      (clear-vec  vjmp n)
      (clear-vec  vlabel n)
     ;;; Only JMP
      (do ((i 0(+ i 1))(cont #t))
          ((or (not cont)(= i n)) )
        (set! x (vector-ref vcomp i))
        (if x
          (begin
              (set! info (jmp-info  x))
             (when (eq? info 'JMP) 
               (vector-set!  vjmp  i (OP (car x)))
               (set! M i)
             )
           )
         (set! cont #f)
       )
     )
    ;;; Next Label
      (do ((i 0(+ i 1))(next 0)(jmp 0)(org 0)(cont #f))
          ((> i M) vjmp)
        (set! x (vector-ref vjmp i))
        (if (and  x (eq? (jmp-info (vector-ref vcomp i)) 'JMP))
          (begin
             (set! y (vector-ref vcomp i))
             (set! jmp (OP (car y)))
             (vector-set!  vjmp  i jmp)
             (set! next (+ i (cadr y) 1))
             (set! org next)
             (set! cont #t)
             (while (and cont (eq?  (jmp-info (vector-ref vcomp next)) 'JMP))
                 (set! c (vector-ref vjmp next))
                 (if  (or (eq? c 'JMP2)(eq? c jmp))
                    (set! next (+ next 1 (cadr (vector-ref vcomp next))))
                     (if (not (eq? jmp 'JMP2))
                         (set! next (+ next 1))
                         (set! cont #f)
                     )
                  )
             )   
            (label-set!  vlabel next i ) 
            (if (< org next)
              (vector-set! vcomp i (list (car y) (+ (cadr y) next (- org))))
            )
          )
       )

      )
))

(define (label-set! vlabel j from)
  (let* ((x (vector-ref vlabel j)))
      (if x
         (vector-set! vlabel j (cons from x))
         (vector-set! vlabel j (cons from ()))
      )
))

(define (jmp-change vcomp vinfo n)
  (let* ((x 0)(n1 (- n 1)))
   (do ((i 0(+ i 1)))
       ((= i n1))
       (if (eq? (jmp-info (vector-ref vcomp i)) 'JMP)
          (vector-set! vcomp i (jmp-change-aux (vector-ref vcomp i) vcomp i))
       )
    )
))
(define (jmp-change-aux cmd vcomp i)
   (let* ((n (cadr cmd)) (org n) (org1 (- org 1)))
     (do ((j 0 (+ j 1)))
         ((= j org)) 
         (if (not (vector-ref vcomp (+ i j 1 ) ))
             (dec n)
         )
     )
    (if  (= n org)
        cmd
       (list (car cmd) n)
    )
))

(define (clear-vec v n)
  (do ((i 0(+ i 1)))
      ((= i n))
      (vector-set! v i #f)
  )
)
             
;;;;  optimize!! from here

(define  (opt-exec vcomp vinfo vjmp vlabel vblock n)
  (let* ((opt 0)(opt1 0))
    (set! opt1 (op-load-load vcomp vinfo n))
    (if (> opt1 0)  (opt-update  vcomp vinfo vjmp vlabel vblock  n))
    (inc opt opt1)
    (set! opt1 (opt-tail vcomp vinfo vjmp vlabel n))
    (if (> opt1 0)  (opt-update  vcomp vinfo vjmp vlabel vblock  n))
    (inc opt opt1)
    (set! opt1    (opt-load-same  vcomp vinfo vjmp vlabel  n))
    (if (> opt1 0)  (opt-update  vcomp vinfo vjmp vlabel vblock  n))
    (inc opt opt1)
    (set! opt1 (opt-false-jmp vcomp vjmp  n))
    (if (> opt1 0)  (opt-update  vcomp vinfo vjmp vlabel vblock  n))
    (inc opt opt1)
    (set! opt1 (opt-jmp0 vcomp  n))
    (if (> opt1 0)  (opt-update  vcomp vinfo vjmp vlabel vblock  n))
    (inc opt opt1)
   ;;;;
    (set! opt1  (opt-block vcomp   vblock n))
    (if (> opt1 0)  (opt-update  vcomp vinfo vjmp vlabel vblock  n))
    (inc opt opt1)
    (set! opt1  (opt-jmp-scm  vcomp vinfo vjmp vlabel n))
    (if (> opt1 0)  (opt-update  vcomp vinfo vjmp vlabel vblock  n))
    (inc opt opt1)
    (set! opt1  (op-load-load-jmp vcomp vinfo vjmp vlabel  n))
    (if (> opt1 0)  (opt-update  vcomp vinfo vjmp vlabel vblock  n))
    (inc opt opt1)
;;;
    (set! opt1   (opt-bind-load vcomp vinfo vblock vlabel  n))
    (if (> opt1 0)  (opt-update  vcomp vinfo vjmp vlabel vblock  n))
    (inc opt opt1)
    (set!  opt1  (opt-set-load vcomp vinfo  vlabel  n))
    (if (> opt1 0)  (opt-update  vcomp vinfo vjmp vlabel vblock  n))
    (inc opt opt1)
    opt
))


(define (opt-update vcomp vinfo vjmp vlabel vblock n)
        (jmp-change vcomp vinfo n)
        (opt-remove  vcomp vinfo n)
        (update-vjmp  vcomp vinfo vjmp vlabel n)
        (make-info  op-block vcomp vblock n)
)
#|
    load1 load2  --> load2
|#
(define   (op-load-load vcomp vinfo n)
   (let* ((x 0) (in 0) (n1 (- n 1)) (opnum 0)(prev #f))
     (do  ((i 0 (+ i 1)))
          ((= i n1))
          (set! in (vector-ref vinfo  i))
          (if   (eq? in 'LOAD)
            (begin
               (if  prev
                  (begin 
                      (vector-set! vcomp (- i 1)  #f)
                      (inc opnum)
                  )
               )
              (set! prev #t)
             )
            (set! prev #f) 
          )
     )
    opnum 
))

(define (next-info vinfo pos n)
   (set! pos (+ 1 pos))
   (if (eq? pos n)
            #f
        (vector-ref vinfo pos)
   )
)

(define (opt-remove  vcomp vinfo n)
 (let* ((ind 0))
   (do ((i 0 (+ i 1)) (n1 (- n 1)) (x 0))
       ((= i n1))
      (set! x (vector-ref vcomp i))
      (when x
         (when (not (= i ind))
             (vector-set! vcomp ind  x)
             (vector-set! vinfo ind (vector-ref vinfo i))
           )
          (inc ind)
       )
   )
  (while (< ind n)
           (vector-set! vinfo ind #f)
          (vector-set! vcomp ind  #f)
          (inc ind)
  )
))
      
#|
  (TAIL-JMP args pull)
  (Pull-ENV)
 --->
   (Pull-ENV)
   (TAIL-JMP args (- pull 1)) 
|#
(define  (tail-pull vcomp vinfo vjmp vlabel n)
   (do ((i 0 (+ i 1)) (x 0)(y 0))
       ((= i n) vcomp)
       (set! x (vector-ref vcomp i))    
       (and (eq? (jmp-info x) 'TAIL)
            (eq? (jmp-info (vector-ref vcomp (+ i 1))) 'Pull-ENV)
           (not (vector-ref vlabel (+ i 1))) 
         (begin
            (set! x (vector-ref vcomp i))
            (vector-set! vcomp i (vector-ref vcomp (+ i 1)))
            (vector-set! vcomp (+ i 1)
                (list (car x) (cadr x) (- (caddr x) 1))  )
            (vector-set! vinfo  (+ i 1) 'TAIL)
            (vector-set! vinfo   i  'Pull-ENV)
          )
        )
    )
)

(define  (opt-tail vcomp vinfo vjmp vlabel n)
     (tail-pull vcomp vinfo vjmp vlabel  n)
   (do ((i 0 (+ i 1)) (x 0)(j 0)(opt 0) (cont #t))
       ((= i n)  opt )
       (set! x  (vector-ref vcomp i))
       ;;;(set! x (jmp-info (vector-ref vcomp i)))
       (when (and x (or (eq? (car x) TAIL) (eq? (car x) JMP2) ))
         (set! cont #t)
         (set! j (+ i 1))
         (while cont
            (set! x (vector-ref vlabel j))
            (if (or x  (eq? (vector-ref vcomp j) #f)) 
               (set! cont #f)
              (begin
                (vector-set! vcomp j #f)
                (vector-set! vinfo j #f)
                (inc opt)
               )
            )
           (inc j)
           (if (= j n) (set! cont #f))
        )
      )  
   )
)

#|
   LOAD1   ..... LOAD2
   .... don't change SCM   & ....  LOAD2 are Not Labelled
   and  LOAD1 equal LOAD2
   Then
   LOAD1  .....
|#
(define   (opt-load-same  vcomp vinfo vjmp vlabel n)
   (do ((x 0)(i 0 (+ i 1))(n1 (- n 1)) (op 0))
       ((= i n1) op)
       (set! x (vector-ref vinfo i))
       (if (eq? x 'LOAD)
         (set! op (+ op (opt-load-same-aux i vcomp vinfo vjmp vlabel n)))
       )
    )
)
(define  (opt-load-same-aux i vcomp vinfo vjmp vlabel n)
   (let* ((load1 (vector-ref vcomp i)) (x 0)(y 0))
      (do ((j (+ i 1) (+ j 1))(opt 0)(load2 0)(break #f))
          ((or break (= j n))  opt )
          (set! x (vector-ref vinfo j))
          (if x
             (if (eq? x 'LOAD)
                (begin
                  (set! break #t)
                  (set! load2 (vector-ref vcomp j))
                  (if (and (not  (vector-ref vlabel j) ) 
                         (equal? load1 load2))
                      (begin
                        (set! opt 1)
                        (vector-set! vcomp j #f )
                        (vector-set! vinfo j #f )
                      )
                  )
                )
               (set! break #t)
              )
             (set! break   (vector-ref vlabel j) )
           )
        )
))
          
#|
       (FALSE2 1) (JMP n)  ....
-->    (TRUE2 n+1 ) #f  ...  
      
       (TRUE2 1) (JMP n)  ->  (FALSE2 n+1) #f 
|#                     
(define   (opt-false-jmp vcomp vjmp   n)
   (let* ((x 0)(y 0)(i 0)(opx 0)(opt 0))
     (while (and opx (< i n))
        (set! opx (vector-ref vcomp i))
        (set! x (vector-ref vjmp i))
        (when (and x (not (eq? x 'TAIL-JMP)) (not (eq? x 'JMP2)))
           (set! y (vector-ref vjmp (+ i 1)))
           (if (and (eq? y 'JMP2) (= (cadr opx) 1))
             (begin 
                (if (eq? (car opx) (NUM 'FALSE2))
                      (set! y (NUM 'TRUE2))
                      (set! y (NUM 'FALSE2))
                )
                (vector-set! vcomp i (list y 
                    (+ 1 (cadr (vector-ref vcomp (+ i 1))))))
                (vector-set! vcomp (+ i 1) #f)
                (inc opt) 
                (inc i)
             )
          )
        )
       (inc i)
     )
   opt
))
;;;;    JMP 0  must be deleted
    (define  (opt-jmp0 vcomp  n)
      (let* ((break #f)(opt 0)(x 0))
       (do ((i 0(+ i 1)))
            ((or break (= i n)) opt)
            (set! x (vector-ref vcomp i))
            (if x
               (if (and (eq? (vector-ref op-jmp (car x)) 'JMP)
                        (<= (cadr x) 0))
                   (begin
                      (vector-set! vcomp i #f)
                      (inc opt)
                    )
               )
              (set! break #t)
           )
        )
))
                      
#|
  ... NO BIND ... Push-ENV   ..... (TAIL-JMP narg k)  ... Pull-ENV
-->
  ... NO BIND ... #f  ..... (TAIL-JMP narg k-1)  ... #f
  we need trace FALSE2,TRUE2 , and Block level
  we also need var-access
  LAMBDA-BIND x .... Push-ENV  BIND x
  can not  erase
  So, we first do
     Push-ENV ... BIND x   ->  ... BIND x Push-ENV
  if x is  not defined in  direct outer block

     x   [   y z  [x   ]]   ->  x[y z ...  x[  ]]
    But 
    x   [   y z  [x   ]... ]   ->  x[y z ...  x[  ] ....]
    is not allowed!!!
    If  Block has no bind , then it is erased.
    In general ,
    x [y z [ ....] ....] ....  ->  x y z[....] ....   ....
    if  y,z are not x. That is,  if all binds are for new variables
     then BLOCK-IN BLOCK-OUT CAN BE erased, and then TAIL-JMP
     within the block are decreased Pull-stack. 

   Note:    P P Q P Q Q      (Q==Pull)
           So, Push, Pull must be same  stack operation
|#   
(define  (opt-block vcomp  vblock n)
  (let* ((env ()) (x 0)(y 0) (start  0)(level 0)
           (v 0)(block ())(keep  #t) (STACK ()) (opt 0)) 
       (push 0 block)
     (do ((i 0(+ i 1)))
         ((= i n) opt)
         (set! x (vector-ref vblock i))
         (if x
           (begin
              (set! y (vector-ref vcomp i))
              (cond ((eq? x 'BIND) (set! x (cadr y)) 
                         (set! v (assq x env)) 
                          (if v (set! keep #t))
                          (push (cons x v)  env))
                    ((eq? x 'LAMBDA-BIND) (set! x (cadr y))
                        (set! x (if (pair? x) (car x) x) ) 
                        (push (cons x  #f) env) ) 
                    ((eq? x 'Push-ENV) (inc level)
                         (push keep block)
                         (push i block)
                         (push env STACK)
                         (set! keep #f)  )
                    ((eq? x 'Pull-ENV) 
                         (set! env (pop  STACK))
                         (set! start (pop block))
                          (when (not keep)
                             #|
                              (when (or (eq? start #f) (eq? i #f))
                                (format #t "~s ~s ~s~%" start i block )
                                 (bye)
                              )
                             |#
                              (block-erase start i vcomp vblock)
                              (inc opt 2)
                           )
                          (dec level)
                          (set! keep (pop block))
                        )
                    (else   )
              )
            ) ;;; begin
         ) ;;if
      ) ;;do
))
                           
(define  (block-erase start i vcomp vblock)
    (vector-set! vcomp start  #f)
    (vector-set! vcomp i #f)
    (do ((j (+ start 1) (+ j 1)) (x 0))
        ((= j i))
        (set! x (vector-ref vblock j)) 
        (when  (eq? x 'TAIL)
            (set! x (vector-ref vcomp j)) 
           (vector-set! vcomp j (list (car x) (cadr x) (- (caddr x) 1)))
        )
    )
)

#|
   IMM #f FALSE2  -> IMM #f JMP2     trace SCM
|# 
(define SCM '(undef))

(define undef SCM)

(define (opt-jmp-scm  vcomp vinfo vjmp vlabel n)
   (set! SCM undef)
   (opt-jmp-scm-start 0  vcomp vinfo vjmp vlabel n)
)

(define (opt-jmp-scm-start k  vcomp vinfo vjmp vlabel n)
   (let* ((x 0)(y 0)(v 0)(info 0) (opt 0))
      (do ((i k(+ i 1))(cont #t))
          ((or (not cont)(= i n)) opt)
        (set! x (vector-ref vcomp i))
        (if x
          (begin
              (set! v  (vector-ref vinfo i))
             (if   v
               (begin 
                 (if (eq? (car x) IMM)
                     (set! SCM (cadr x))
                     (set! SCM undef)
                 ) 
               )
              (begin
                 (set! v (vector-ref vjmp i))  
                 (if  (vector-ref vlabel i)
                    (set! SCM undef)
                    (if (and v (not (eq? SCM undef)) (not (eq? v 'TAIL-JMP)))
                      (inc opt (opt-jmp-scm-aux  i v vcomp vinfo vjmp vlabel n)))
                  )
              ) 
             )
          )
         (set! cont #f)
        )
      )
))  

(define  (opt-jmp-scm-aux  i v vcomp vinfo vjmp vlabel n)
   (let* ((x (vector-ref vcomp i))(y 0)(opt 0)(j 0))
      (cond 
             ((eq? v 'FALSE2)
                      (inc opt)
                (if SCM
                      (vector-set! vcomp i #f)
                      (vector-set! vcomp i (list JMP2 (cadr x))) 
                 )
               )
             ((eq? v 'TRUE2)
                      (inc opt)
                (if SCM
                      (vector-set! vcomp i (list JMP2 (cadr x))) 
                      (vector-set! vcomp i #f)
                )
              )
             ((eq? v 'JMP2)
                 (set! j (+ i 1 (cadr x)))
                 (set! v (vector-ref vjmp j))
                 (when v
                     (set! y (vector-ref vcomp j))
                    (cond ((eq? v 'FALSE2)
                             (inc opt)
                             (if SCM
                                (vector-set! vcomp i (list JMP2 (+ 1 (cadr x)))) 
                                (vector-set! vcomp i 
                                  (list JMP2 (+ 1 (cadr x) (cadr y))) )
                             )
                            )
                          ((eq? v 'TRUE2)
                             (inc opt)
                             (if SCM
                                (vector-set! vcomp i 
                                  (list JMP2 (+ 1 (cadr x) (cadr y))) )
                                (vector-set! vcomp i (list JMP2 (+ 1 (cadr x)))) 
                              )
                             )
                           (else)
                      )
                  )
              )
            (else )
      )
   opt
))

#|
    load1 JMP-> load2  --> #f JMP load2
    if load1 is not labelled and load2 is lablled from only JMP
|#
(define   (op-load-load-jmp vcomp vinfo vjmp vlabel  n)
   (let* ((x 0) (v 0) (next 0)(n1 (- n 1)) (opnum 0)(prev #f))
     (do  ((i 0 (+ i 1)))
          ((= i n1))
          (set! v (vector-ref vjmp  i))
          (when (eq? v 'JMP2)
              (set! x (vector-ref vinfo (- i 1)))
              (when (and (eq? x 'LOAD) (not (vector-ref vlabel (- i 1))))
                 (set! v (vector-ref vcomp  i))
                 (set! next (+ i 1 (cadr v)))
                 (when (and (= (length (vector-ref vlabel next)) 1)
                          (eq? (vector-ref vinfo next) 'LOAD))
                      (vector-set! vcomp (- i 1)  #f)
                      (inc opnum)
                  )
               )
           )
     )
    opnum
))

#|
  BIND x LOADENV x  --->  BIND x #f
|#                   
(define   (opt-bind-load vcomp vinfo vblock vlabel  n)
   (let* ((x 0) (v 0) (next 0)(n1 (- n 2)) (OPnum 0))
     (do  ((i 0 (+ i 1)))
          ((>= i n1))
          (set! v (vector-ref vblock  i))
          (set! x (vector-ref vinfo  (+ i 1)))
          (when (and x v (eq? x 'LOAD) (or (eq? v 'BIND) (eq? v 'LAMBDA-BIND))
                  (not (vector-ref vlabel (+ i 1))))
              (set! v (vector-ref vcomp  i ))
              (set! x (vector-ref vcomp  (+ i 1) ))
              (when (eq? (car x) LOADENV)
                 (set! v (cadr v))
                 (if (pair? v) (set! v (car v)))
                 (when (eq? v (cadr x))
                      (vector-set! vcomp (+ i 1)  #f)
                      (inc OPnum)
                  )
               )
           )
     )
    OPnum
))

#|
  SET x LOAD x  --->  SET x #f
|#
(define   (opt-set-load vcomp vinfo  vlabel  n)
   (let* ((x 0) (v 0) (next 0)(s 0)(n1 (- n 2)) (Opnum 0)(prev #f))
     (do  ((i 0 (+ i 1)))
          ((>= i n1))
          (set! v (vector-ref vcomp  i))
          (set! s  (if v (car v) #f))
          (set! x (vector-ref vinfo  (+ i 1)))
          (when (and x v (eq? x 'LOAD) (or (eq? s SET) (eq? s SETENV))
                  (not (vector-ref vlabel (+ i 1))))
              (set! x (vector-ref vcomp  (+ i 1) ))
              (when (and (pair? (cdr x))
                      (eq? (cadr x) (cadr v))
                      (or (and (eq? (car x) LOAD)(eq? s SET))
                          (and (eq? (car x) LOADENV) (eq? s SETENV))) )
                      (vector-set! vcomp (+ i 1)  #f)
                      (inc Opnum)
               )
           )
     )
    Opnum
))
;;(trace opt-update)
;;;(trace update-vjmp)
;;;(trace vector-set!)


