;;; get-file-base
;;;

(in-package "get-file")

(define fixfont "fixfont")
(let* ((name (font 'names)))
   (if (string? name) (set! name (list name)))
   (if  (not (member fixfont name))
    (font 'create fixfont :family 'fixed :size 11)
   )
)

(defstruct GETF :top :cwd  :dirs :files :allfiles :files_stat (:ext '("*" ".*" ))
      :win :dirname :var :globent
      (:stat_func getf-stat) (:glob_func getf-glob) (:getcwd getcwd)(:chd chdir)
)

(define (make-files-win getf)  
  (let* ((s 0)
         (dir (GETF-top getf))  ;;;;  dir is top wind path
         (ext (GETF-ext getf))  ;;;;  dir is top wind path
        ;;;;(dir  (gen-toplevel '.getfile))
        (lab-glob (tk-name dir ".labglob"))  ;;; entry  glob *.*
        (dir-glob (tk-name dir ".glob"))  ;;; entry  glob *.*
        (dir-cwd (tk-name dir ".labcwd"))  ;;; dir name label
        (dir-ent (tk-name dir ".entcwd"))  ;;; dir name entry
        (file-lb  (tk-name dir ".lbox"))    ;;; files listbox
        (dir-yscroll  (tk-name dir ".ysc"))
        (dir-xscroll  (tk-name dir ".xsc"))
        ;;;(file-name  (tk-name dir ".name"))   ;;; file name
       ;;;;(getf (make-GETF :win file-lb :dirname dir-cwd  :globent dir-glob))
        )
     (set-GETF getf :win file-lb :dirname dir-cwd  :globent dir-glob)
    ;;;(if (null? ext) (set! ext '("*" ".*" ) ) )  ;;;;  .* are hidden for *
    (label lab-glob  :text "glob")
    (entry  dir-glob  :width 25 :font fixfont)
    (entry  dir-ent  :width 25  :font fixfont)
    (insert-glob dir-glob ext)
     (grid lab-glob dir-glob )
     (label dir-cwd )
     (grid dir-cwd dir-ent)
      (listbox  file-lb   :font fixfont  :exportselection #t   
             ;;;;;; :selectMode 'extended
        :yscrollcommand   (lambda l (apply  (function dir-yscroll) 'set l))
        :xscrollcommand   (lambda l (apply (function dir-xscroll) 'set l))
       :width 60 :height 16)
     (scrollbar  dir-yscroll  :orient 'vertical
          :command   (lambda l (apply (function  file-lb)  'yview l))  )
     (scrollbar dir-xscroll  :orient 'horizontal
            :command (lambda l (apply (function file-lb) 'xview l)))
     (grid    file-lb    :row 2 :columnspan 3  :sticky 'news)
     (grid     dir-yscroll :row 2 :column 3 :sticky 'nws)
     (grid     dir-xscroll :columnspan 3  :sticky 'new)
     (grid 'rowconfigure dir 2 :weight 1)
     (grid 'columnconfigure dir 0 :weight 1)
                                                                                                           
    (dir-reset getf)   ;;;debug
    (move-look-file getf)
    (bind file-lb  "<Double-1>" (lambda (y)
       (chd-ypos  y getf)  )  )
                                                                                                           
   ;;;; (bind  file-lb  "<Return>" (lambda () (destroy dir)))
    (bind  dir-glob  "<Return>" (lambda () (dir-reset  getf)))
    (bind  dir-ent  "<Return>" (lambda () (chdir-reset (funcall dir-ent 'get)  getf)))
   getf
))

(define (move-look-file getf)
  (let* ((dirs (GETF-dirs getf))
         (all  (GETF-allfiles getf))
         (lb  (GETF-win getf))
         (r (/ (length dirs) (length all)))
        )
     (set! r (round (* r 90)))
     (set! r (* r 0.01))
     ;;;(format #t "move ~s~%" r)
     (funcall lb 'yview 'moveto r)
))
     
(define (insert-glob ent ext)
  (funcall ent 'delete 0 'end)
  (while (pair? ext)
     (funcall ent 'insert 'end (pop ext))
     (if (pair? ext) (funcall ent 'insert 'end " "))
  )
)
                                                                                                           
(define (dir-reset getf)
  (let* (( dir-cwd  (GETF-dirname getf))
         ( file-lb (GETF-win getf))
         ( ent (GETF-globent getf))
         ( prev (GETF-cwd getf))
         (stat-f (GETF-stat_func getf))
         (glob-f (GETF-glob_func getf))
         (getcwd-f (GETF-getcwd getf))
         (cwd (funcall getcwd-f))
         (stat 0) (size 0)(dir-list 0)(direc 0))
   (set-GETF getf :cwd cwd)
   (funcall dir-cwd 'configure :text cwd)
   (funcall file-lb 'delete 0 'end)
  ;;; (funcall dir-wdir 'delete 0 'end)
     (set-ext ent getf)
     (funcall glob-f getf)
     (set!  dir-list (GETF-files getf))
      ;;;(.dir.lb 'insert 'end "..")
      ;;;(set! direc (sort (glob-dir-dot) string<?))
      (set! direc  (GETF-dirs getf) )
      ;;;;(set-GETF getf :dirs direc :files dir-list :allfiles (append direc dir-list))
      (do ((x ()) (i 0) (dirs direc))
          ((null? dirs) )
         (set! x (pop dirs))
         (funcall file-lb 'insert 'end  x)
         (funcall file-lb 'itemconfigure 'end  :foreground 'blue)
     
          ;;; (format #t "~a~%" x)
          (set! i (+ i 1))
       )
     (do ((x ()) (i 0) (dirs dir-list))
          ((null? dirs) )
            (set! x (pop dirs))
            (set! stat (funcall stat-f getf x))
            ;;;(format #t "stat: ~s ~s ~%" x stat)
            (set! size (car stat))
            (set! stat (cdr stat))  ;;;date
            (funcall file-lb 'insert 'end  (format #f "~18a ~12@a  ~a" x size stat))
            (if (and (string? size) (not (string->number size)))
                (funcall file-lb 'itemconfigure 'end  :foreground 'cyan)
            )
          ; (format #t "~a~%" x)
          (set! i (+ i 1))
        )
     (if (not (equal? prev cwd)) (move-look-file getf))
     (focus file-lb)
    (update)
))

(define (set-ext ent getf)
  (let* ((ext  (funcall ent 'get)))
    (set! ext (regexp ext #"[^\s]+" :repeat))
    (if (not ext) (set!  ext '("*")))
    (set-GETF getf :ext ext)
))

(define (glob-dir-dot)
   (let* ((s (glob-dir  "*" ".*")))
        (set! s (remove "." s))
        (set! s (remove ".." s))
        (cons ".." (cons "." s))
))

(define (chd-ypos  y  getf)
  (let* ( (file-lb (GETF-win getf))
          (i  (funcall file-lb  'nearest y  ))
          (file "")
        )
     ; (format #t "~s ~s ~%" i y)
     (set! file (funcall file-lb 'get i))
    (chdir-reset file getf)
))
                                                                                                           
(define (chdir-reset dir getf)
  (let* ((chd (GETF-chd getf))
         (dirs (GETF-dirs getf))
       )
    (when (member  dir dirs)
       (funcall chd dir)
       (dir-reset getf)
   )
))
;;;  normal file operations
(define (getf-stat getf x)
  (let* ((stat (GETF-files_stat getf))
         (data (assoc x stat))
         (s 0) (d 0)
       )
     (if data
       (begin
        (set! data (cdr data))
        (set! s (cadr data))
        (set! d (list-ref data  3))
        (cons s d)
      )
      (cons 0 "")
     )
))

(define (file-stat-slink x)
  (let* ((s (file-stat x)))
     (if (file-is-slink? x)
          (list* (car s) (string-append "->" (read-slink x)) (cddr s))
          s
     )
)) 

(define (getf-glob getf)
   (let*  ((dirs (glob-dir-dot))
           (files (apply glob-file (GETF-ext getf)))
           (fstat (map (lambda(x) (cons x (file-stat-slink x)))  files))
         )
    (set!  files (sort files  string<?))
    (set-GETF getf :dirs dirs :files files :allfiles (append  dirs files)
                 :files_stat fstat)
))
;;;(export 'make-files-win)
;;;(use-package "get-file" "ss")
;; (define x (make-GETF))
;; (set-GETF x :top (gen-toplevel ".test"))
;; (make-files-win x)

