;;;  R-subr.ss
;;;   

(in-package "regexp")

;;; group-ref
(define (group-ref x  state)
   (let* ( (ans #f))
    ;;; (format #t "gref x ~s~%" x)
       (cond ((number? x )
               (group-ref-num  x   state)   )
             ((symbol? x)
                (set! x (assoc x *named-group*))
                 (if x (set! x (cdr x)))
                (while (and (pair? x) (not ans))
                   (set! ans (group-ref-num (pop x)  state))
                )
                ans
                )
            ((pair? x)
                 (R-cmp-string (R-call x state) state)
              )
       )
))
                                                                                                     
(define (group-ref-num  n    state)
  (let* ((i (Rindex state)) (gr (get-group state )) (cont #t)(s 0)(e 0))
     ;;;;(format #t "gref ~s~%" gr)
     (set! e (assoc (list 'g-end n) gr))
     (set! s (assoc (list 'g-top n) gr))
     (set! cont (and s  e))
     (when cont
        (set! s (cdr s))
        (set! e  (cdr e))
        ;;;;;(format #t "gref str ~s ~s~%" s e)
         (while (and cont (< i *regexp-length*)  (< s e))
             (set! cont  (regexp-char=?
                  (string-ref *regexp-string* s) (string-ref *regexp-string* i)))
             (inc s)(inc i)
         )
         (set! cont (and cont (= s e)))
     )
    (if cont
       (begin
           (set-Rindex state i)
           state
      )
    #f)
))

(define (R-cmp-string str state)
   (if str
        (R-cmp-string-main str state)
        #f
   )
)
  
(define (R-cmp-string-main str state)
    (let* ((i (Rindex state)) (cont (>= i 0))(s 0)(e (string-length str)))
         ;;;(format #t "cmp-string i ~s str ~s state ~s~%" i str state)
         (while (and cont (< i *regexp-length*)  (< s e))
             (set! cont  (regexp-char=?
                  (string-ref str s) (string-ref *regexp-string* i)))
             (inc s)(inc i)
         )
         (set! cont (and cont (= s e)))
    (if cont
       (begin
           (set-Rindex state i)
           state
      )
    #f)
))

(define (R-search-str  str  i)
    (let* ((cont #t)(k i)(s 0)(e (string-length str))(ans #f)(up (- *regexp-length* e)))
         ;;;(format #t "cmp-string i ~s str ~s state ~s~%" i str state)
       (if (< i 0) (set! i 0))
       (while (and (not ans) (<= i up))
          (set! k i)
          (set! cont #t)
          (set! s 0)
         (while (and cont  (< s e))
             (set! cont  (regexp-char=?
                  (string-ref str s) (string-ref *regexp-string* k)))
             (inc s)(inc k)
         )
         (if (and cont (= s e))
                (set! ans i)
                (inc i)
         )
         
       )
     ans
))

(define (str-group-ref x state)
    (str-group-ref-aux  x state #f)
)

(define (index-group-ref x state)
    (str-group-ref-aux  x state #t)
)
   
(define (str-group-ref-aux  x state ind)
   (let* ( (ans #f))
    ;;; (format #t "gref para ~s~%" para)
       (if (number? x )
          (if (eq? x 0)
               (if ind
                    (state->index state)
                    (state->string state)
               )
               (str-group-ref-num  x   state ind)
          )
         (begin
             (set! x (assoc x *named-group*))
              (if x (set! x (cdr x)))
           (while (and (pair? x) (not ans))
              (set! ans (str-group-ref-num (pop x)  state ind))
           )
          ans
         )
       )
))

(define (str-group-ref-num  n    state ind)
  (let* ((gr (get-group state )) (s 0)(e 0))
     ;;;;(format #t "gref ~s~%" gr)
     (set! e (assoc (list 'g-end n) gr))
     (set! s (assoc (list 'g-top n) gr))
     (if (and s  e)
        (if ind
               (cons (cdr s) (cdr e))
               (R-substring (cdr s) (cdr e))
        )
        #f
     )
))


;;;;
(define (r-pos p   state)
  (let* ((i (Rindex state))(ch (R-string-ref i)))
    (cond ((eq? p 'top)
              (if (eq? i 0)
                  state
                 (if (and (eq? *regexp-mode* :multiple)
                        (eq? (R-string-ref (- i 1)) #\newline))
                      state
                      #f
                 )
              )
          )
          ((eq? p 'abs-top)
              (if (eq? i 0)
                  state
                  #f
               )
           )
          ((eq? p 'end)
            ;;; (format #t "r-end  ind ~s~%" i)
              (if (eq? i *regexp-length*)
                  state
                 (if (eq? (R-string-ref i ) #\newline)
                    state
                     #f
                 )
              )
           )
          ((eq? p 'abs-end)
            ;;; (format #t "r-end  ind ~s~%" i)
              (if (eq? i *regexp-length*)
                  state
                   #f
               )
           )
          ((eq? p :ws)
             (if (and (r-word? ch)
                      (not (r-word? (R-string-ref (- i 1)))))
                    state #f)
             )
           ((eq? p :we)
             (if (and (not (r-word? ch))
                       (r-word? (R-string-ref (- i 1))))
                    state  #f)
             )
           ((eq? p :wse)
             (if (or (and (not (r-word? ch))
                       (r-word? (R-string-ref (- i 1))))
                     (and (r-word? ch)
                      (not (r-word? (R-string-ref (- i 1))))))
                    state  #f)
             )
            ((eq? p :wsenot)
             (if (and (or (not (r-word? ch))
                       (r-word? (R-string-ref (- i 1))))
                     (or (r-word? ch)
                      (not (r-word? (R-string-ref (- i 1))))))
                    state   #f)
             )
           ((pair? p)
                (if (= (car p) i) state #f)
             )
           (else #f)
    )
))

;;;;  For R-read.ss   modori yomi length estimate
;;;;    return max bytes or #f
;;;;
(define (R-count exp)
  (let* ((n 0)(m 0))
  (if (null? exp)
          0
      (begin
         (set! n (R-count-pat (car exp)))
         (if n
             (begin
                (set! m (R-count (cdr exp)))
                (if m (+ n m) #f)
             )
            #f
        )
     )
  )
))

(define (R-count-pat  pat)
  (let* ((top (pop pat)))
     (cond ((keyword? top) (R-count-key top  pat))
           ((eq? top 'string) (length  pat))
           ((eq? top 'pure-string) (string-length  (car pat)))
           ((eq? top 'group-ref) #f)
           ((eq? top 'nfa-ref) #f)   ;;;;;   
           (else 0)
      )
))

(define (R-count-key top  pat)
  (let* ((n #f)(m 0)(k 0)(c 0)(try #f))
     (cond ((eq? top :or) 
               (set! n (R-count  (car pat)))
               (if n
                 (begin
                   (set! m (R-count  (cadr pat)))
                   (if m (max n m) #f)
                 )
                 #f
              )
            )
          ((eq? top :if)
               (set! c (pop pat))
               (set! n 
                  (if  (pair? c)
                          (cond ( (eq? (car c) :test)    
                                      (R-count (cadr c))  )
                              ;;;  ( (eq? (car c) :try)    ;;;   :try!!!
                              ;;;        (set! try #t)
                              ;;;        (R-count (cadr c))  )
                                (else #f)    ;;;; proc call
                          )
                      0   ;;;; capture check
                   )
               )
              (if n
                 (begin
                     (set! m (R-count (car pat)))
                      (if m
                          (if (pair? (cdr pat))
                              (begin
                                 (set! k (R-count (cadr pat)))
                                 (if k 
                                    (if try
                                           (+ n (max  m k))   ;;; for try!!!  
                                           (max  n  m k)   ;;; for test
                                    )
                                    #f
                                 )
                              )
                             (if try
                                (+ n m)   ;;; for try!!!
                                 (max n m)   ;;; for test
                             )
                          )
                         #f
                      )
                  )
                 #f
             )
           )
          ((or (eq? top :not)(eq? top :atomic)(eq? top :forward))
               (R-count   (car pat)))
          ((eq? top :back)
               (R-count   (car pat)))
          ((eq? top :backward)
               (R-count   (car pat)))
          ((eq? top :?)
               (R-count   (car pat)))
           ((eq? top :range)
                (set! n (cdr (pop pat)))
                (set! m (R-count   (car pat)))
                (if m (* n m) #f)
             )
          ((eq? top :begin)
              (R-count   pat))
          (else  #f)
    )
))
;;;;

(define (nfa-ref x state)
  (let* ((nfa 0)(new 0)  ;;;(bug 0)
            (fchar regexp-char=?) (mode *regexp-mode*)
            (num *group-num*)(gr *named-group*) (orgnfa *regexp-nfa*))
    (if (symbol? x) 
           (set! nfa (symbol-value x))
           ;;;(set! nfa (eval x))
           (set! nfa (R-call x state))
     )
    ;;;(format #t "nfa-ref nfa  state ~s ~%" nfa state)
    (inc *debug-depth* )   ;;; for debug out
    (set! nfa (regexp->nfa nfa))
    (set! new (pop nfa))
    (set! *group-num* (car new))
    (set! *named-group* (cadr new))
    (set! *regexp-nfa*  nfa)
    (set! new (copy-state state))
    (set! *regexp-state*  new)   ;;; for match-string
    (set! new (regexp-nfa (init-state new (Rindex state))))
    (when new
          ;;;(set! bug (state->string new))
          (set! new (state->index new))
          (set-Rindex state (cdr new))
    )
    (set! *group-num* num)
    (set! *named-group* gr)
    (set! *regexp-nfa* orgnfa)
    (set! regexp-char=? fchar)
    (set! *regexp-mode* mode) 
    (set! *regexp-state*  state)
    (dec *debug-depth* )   ;;; for debug out
    ;;;(format #t "nfa-ref 2  new ~s state ~s bug ~s~%" new state bug)
   (if new state #f)
))
    
    
               
;;;; for test
(define (ct exp)
   (R-count (cdr exp))
)

                                                                                                 

  
    
