;;;   files-win.ss
;;;      2005.3.15 
;;;     for sftp
;;;

;;;
(load "tclglob")
(require  "dialog")
(require  "ftp-base")
(in-package "get-file")

(load "dir-copy")
(load "rmdir")

;;;(in-package "get-file-list")
(define *get-file-list* ())
;;;;(define *file-ext* "")   ;;; common for all win

(define (system-local local)
  (let* ((s (shell-entry local)))
    (when (and s (not (equal? s "")))
       (catch (system s))
       (dir-reset local)
    )
))

(define (make-local-files top)
 (let* ((win 0))
   ;;;;(if (null? ext) (set! ext '("*")))
   (set! *file-ext* '("*"))
  ;;; (set! top (gen-toplevel '.get-files))
   (set! win (make-FILES_WIN :filestop top  :cwd (getcwd) :chd local-chd  :name "Local Shell" 
        :name_cmd (lambda() (system-local win))
        :rename rename_local  :remove remove_local :mkdir mkdir_local)) ;:sort string<?
   (files-win win)
))

(define (make-remote-files top)
 (let* ((win 0))
   (set! *file-ext* '("*"))
   (set! win (make-FILES_WIN :filestop top  :cwd (remote-pwd)    :name *access*
                :glob_func remote-glob-file 
                 :getcwd remote-pwd  :chd remote-chd :mkdir mkdir_remote
         :rename rename_remote  :remove remove_remote :stat_func remote-stat
                 ) )
   (files-win win)
))

(define (local-chd dir)
  (let* ((s 0)(n 0))
    (chdir dir)
   (send-msg (tk-string "lcd " dir))
   (read-p)
   dir
))

(define (move_local local remote)
   (let* ((files  (copy_local local remote))
          (dirs (FILES_WIN-dirs local))
         )
      (map (lambda(x ) (if (member x dirs) (rmdir-local-rec x local) (remove-file x))) files)
   (dir-reset local)
))


(define (move_remote local remote)
   (let* ((files  (copy_remote local remote))
          (dirs (FILES_WIN-dirs remote))
         )
      (map (lambda(x ) (if (member x dirs) (rmdir-remote-rec x remote) (remote-remove-file x))) files)
   (dir-reset remote)
))
   
(define (copy_local local remote)
   (let* ((lb (FILES_WIN-win local))
          (ind (listbox-index lb))
          (files (FILES_WIN-allfiles local))
          (dirs (FILES_WIN-dirs local))
          (res ())
          (x 0)
         )
    (while (pair? ind)
       (set! x  (list-ref files (pop ind)))
        (push x res)
       (if (member x dirs)
            (copy_dir_local x local remote)
         (begin
            (if (and (file-is-slink? x)(file-is-directory? (read-slink x)))
                 (format #t "ERROR: Cannot upload symbolic link  ~a -> ~a ~%" x (read-slink x))
               (begin
                 (send-msg (tk-string "put " *-P* x))
                 (read-p) 
              )
            )
         )
       )
    )
   ;;;(format #t "~s~%" res)
   (dir-reset remote)
  res
))

(define (copy_remote local remote)
   (let* ((lb (FILES_WIN-win remote))
          (ind (listbox-index lb))
          (files (FILES_WIN-allfiles remote))
          (dirs (FILES_WIN-dirs remote))
          (res ())
          (x 0)
         )
    (while (pair? ind)
       (set! x  (list-ref files (pop ind)))
       (push x res)
        (if (member x dirs)
            (copy_dir_remote x local remote)
           (begin
             (send-msg (tk-string "get " *-P* x))
             (read-p)
          )
        )
    )
   ;;;(format #t "~s~%" res)
   (dir-reset local)
  res
))

(define (remove_local local)
   (let* ((lb (FILES_WIN-win local))
          (ind (listbox-index lb))
          (files (FILES_WIN-allfiles local))
          (dirs (FILES_WIN-dirs local))
          (res ())
          (x 0)
         )
    (while (pair? ind)
       (set! x  (list-ref files (pop ind)))
       (if (member x dirs)
           (rmdir-local-rec   x  local)
           (remove-file x)
       )
       (push x res)
    )
   ;;;(format #t "~s~%" res)
   (dir-reset local)
  res
))

(define (remove_remote  remote)
   (let* ((lb (FILES_WIN-win remote))
          (ind (listbox-index lb))
          (files (FILES_WIN-allfiles remote))
          (dirs (FILES_WIN-dirs remote))
          (res ())
          (x 0)
         )
    (while (pair? ind)
       (set! x  (list-ref files (pop ind)))
       (if (member x dirs)
          (rmdir-remote-rec   x  remote)
          (remote-remove-file x)
       )
       (push x res)
    )
   ;;;(format #t "~s~%" res)
   (dir-reset remote)
  res
))

(define (remote-remove-file x)
       (send-msg (tk-string "rm " x))
       (read-p)
)

(define (rmdir-remote x)
       (send-msg (tk-string "rmdir " x))
       (read-p)
)

(define (mkdir_local local)
   (let* ( (x 0) )
   (set! x (new-name (FILES_WIN-allfiles  local) (FILES_WIN-top local) #f))
   (when x
     (mkdir x)
     (dir-reset local)
   )
  x
))

(define (mkdir_remote remote)
   (let* ( (x 0) )
   (set! x (new-name (FILES_WIN-allfiles remote)(FILES_WIN-top remote) #f ))
   (when x
     (send-msg (tk-string "mkdir  " x))
      (read-p)
      (dir-reset remote)
   )
  x
))

(define (rename_local local)
  (let* ((lb (FILES_WIN-win local))
          (ind (listbox-index lb))
          (files (FILES_WIN-allfiles local))
          (x 0) (y 0)
         )
    (while (pair? ind)
       (set! x  (list-ref files (pop ind)))
       (set! y (new-name  files (FILES_WIN-top local) x))
       (when y
          (rename-file x y)
          (set! files (cons y (remove x files)))
          (dir-reset local)
       )
    )
   ;;;(format #t "~s~%" res)
   ;;;(dir-reset local)
))

(define (rename_remote remote)
  (let* ((lb (FILES_WIN-win remote))
          (ind (listbox-index lb))
          (files (FILES_WIN-allfiles remote))
          (x 0) (y 0)
         )
    (while (pair? ind)
       (set! x  (list-ref files (pop ind)))
       (set! y (new-name  files (FILES_WIN-top remote) x))
       (when y
          (send-msg (string-append "rename  " x " " y))
          (read-p)
          (set! files (cons y (remove x files)))
          (dir-reset remote)
       )
    )
   ;;;(format #t "~s~%" res)
))

(define (get-win-pos win)
   (cons (winfo 'rootx win)(winfo 'rooty win))
)

(define (new-name exists win  orig)
   (let* ((top (gen-toplevel ".new"))
          (lb (tk-name top ".lb"))
          (ent (tk-name top ".ent"))
          (can (tk-name top ".can"))
          (msg "Newname")
          (pos (get-win-pos win))
          (geo 0)
        )
     (set! geo (tk-string "300x30+" (+ (car pos) 10) "+" (+ (cdr pos) 5)))
    ;;;(wm 'geometry top "250x100+80+80")
    (wm 'geometry top geo)
     (if  orig ( set! msg "Rename"))
     (label lb :text msg)
     (entry ent)
     (if  orig (funcall ent 'insert 'insert  orig))
     (button can :text "CANCEL" :command (lambda() (set! ent #f) (destroy top)))
     (grid lb ent )
     (grid can :row 0 :column 2 :sticky 'e)
     (bind ent  "<Return>" (lambda() (set! ent (funcall ent 'get)) (destroy top)))
     (focus ent)
     (grab top)
     (tkwait 'window top)
     (if (member ent exists)
         (new-name exists win orig)
         (if (symbol? ent)    ;;;; when user push  [x]  to destroy top!!!
              #f
               ent
         )
     )
))

(define (remote-stat fileswin x)
  (let* ((stat (FILES_WIN-files_stat fileswin))
         (data (assoc x stat))
        )
   (if data
        (cdr data)
        (cons 0 "")
   )
))

(define (remote-glob-file  fileswin)
  (let* ((ext (FILES_WIN-ext fileswin)) (x 0)(s 0)(size 0)
          (res ())(dir ())(state ())(attr 0)(file 0))
  ;;; compile ext
   (when (and (pair? ext) (string? (car ext)))
       (set! ext (map tclglob:glob-pat ext))
       (set-FILES_WIN fileswin :ext ext)
   )

   (send-msg "ls -l")
   (set! s (read-p))
   (while (pair? s)
      (set! x (pop s))
      (set! x (split-string x " "))
      ;;;  Caution!!!   this mae be changed other version of sftp
      (set! attr (car x))
      (set! file (list-ref x 8))
     ;;; (format #t "~a ~a~%" attr file)
      (if (eq? (string-ref attr 0) #\d)
            (begin
               (if (not (equal? file ".."))
                  (push file dir)
               )
            )
           (when (glob-remote (string->list file) ext)
                (push file res)
                (set! x (cddr x))
                (set! x (cddr x))
                (set! size (pop x))
                (if (eq? (string-ref attr 0) #\l)
                     (set! size "slink")
                )
                 (set! x ( string-append (car x) " " (cadr x)" " (caddr x)))
                 (push (cons file (cons size x)) state)
          )
      )
   )
  (set! dir (cons ".." dir))
  (set!  res (sort res string<?)  )
  (set-FILES_WIN fileswin :dirs dir :files res :allfiles (append dir res)
           :files_stat state)
                                                                                                         
))

(define (glob-remote file pats)
   (if (pair? pats)
       (if (tclglob:glob-match (car pats) file)
             #t
            (glob-remote file (cdr pats))
        )
      #f
   )
)

(define (files-win  fileswin)
  (let*  ((n-files 0)
          ;;; (dir (gen-toplevel ".dir"))
           (dir (FILES_WIN-filestop fileswin))
           (name (FILES_WIN-name fileswin))
           (name-cmd  (FILES_WIN-name_cmd fileswin))
           (fr (tk-name dir ".frame"))
           (remove-func (FILES_WIN-remove fileswin))
           (mkdir-func (FILES_WIN-mkdir fileswin))
           (rename-func (FILES_WIN-rename fileswin))
           (mkdir (tk-name  dir ".mkdir"))
           (lab  (tk-name  dir ".name"))
           (remove (tk-name  dir ".remove"))
           (rename (tk-name  dir ".rename"))
          )
     (if name-cmd
        (button lab :text name :command name-cmd)
        (label lab :text name)
     )
     ;;;(grid labfiles :row 0 :column 4)
     (frame fr)
     (set-FILES_WIN fileswin :top fr)
     (make-files-win fileswin)
     (funcall (FILES_WIN-win fileswin) 'configure :selectMode 'extended)
     (grid fr :columnspan 4)
     (button remove  :text "remove" :command  (lambda()(funcall remove-func fileswin)))
     (button mkdir  :text "mkdir" :command  (lambda()(funcall mkdir-func fileswin)))
     (button rename  :text "rename" :command  (lambda()(funcall rename-func fileswin)))
     (grid remove :row 1 :column 3  )
     (grid lab :row 1 :column 2  )
     (grid rename :row 1 :column 1  )
     (grid mkdir :row 1 :column 0  )
  fileswin
))

;;;(export 'get-file-list)
;;;(use-package "get-file-list" "ss")
;;;(make-local-files (gen-toplevel ".text"))


