;;;  ssftp session manager
;;;  2005.3.19
(in-package "get-file")
;;;
   (load "ssftp-main")
   (load "ftp-win")

(define *session* (tk-string *HOME* "/.ssh"))
(define *access* "")
;;;;  before create  ssftp window , we need dummy function
(define (*status* config opt x . rest)
    (if *echo* (format #t "~a~%" x)))

(if (not (file-exists? *session*))
      (mkdir *session*)
)

(set!  *session* (tk-string *session* "/ssftpsession"))

(if (not (file-exists? *session*))
     (system (tk-string "touch " *session*))
) 
;;;
(define (session)
    (let* ((top (gen-toplevel ".ssftp"))
           (file (tk-name top ".file"))
           (lis (tk-name top ".lis"))
           (fr (tk-name top ".frame"))
           ;;(loa (tk-name fr ".loa"))
           (save (tk-name fr ".save"))
           (cancel  (tk-name fr ".can"))
           (space (tk-name fr ".sp"))
           (space2 (tk-name fr ".spb"))
           (ok  (tk-name top ".ok"))
           (user-lab (tk-name top ".ulab"))
           (user-ent (tk-name top ".uent"))
           (host-lab (tk-name top ".hlab"))
           (host-ent (tk-name top ".hent"))
           (slis 0)
         )
     (label file :text *session*)
     (listbox lis)
     (bind lis "<Button-1>" (lambda() (set-host lis slis host-ent user-ent )))
     (bind lis "<Double-1>" 
           (lambda ()
              (set-host lis slis host-ent user-ent )
             (make-session  host-ent user-ent )(destroy top)))
     (set! slis (read-session lis)) 
     (frame fr)
     ;;;(button loa :text "LOAD" :command (lambda() (set-host lis slis host-ent user-ent )))   
     (button save :text "SAVE" :command 
              (lambda() (set! slis (save-host lis slis host-ent user-ent ))))
    
     (button cancel :text "EXIT" :activebackground 'red  :command 
        (lambda () (bye)))
  
     (button ok :text "OK"  :command 
           (lambda ()(make-session  host-ent user-ent )(destroy top)))
     (label space)
     (label space2 :height 2)
     (label host-lab :text "host")
     (entry host-ent)
     (label user-lab :text "user")
     (entry user-ent)
;;;
     (grid cancel :sticky 'n)
     (grid space)
     ;;;;(grid loa )
     (grid space2)
     (grid save  :sticky 's)
;;;
     (grid file)
     (grid lis :columnspan 4 :sticky 'news) 
     (grid fr :row 1 :column 4)
     (grid host-lab host-ent user-lab user-ent ok)
   top
))

(define (read-session lis)
  (let* ((in (open-input-file *session*))
         (x 0) (res ())
       )
    (set! x (read-line in))
    (while (not (eof-object? x))
       (funcall lis 'insert 'end x)
       (push x res)
       (set! x (read-line in))
    )
  (reverse res)
))

(define  (set-host lis slis host-ent user-ent )
   (let* ((f (listbox-index lis)))
     (when (pair? f)
        (set! f (car f))
        (set! f (list-ref slis f))
        (set! f (string-split f " "))
        (funcall host-ent 'delete 0 'end)
        (funcall user-ent 'delete 0 'end)
        (when (pair? f)   
           (funcall host-ent 'insert 'end (pop f))
           (if (pair? f)
              (funcall user-ent 'insert 'end (pop f))
           )
       )
    )
))

(define (save-host lis slis host-ent user-ent )
   (let* ((x (funcall host-ent 'get)) (out (open-append-file *session*)))
     (set! x (tk-string x " " (funcall user-ent 'get)))
     (format out "~a~%" x)
     (close-port out)
     (push x slis)
     (funcall lis 'insert 'end x)
    slis
))

(define (make-session  host-ent user-ent )
   (let* ((x (funcall host-ent 'get)) (user 0) )
     (set! user  (funcall user-ent 'get))
     (if (not (equal? user ""))
         (set! x (tk-string user "@"x))
     ) 
    (set! *access* x)
))

(define (help-ssftp)
  (format #t "ssftp should be executed in silent-mode~%")
  (format #t "Try~%")
  (format #t "  ssftp~%")
  (format #t "or~%")
  (format #t "  ss -s ssftp-start~%")
  (bye)
)

(define (start-ssftp)
  ;;; (if (not (silent-mode?)) (help-ssftp))
   (tkwait 'window (session) )    
   (if (equal? *access* "") (bye))
   (format #t "dir-reset ~s~%" dir-reset)
   (run-sftp)
   (send-msg "pwd")
   (read-p)  ;;; wait for the first prompt
;;;(format #t "connection OK!~s~%")
;;;(format *out* "ls~%")
;;;(flush *out*)
;;;(make-win (read-p))
  (tkwait 'window (sftp-win))
  (send-msg "exit")
   (bye)
)

(export 'start-ssftp)          
;;(start-ssftp)

