;;;;  pat-pre.ss
;;;; 2004.3.25
;;;;   pattern pre transform 
;;;; 4.3
;;;;  2005.10.11 revised
;;;;  2005.10.16 revised
;;;;       
#|
  trans defitiniton:
  1. symbol 
       macro   => (macro key)
       literal -> (literal word ass)
                   ass is (assoc word env)
       pat variable -> (pat var)
  2. constants
      (), keyword,string,etc.   No change
  3. (P ...   .  Q)
       ->   ((...  (trans P)) )   if Q==()
       ->   ((...  (trans P)) *dot-mark*  (trans Q)) 
  4. (P . Q)
       -> ((trans P) )   if Q==()
       -> ((trans P)  *dot-mark*  (trans Q))
  5. #(P1 ...... Pn)
     ->(vector #f (trans P1) .....)
  6. #(P1 ...... Pn ...)
     ->(vector #t (trans P1) .....  (... (trans Pn)))

   (trans P)  will be a pair or not pair(constants).
|#
(define *macro-key* ())
(define *literal* ())
(define *pat-variable* ())
(define *pat-level* 0)
(define  *pat-variable-level* ())
(define *symbol-trans-func* #f)
(define *alias-data* ())
(define *local-env* ())
(define *name-change* ())

 (define (pat-trans p env)
     (set! *symbol-trans-func* pat-symbol-trans)
     (set! *pat-variable* ())
     (set!  *pat-level* 0)
     (set!  *pat-variable-level* ())
     (set! *dot-mark* '(S-read-dot))
     (exp->linear (pat-trans-common p env))
 )

 (define (pat-trans-common  p env)
   (if (pair? p) 
       (pat-pair-trans p env)
       (if (vector? p)
            (pat-vector-trans p env)
           (if (symbol? p) (*symbol-trans-func*  p env)
                p   ;;; constants
           )
       )
   )
)

(define (pat-symbol-trans p env)
   (cond ((eq? p *macro-key*) (list 'macro p))
         ((memq p *literal*) (list 'literal p (assq p env)))
         (else 
           (set! *pat-variable* (cons p *pat-variable*))
           (set! *pat-variable-level* 
                    (cons  (cons p *pat-level*)  *pat-variable-level*))
           (list 'pat p ))
   )
)


(define (pat-pair-trans p env)
   (let ((top (car p)) (rest (cdr p))(ans 0))
   ;;;; (format #t "pat-pair-trans p ~s ~%" p)
     (if (pair? rest)
        (if (eq? (car rest) '...)
             (begin
                (inc *pat-level*)
                (set! ans (list '... (pat-trans-common  top env)))
                (dec *pat-level*)
                (set! rest (cdr rest))
                (if (pair? rest)
                     (cons ans  (pat-trans-common  rest  env))
                   (if (null? rest)
                      (cons ans  ())
                      (list ans  *dot-mark* (pat-trans-common rest env))
                   )
                )
             )
             (cons (pat-trans-common  top env) (pat-trans-common rest env))
        )
       ;;;(cons (pat-trans-common  top env) (pat-trans-common rest env))
       (if (null? rest)
          (cons (pat-trans-common  top env) ())
          (list (pat-trans-common  top env) *dot-mark* (pat-trans-common rest env))
       )
       ;;; (list (pat-trans-common  top env))      wrong for (f . x)!!!
    )
))

(define (pat-vector-trans p env)
   ;;;(set! p (pat-trans (vector->list p) env))
   (set! p (pat-pair-trans (vector->list p) env))
   (cons 'vector p)
)
#|
(define (pat-vector-trans p env)
   (let ((n (vector-length p)) (res ()) (flag #f)(i 0)(q 0))
      (set! n (- n 1))
      (while (> n 0)
         (push (pat-trans-common  (vector-ref p i) env) res)
         (set! n (- n 1))
         (set! i (+ i 1))
      )
      (if (= n 0)
        (begin
            (set! q (vector-ref p i))
            (if (eq? q '...)
               (begin
                 (set! q (pop res))
                 (push (list '... q) res)
                 (set! flag #t)
                )
                 (push (pat-trans-common  q env) res)
              ) 
          )
      )
      (set! p (cons flag (reverse res)))
      (cons 'vector p)
))
|#              
   
#|
 (define *macro-key* 'cond)
 (define *literal* (list 'else))

 (pat-trans '(cond (else y ...)) ())

 (pat-trans '(cond (test y ...) clause ...) ())

 (define *macro-key* 'do)
 (pat-trans '(do ((var init step ...) ...)
         (test expr ...)
         command ...)   ())   

 (pat-trans '(do ( #(var init step ...) ...)
         (test expr ...)
         #(foo bug)
         ()
         #()
         command ...)   ())
  (template-trans ' (letrec
       ((loop
           (lambda (var ...)
             (if test
                 (begin
                   (if #f #f)
                   expr ...)
                 (begin command ...
                   (loop (do "step" var step ...)
                       ...)
                 )
              )
            )
           ))
        (loop init ...))      ())
 
|#

