;;;;  s-outstream.ss
;;;; 05.10.19 created
;;;;
;;;;  s-outstream can be output  of a linear expresion to S-expression
;;;; 
(define *s-outstream* ())
(define *s-out-dot* #f)
                                                                                    
;;;(define *eof-object* (integer->char -1))

;;;  write 
(define (S-write s )
   ;;;(push (list SS-write (list quote s)) *s-outstream* )
   (push (list SS-write s) *s-outstream* )
)

(define (SS-write s )
  (let* ((x 0)(new 0))
   (if (null? *s-outstream*)
            (error 653 s)
      (begin
          (set! x (car *s-outstream*))
         (cond (*s-out-dot*
                 (set-cdr! x s)
                 (set! *s-out-dot* #f)  )
               (else
                  (set! new  (cons s ()))
                  (set-cdr! x new)
                  (set-car! *s-outstream* new)  
              )
       )
     )
  )
))

;;;;  request to ( ...)
(define (S-write-left)
   (push (list SS-write-left) *s-outstream* )
)

(define (SS-write-left)
  (let* ((x 0)(new (cons () ()) ))
     (if (null? *s-outstream*)
         (begin
             (push new *s-outstream*)
             (set! x (cons ()()) )
             (push x *s-outstream*)
             (set-car! new x)
         )
         (begin
              (set! x (car *s-outstream*) )
              (set-cdr! x new)
              (set-car! *s-outstream* new)  
              (set! x (cons ()()) )
              (set-car! new x)  
              (push x *s-outstream*)
         )
    )
))

;;;;  request  right-par
(define (S-write-right)
   (push (list SS-write-right) *s-outstream* )
 )

(define (SS-write-right)
   (if (null? *s-outstream*)
            (error 654 s)
      (let* ((x 0)(dest 0)) 
         (pop *s-outstream*)
         (set! x (car *s-outstream*))
         (set! dest  (car x))
         (set-car! x (cdr dest))
         (set! *s-out-dot* #f) 
      )
    )
)
;;;;  request  dot
(define (S-write-dot)
   (push (list SS-write-dot) *s-outstream* )
)

(define (SS-write-dot)
   (set! *s-out-dot* #t) 
)

;;;;   request to write  vector
(define (S-write-vector-left)
   (push (list SS-write-vector-left) *s-outstream* )
)

(define (SS-write-vector-left)
   (let* ((x 0))
      (SS-write-left)
      (set! x (pop *s-outstream*))
      (push 'vector *s-outstream*)   ;;;; mark
      (push x *s-outstream*)
))

;;; request end of vector
(define (S-write-vector-right)
   (push (list SS-write-vector-right) *s-outstream* )
)

(define (SS-write-vector-right)
    (if (null? *s-outstream*)
            (error 654 s)
      (let* ((x 0)(dest 0))
         (pop *s-outstream*)
         (set! x (pop  *s-outstream*))
         (if  (not (eq? x 'vector)) (error 658 "vector-right"))
         (set! x (car *s-outstream*))
         (set! dest  (car x))
         (set-car! x (list->vector (cdr dest)))
      )
    )
)


;;;;  init
(define (S-write-init )
   (set! *s-outstream* ())
   ;;;;(set!  *s-out-dot* #f)
   (push (list SS-write-left) *s-outstream* )
   ;;;(S-write-left)
)

(define (S-write-close)
  (let* ((s 0))
   (set!  *s-out-dot* #f)
   (S-write-right)
   (set! s  (reverse *s-outstream*))
   (set!  *s-outstream* ())
   ;;;(for-each (lambda (x) (eval x ()) ) s)
  ;;; Don7t use eval , since eval call macro-expand-rec!!!
   (for-each (lambda (x) (apply (car x) (cdr x))) s)
   (if (pair? (cdr  *s-outstream*))   (error 659 "incomplete write"))
   (caaar  *s-outstream*)
))
;;;     for rewind out stream
(define (S-write-get )
   *s-outstream* 
)

(define (S-write-set  org )
   (set! *s-outstream*  org)
)
#|
(define (copy-tree x)
  (if (pair? x)
      (cons (copy-tree (car x)) (copy-tree (cdr x)))
      x
  )
)
|#

