;;;  get-data.ss
;;;
;;;   05.10.23

(define (var-level v)
   (cdr (assq v *pat-variable-level*))
)

(define (init-get-data)
   (clear-hash *dot-hash*)
   (for-each 
          (lambda (x) (set-hash *data-hash* (car x)
                          (list 0 (cdr x) 0) ))
           *match-data*   ;;;; level 0
   )
  (map-hash  (lambda (v data) 
      (set-hash *dot-hash* v (list (var-level v)  data #f)) )
      *data-hash*
   )
)

(define (get-data v level)
   (let* ((s (get-hash *dot-hash* v))
            (n (car s)) (x 0))
      (cond ( (eq? n 0)
                  (cadr (cadr s )) )
            ((<= n level) 
               (new-get-dot-data v s n level ))
           (else
              (error 755 v)
           )
      )
))

(define (new-get-dot-data v s n level )
   (let* ((dp (cddr s)) (d (car dp)) (x 0) )
     (if (pair? d)
        (begin
           (set! x (pop d))
           (set-car! dp d)
           x
        )
       *eof-object*   ;;;  no data
    )
))

(define (get-request v level)
   (let* ((s (get-hash *dot-hash* v))
            (n (car s)) (x 0))
      (cond ( (eq? n 0)
                   #t  )  ;;;; do nothing
            ((= n level)
               (request-dot-data v s  level ))
            (else
               (request-dot-data-shift v s level ))
      )
))

(define (shift-request v level)
   (let* ((s (get-hash *dot-hash* v))
            (n (car s)) (x 0))
      (if (eq? n 0)
              #t
           (request-dot-data-shift v s level )
       )
))

(define (request-dot-data v s n)
   (let* ((posp (cdr s)) (pos (car posp)) (x #t) (cont #t))
  ;;; (format #t "Enter request dot data v ~s n ~s  pos ~s~%" v n  pos)
     (while (and (pair? pos) cont)
          (set! x (pop pos ))
           ;;;(format #t "request data n ~s x ~s pos ~s~%" n x pos)
          (if (pair-null? x)
              (begin
                 (set-car! posp pos)
                 (set-car! (cdr posp) x)
                 (set! cont #f)
  ;;;(format #t "request dot data  success  v ~s n ~s  data  ~s~%" v n x)
                )
              (if (number? x)
                 (when (not (eq? x n))
  ;;;(format #t "request dot data  fail  v ~s n ~s  x ~s pos ~s ~%" v n x pos)
                    (set! cont #f)
                    (set-car! posp (cons x pos))
                    (set-car! (cdr posp) #f) 
                 )       
              )
          )
     )
   ;;; (format #t "Exit request dot data v ~s n ~s  posp ~s~%" v n  posp)
  (cadr posp)   ;;;  data ready (but maybe ())
 ))

(define (request-dot-data-shift v s level )
   (let* ((posp (cdr s)) (pos (car posp)) (x #t) (cont #t))
      (when (pair? pos)
          (set! x (pop pos ))
          ;;; (format #t "shift n ~s level ~s x ~s pos ~s~%" n level x pos)
          (when (and (number? x)(= x level))
   ;;;  (format #t "shift level success  ~s v  ~s pos ~s~%"  level v pos)
                 (set-car! posp pos)
                 (set-car! (cdr posp) #f)
                 (set! cont #f)
          )
      )
  (equal? x level)  ;;;;  succes??
))


(define (init-get-request v)
  (let* ((n (var-level v)) ( s (get-hash *data-hash* v)))
           (set! s  (list n s #f) )
    ;;;;   (format #t "init-get var  ~s  pos ~s~%" v s)
           (set-hash *dot-hash* v s )
         ;;;;  (init-request-dot-data v s  n )
))



