;;;;  help  for  GUI
;;;;  04.8.31
;;;;
;;(load "select-dialog")
;;(load "mesg")
(require "dialog")
(in-package "sshelp")
(define *kanji* (kanji-mode))
(define DOC
   (cond ((eq? *kanji* :utf8 ) "Doc/")
         ((eq? *kanji* :euc ) "Doc_euc/")
         (else "Doc_english/")
   )
)

(set! DOC (string-append *SSLIBDIR* DOC))

(define HOME (pwd))
(if (file-exists? DOC)
    (chdir DOC)
)
(define *note* (glob "*"))
(define *help-win* ())
(define *sel-win* ())
(define *help-words* ())

(chdir HOME)

(define (list->tkstring notes)
  (let* ((res ""))
    (if (pair? notes) (set! res (pop notes))) 
    (while (pair? notes)
      (set! res (string-append res " "  (pop notes) ))
    )
  res
))

;;;   (clean-wins var)   var is a list of  widget,  destroy and set () 
(define-syntax  clean-wins
   (syntax-rules ()
     ((clean-wins var)
         (let* ((x 0)(lis var))
           (while (pair? lis)
              (set! x (pop lis))
              (if (winfo 'exists x) (destroy x))
           )
          (set! var ())
         )  )
    )
)


(define bag (list  #\newline #\:))

(define (help-1 word notes)
  (let* ((res 0))
      (chdir DOC)
      (set! res   (exec (tk-string "grep -c " word #\space (list->tkstring notes))))
     (chdir HOME)
   (make-help-list  (string-split res bag))
))

(define (make-help-list lis)
 (let* ((file 0)(count 0)(res ()))
  (while (pair? lis)
    (set! file (pop lis))
    (set! count (string->number (pop lis)))
    (if (> count 0)
        (push (cons  file count) res))
  )
  res
  (sort res (lambda (x y) (> (cdr x) (cdr y))))
))

(define (select-note sel topw)
 (let* ((ans #t))
    (if (= (length sel) 1)
       (begin (display-note  (caar sel)) #f)
       (note-dialog sel topw)   ;;; return dialog-widget for destroy 
    )
))

;;; GUI
(define (note-dialog sel topw)
  (let* ((note 0) (n 0)(lis sel) (items ())(ass ()))
     (while (pair? lis)
        (set! note (pop lis))
        (push (tk-string  (car note) "  " (cdr note)) items)
        (push (cons (car items) note) ass) 
     )
     (select-dialog (reverse items)
          (lambda (x) (set! x (assoc x ass))
                  (if x (display-note (cadr x))) )
         topw
     )
))

(define (display-note note)
  (let* ((topw 0)(txt 0) (ysc 0)(find 0))
    (set! topw (gen-toplevel ".txt"))
    (push topw *help-win*)
    (set! txt (tk-name topw  ".tx"))
    (set! ysc (tk-name topw '.yscroll))
     (wm 'geometry topw "600x650")
    (wm 'title topw (tk-string "Help: " note ))
    (text txt  :exportselection #t
         :yscrollcommand (lambda l (apply (function ysc) 'set l)) )
    (scrollbar ysc :orient 'vertical
          :command (lambda l (apply  (function  txt) 'yview l))  )
    (grid  txt ysc :sticky 'news )
     ;;;;    text enable expand
      (grid 'rowconfigure topw 0 :weight 1)
      (grid 'columnconfigure topw 0 :weight 1)
    (insert-file (tk-string DOC note) txt 'insert)
    (funcall txt 'tag 'configure 'select :foreground 'blue)
    (set! find (map (lambda (x) (all-find-txt txt x)) *help-words*))
    ;;(format #t "find ~s~%" find)
    ;;;(set! find (apply append find))
     (bind txt "<F3>" (lambda ()(my-f3 txt ) ))
     (bind txt "<Key>" (lambda ()(my-f3 txt ) ))
    (my-f3 txt)
    (focus txt)
    topw
))
     

(define (insert-file file txt pos)
  (let* ((s 0))
     (set! s (open-input-file file))
         (do ((x (read-line s)(read-line s)))
           ((eof-object? x)(close-input-port  s))
           (funcall  txt 'insert pos x )
           (funcall  txt 'insert pos #\newline )
         )
))

(define (all-find-txt txt pat)
   (do ((res ()) (pos '(1 . 0))(n 0) (len (string-length pat) ))
       ((not pos) (reverse res))
       (set! pos (find-txt txt pat pos 'end))
        (if pos
           (begin
              (push pos res)
                (funcall txt 'tag 'add 'select  pos (next-pos pos len ))
               (set! pos (next-pos pos len))
               ;(set! n (- 1 n))
            )
         )
    )
)

(define (find-txt txt pat index last)
   ;;;-- indicates end of option
   ;;;   it needs for pat is beginning from '-'  !
   (funcall txt 'search "--" pat index last)
)

(define (next-pos pos n)
      (tk-string (car pos) #\. (cdr pos) " +" n " chars")
)

(define (my-f3 txt)
   (let* (
          (find (funcall txt 'tag 'nextrange 'select "insert + 1 chars"))
            (ind 0)  )
     (if(pair? find)
       (my-f3-sub txt find)
       (begin   ;;; back to top
          (set! find  (funcall txt 'tag 'nextrange 'select '(1 . 0)))
          (when (pair? find)(my-f3-sub txt find)
             ;;; (mesg-dialog "Return to Top" 500)
           )
       )
     )
))

(define (my-f3-sub txt find)
  (let* ((ind (car find)))
        (funcall txt 'see ind)
        (funcall txt 'mark 'set 'insert ind)
))


(define (text-clear top)
   (funcall (tk-name top '.tx) 'delete "1.0" 'end)
     ;;; 1.0 means  line1, column 0
)
(define (help-select  words topw)
 (let* ((memo words) (sel   (map (lambda (x) (cons x 0)) *note*)) (selwin 0))
    (set! *help-words* memo)
    (while (and (pair? words) (pair? sel))
        (set! sel (help-1 (pop words) (map car sel)))
    )
   (if (null? sel)
       (format #t "No match ~s !!!~%" memo)
       (begin
            (set! selwin (select-note  sel topw) )
            (when selwin
               (grid selwin )
               (push selwin *sel-win*)
           )
       )
  )
))

(define (help   .  words)
   (let* ((topw 0)(lab 0)(ent 0)(quit 0)(fr 0))
     (set! words (map tk-string words))
    (set! topw (gen-toplevel ".help"))
    (wm 'title topw "Help")
    (set! lab (tk-name topw  ".lab"))
    (set! ent (tk-name topw  ".ent"))
    (set! quit (tk-name topw  ".quit"))
    (set! fr (tk-name topw  ".fr"))
     (label lab :text "Key Words")
     (grid lab)
     (entry ent :bg 'snow :width 30)  ;;; :font '(courier 12)
     (grid ent)
     (funcall ent 'insert 0 (list->tkstring words))
     (bind ent "<Return>"
           (lambda () (reset-help (funcall ent 'get) topw))) ;;;topw
     (button quit :text "Quit" :command 
              (lambda() (clean-wins *sel-win*)
                  (clean-wins *help-win*)  (destroy topw)))
     (grid quit)
     (frame fr)
     (push fr *sel-win*)
     (help-select words fr)
))


(define (reset-help words topw)
   (let* ( (fr (tk-name topw  ".fr")))
     (clean-wins *sel-win*)
    (set! words (split-string words))
    (frame fr)
    (push fr *sel-win*)
    (help-select words fr)
))

  

;;;(define (help-quit)
     
(export 'help)
(use-package "sshelp" "ss")


