;;;  vm-makesr.ss
;;;;  -> makesr.ss
;;;;   2010.5.10
;;;;    use compiled vm_comp.c , (vm-compile )
;;;;   ss2n  Only

;;;(load "vm-op-table.ss")
;;;(load "compiler.ss")
;;(load "vm-list-final")
;;;(load "vm.ss")
(load "opt")

(define (make-name-sr2 file)
   (let* ((s (split-string file ".")))
     ;;(tk-string (car s) ".sr2")
     (string-append (car s) ".sr2")
  )
)

(define (compile-file file)
   (let* ((sr  (make-name-sr2 file)))
      (makesr2 file)
      (rename-file  "aout.sr2" sr)
   )
)

(define   (makesr2 file)
   (let* ((in (open-input-file file)) (x (read in)) ;;;;(pcst PCST)
           (out (open-output-file "aout.sr2")) )
       (format out "~s~%" 'BEGIN-SR2)
     (while (not (eof-object? x))
          (format #t "~s~%" x)
            (set! x (vm-compile x ()))   ;;; 
            (set! x (c-opt x))    ;;;;  optimize
            (set! x (imm-final x))   ;;;;  IMM-t  etc.
       (format out "~s~%" x)
       (set! x (read in))
    )
       ;;;;(format out "~s~%" 'END-SR2)
   (close-port in)
   (close-port out)
   (format #t "makesr2  ~s END~%" out)
   ;;;;(set! PCST pcst)
))

(define Undef (make-undef))
(define LAMBDA (NUM 'LAMBDA))
(define MACRO  (NUM 'MACRO))
(define (imm-final lis)
   (let* ((res (cons ()())) (memo res) (x 0)(op 0))
      (while (pair? lis)
        (set! x (pop lis))
        (set! op (car x))
       (if (or  (eq? op LAMBDA)(eq? op MACRO))
          (set! x (list op (imm-final (cadr x))))
          (set! x (imm-trans x))
       )
       (set-cdr! res (cons x ()))
       (set! res (cdr res))
      )
    (cdr memo)
))

(define (imm-trans x)
 (let* ((op (car x)) )
   (if (eq? op  2)   ;;;  IMM
         (begin 
            (set! op (cadr x))
            (cond ((eq? op Undef) (list (NUM 'IMM-undef)))
                  ((eq? op #t) (list (NUM 'IMM-t)))
                  ((eq? op #f) (list (NUM 'IMM-f)))
                  ((eq? op ()) (list (NUM 'IMM-null)))
                  ((eq? op 0) (list (NUM 'IMM-0)))
                  ((eq? op 1) (list (NUM 'IMM-1)))
                  (else x)
            )
         )
       x
    )
)) 

(if (pair? *argv*)
  (while (pair? *argv*)
     (compile-file (car *argv*))
     (set! *argv* (cdr *argv*))
  )
  (let* ((s (glob-file "*.ss")) (f 0)(fr 0))
    (while (pair? s)
       (set! f (pop s))
       (set! fr (string-append (substring f 0 :end -2) "sr2"))
       (if (file-exists? fr)
           (if (> (file-time fr)(file-time f)) (set! f #f))
       )
       (when f (format #t "Compile ~s~%" f) (compile-file f))
    )
   )
)
   
(bye)

