
;;;  test str port

;;;(define x (open-output-str "sato"))

;;;;(define y (open-input-str "sato test"))

;;;;  test   func port
#|
(define rf
   (let ((port ()))
      (lambda (x eof)
          (cond ((eq?  x :open) 
                   (set! port (open-input-str "read func test"))
                    port
                   )
                ((eq?  x :close) 
                     (close-port port)  )
                ((eq? x :input)
                     (read-char port))
                ((eq? x :ready) #t)
                (else #f)
           )
       )
   )
)

(define p (open-input-func rf))

(define wf
   (let ((port ()))
      (lambda (x c)
          (cond ((eq?  x :open)
                  (set! port (open-output-str (make-string 10)))
                   port
                  )
                ((eq?  x :close)
                    (close-port port)  )
                ((eq? x :output) 
                    (write-char c port) )
                ((eq? x :flush)
                    (flush port))
                (else #f)
           )
      )
))

(define q(open-output-func wf))
|#
;;;; transcript
(define *transcript* "")

(define rf
   (let ((stdin ())(c 0))
      (lambda (x eof)
          (cond ((eq?  x :open)
                     (set! stdin(current-input-port))
                     stdin
                   ) 
                ((eq?  x :close)
                     (display "**** transcript end *******") )
                ((eq? x :ready)
                     (char-ready? stdin)  )
                ((eq? x :input)
                    (read-char stdin))
                (else #f)
          )
       )
))

(define (wf file)
   (let ((port ())(stdout ())(buff #f))
      (lambda (x c)
          (cond ((eq?  x :open)
                  (set! buff (open-output-str "x"))
                  (set! port (open-output-file file))
                  (set! *transcript* buff)
                  (set! stdout(current-output-port))
                    port
                  )
                ((eq?  x :close)
                      (display (close-port buff) port)
                      (close-port port))
                ((eq? x :output)
                      (cond ((eq? c #\backspace)
                                  (unwrite-char buff) )
                            ((eq? c #\newline)
                                (display (close-port buff) port)
                                (newline port)
                                (set! buff (reopen-str buff))
                              )
                            (else (write-char c buff))
                      ) 
                      ;;;(write-char c port)
                      (write-char c stdout)
                    )
                ((eq? x :flush)
                       ;;;(display (close-port buff) port)
                       ;;;(set! buff (reopen-str buff))
                       (flush port)
                       (flush stdout)
                    )
                (else #f)
           )
       )
))

(define (transcript-on file)
       (tty #f)
       (stdio-push! 1 (open-output-func (wf file)))
       ;;(stdio-push! 0 (open-input-func rf))
)

(define (transcript-off)
       ;;;(close-port (stdio-pull! 0))
       (close-port (stdio-pull! 1))
)
                  
 
