;;;  vm-op-table.ss
;;;  sr2 => compress
;;;
;;; 2010.5.23
;;; Reg-Push Pull  are not used in vm_comp.c
;;;;
(define OP-LENGTH
  '(
    (LOAD . 2) (SET . 2) (IMM . 2)
  (LOADENV . 2)(SETENV . 2) 
  (LAMBDA . 2) (MACRO . 2)
  ( DEFINE . 2) (BIND . 2)   ;;; 7,8
  (JMP2 . 2) (FALSE2 . 2)
  (LAMBDA-BIND . 3) (FUNC . 2) 
  (PUSH . 1) 
  (JSR . 2)          ;;12
  (TAIL-JMP . 3)
  (RETURN . 1)
  (CLOSURE-ENV . 2)
  (LAMBDA-ARGS . 2)  
  (TRUE2 . 2) 
  (SCM->MULTI . 1) (MULTI->SCM . 1)(SCM->BA . 1)(BA->SCM . 1) 
  (SCM->ST . 1) (SCM->ARGS . 1) (ST->SCM . 1)
  (COPY-CC . 1) ( RESTORE-CC . 1 )
   ( IMM-undef . 1) ( IMM-t . 1) (IMM-f . 1) (IMM-null . 1)
   ( IMM-0 . 1)( IMM-1 . 1)
  ;;;  35
  (Push-ENV . 1) (Pull-ENV . 1) (Pull .  2) (Pull-PCST . 2)
  (Push-ARGS . 1)
  (IF-TRUE . 2) 
  (JMP . 2) ( IF-FALSE . 2) (LABEL . 2)
  (LAMBDA-LAST . 3)(ENV->SCM  . 1)
   )
)
(define ALL-OP
   (map car OP-LENGTH)
)

(define (make-op-trans opp)
  (let* ((res ()) (x 0))
    (while (pair? opp)
      (push (cons (pop opp) x) res)
      (inc x)
   )
  res
))
 
(define OP->Num
   (make-op-trans ALL-OP))

(format #t "~s~%" OP->Num)
(define Num->OP
   (list->vector ALL-OP)
)

(format #t "~s~%" Num->OP)


#|
;;;  Reg  ;;; Not used!
(define Reg '(SCM ST BA MULTI ENV ARGS))

(define Reg->Num
   (make-op-trans Reg))

(define Num->Reg
   (list->vector Reg)
)
|#

(define (trans-num oplis)
  (let* ((x 0)(y 0) (n 0)(st (cons ()())) (work st))
    (while (pair? oplis)
       (set! x (pop oplis))
       (set! y (car x))
       (set! n (cdr (assq y OP->Num)))
       (if (or (eq? y  'LAMBDA)  (eq? y 'MACRO))
          (set! x (list n (trans-num (cadr x))))
          (set! x (cons n (cdr x)))
       )
      (set-cdr! work (cons x ()))
     (set! work (cdr work))
   )
  (cdr st)
))
#|
(define (reg->num reg)
     (cdr (assq reg Reg->Num))
)

(define (num->reg n)
     (vector-ref Num->Reg n)
)
|#


(define (num-trans-op  oplis)
  (let* ((x 0)(y 0) (op 0)(st (cons ()())) (work st))
    (while (pair? oplis)
       (set! x (pop oplis))
       (set! y (car x))
       (set! op (vector-ref Num->OP y))
       (if (or (eq? op  'LAMBDA)  (eq? op 'MACRO))
          (set! x (list op (num-trans-op (cadr x))))
          (set! x (cons op (cdr x)))
       )
      (set-cdr! work (cons x ()))
     (set! work (cdr work))
   )
  (cdr st)
))
 
(define (function-look f)
   (set! f (function-body f))
   (if (and f (pair? f)) 
       (num-trans-op f)
       #f
   )
)

(define sr2-look num-trans-op)
;;;  for opt
(define (OP n)  (vector-ref Num->OP  n))

(define (NUM OP)  (cdr (assq OP OP->Num)))
