;;;   sgf.ss
;;;
(define *file-name*  #f)
(define *load-list* ())
(define *io-buff* ())
(define *sgf-tejun* ())
(define *sgf-tejun-main* ())

(define (readc port)
   (if (null? *io-buff*)
          (read-char port)
          (pop *io-buff*)
   )
)

(define (unreadc c)
   (push c *io-buff*)
)

(define (load-sgf-data)
  (let* ((x()))
     (set! x (load-sgf-file))
     (set! *sgf-tejun-main* ())
    (when  (pair? x)
         (set! *sgf-tejun* (sgf->tejun x))
         (sgf-tejun-main)
         (set! *load-list* *sgf-tejun-main*)
          (new-reset)
          (.user.input  'configure :text "Load-OK" :height 2 :width 15)
    )
 *sgf-tejun-main* 
))

(define ( load-sgf-file)
  (let* ( ( stream 0))
     (set! *file-name* (get-file-name "*.sgf"))
    (if (file-exists?  *file-name*)
        (begin
          ;(.l5 :configure :text "Load-")
          (init-param)
          (set! stream (open-input-file  *file-name*))
          (load-sgf stream)
         )
       ()
     )
))      
;(.l5 :configure :text "¾Υե" ))))
(define (space? c)
   (or (eq? c #\space) (eq?  c #\newline)(eq? c #\return))
)

(define (sgf-tejun-main)
  (let* ( (tejun ()) (sgf *sgf-tejun*))
    (do ((te ()))
        ((null? sgf))
        (set! te (pop sgf))
        (if (eq? te 'tejun)
             (pop sgf)
           (begin
             (if (eq? (car te) 'tejun)
                 (set! sgf te)
                 (push (car te) tejun)
             )
           )
         )
    )
  (set! *sgf-tejun-main* (reverse tejun))
  *sgf-tejun-main*
))

(define (load-sgf port)
   (let* ((res ()))
    (do ((c (readc port)))
        ((or (eof-object? c)(eq? c 'end)))
        (cond  
           ((space? c))
           ((eq? c #\(  )
             (do ((c (load-sgf port)(load-sgf port)))
                 ((or (eof-object? c)(eq? c #\)) ))
                  (push c res)
             )
            (set! c 'end))
          ((eq? c #\; )
            (set! res (load-sgf-node port) )
            (set! c  'end))
          ((eq? c #\:)
             (set! c 'end))
          ((eq? c #\) )
             (set!  c 'end))
          (#t
              (push c res))
         )
       (if (eq? c 'end)
               ()
           (set! c (readc port))
       )
     )
  (if (pair? res)
          (reverse res)
          #\)
  )
))

(define (load-sgf-node  port)
   (let* ((res '(node))(name ()))
    (do ((c (readc port)))
        ((or (eof-object? c)(eq? c 'end)))
        (cond
           ((space? c))
           ((or (eq? c #\;) (eq? c #\(  )(eq? c #\)) )
             (unreadc c)
             (set! c 'end))
          ((eq? c #\[  )
            (when (pair? name)
               (push (clist->name (reverse name)) res)
            
               (set! name ())
             )
            (push (load-sgf-value port) res)
            )
          (#t
              (push c name))
         )
       (if (eq? c 'end)
               ()
           (set! c (readc port))
       )
     )
    (if (pair? name)
               (push (clist->name (reverse name)) res)
     )       
   res
))
           
(define (clist->name clist)
    (string->symbol (list->string clist)))

(define (load-sgf-value  port)
   (let* ((res '(value))(name ()))
    (do ((c (readc port)))
        ((or (eof-object? c)(eq? c 'end)))
        (cond
           ;((eq? c #\space))
           ( (eq? c #\] ) 
              (when (pair? name)
               (push (char-list->num/string  (reverse name)) res)
               (set! name ())
             )
             (set! c 'end))
          ((eq? c #\:  )
            (when (pair? name)
               (push (char-list->num/string  (reverse name)) res)
               (set! name ())
             )
             ;(push (load-sgf-value port) res)
            )
          (#t
              (push c name))
         )
       (if (eq? c 'end)
               ()
           (set! c (readc port))
       )
     )
   (reverse res)
))

(define (char-list->num/string  clist)
   (let* ((str (list->string  clist))(c 0))
      (set! c (string->number str))
      (if c
           c
           str
       )
))

(define (str->pos str)
   (let* ((x 0)(clist (string->list str))(a (char->integer #\a)))
     (set! x (- (char->integer (pop clist)) a))
     (+ x (* *n* (- (char->integer (pop clist)) a)))
))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(define *humei* ())

(define (sgf->tejun sgf)
  (set! *humei* ())
  (sgf->tejun-aux  sgf 0 ())
)

(define (sgf->tejun-aux  sgf level his)
  (let* ((res '(tejun))) 
       (set! his (cons level his))
        (push his res)
   (do ((x()))
       ((null? sgf) (reverse res))
       (set! x (pop sgf))
       (if (eq? (car x) 'node)
             (set! x (proc-funcall  (car x) (cdr x)) )
            (begin
             (set! x (sgf->tejun-aux  x level his ) )
             (inc level)
            )
       )
      (if (pair? x) (push x res))
   )
))

(define (proc-funcall . body)
  (let ((x (car body)) (y #f))
     ;;;(catch (set! y (eval x)))
     (if (symbol-bind? x )(set! y (eval x)))
    (if (procedure? y)
       (apply y  (cdr body))
       (begin 
         (push x *humei*)
         (apply humei (cdr body))
       )
    )
))

(define (humei  prop)
   (cons (cdr prop) ())
)
 
(define (node prop)
   (let* ((res ()))
    (do ((p 0))
        ((null? prop))
        (set! p (pop prop))
        (if (pair? p)   
          ()  ;;;;  (value ..)
          (begin
           (set! p (proc-funcall  p  prop))
           (if (pair? (cdr p)) 
                  (push (cdr p) res))
           (set! prop (car p))
          )
        )
    )
   (reverse res)
))

(define  (|GM| prop)
   (let ((v (pop prop)))
      (if (= (cadr v)  1)
               ()   ;;;;Igo
              (error 5555 v)
       )
      (cons  prop  ())
))

(define  (|FF| prop)
      (let ((v (pop prop)))
      (cons  prop  ())
))

(define  (|B| prop)
   (let ((v (pop prop)))
       (set! v (str->pos (cadr v)))
      (list  prop  *KURO* v)
))

(define  (|W| prop)
   (let ((v (pop prop)))
       (set! v (str->pos (cadr v)))
      (list  prop  *SHIRO* v)
))


(define  (|EV| prop)
   (let ((v (pop prop)))
      (cons  prop  ())
))
           
(define  (|SZ| prop)
   (let ((v (pop prop)))
       (set! *n*  (cadr v))
       (set! *n-sitei* *n*)
      (list  prop) 
))

(define  (|KM| prop)
   (let ((v (pop prop)))
       (set! *komi*  (cadr v))
      (list  prop)  
))

(define  (|HA| prop)
   (let ((v (pop prop)))
       (set! *okigo*  (cadr v))
      (list  prop)
))

(define  (|RE| prop)
   (let ((v (pop prop)))
       (set! *result*  (safe-cadr v ""))
      (list  prop)  
))

(define (safe-cadr v default)
  (if (null? (cdr v)) 
        default
        (cadr v)
  )
)


