package require Tkogl

pack [OGLwin .gl -width 300 -height 300 ] -expand yes -fill both

set nx 4
set ny 4
set controlpts \
	"-1.5 -1.5 4   -0.5 -1.5 2.0   0.5 -1.5 -1.0   1.5 -1.5 2.0 \
	-1.5 -0.5 1.0   -0.5 -0.5 3   0.5 -0.5 0   1.5 -0.5 3 \
	-1.5 0.5 4.0   -0.5 0.5 0   0.5 0.5 3   1.5 0.5 4 \
	-1.5 1.5 -2.0   -0.5 1.5 -2.0   0.5 1.5 0   1.5 1.5 -1"

set vstride [expr $nx*3]

eval ".gl eval \
	-matrixmode projection \
	-loadidentity \
	-ortho -4 4 -4 4 -4 4 \
	-map2 map2vertex3 0 1 3 $nx 0 1 $vstride $ny $controlpts\
	-enable map2vertex3 \
	-enable autonormal \
	-material frontandback ambientanddiffuse 0.5 0.5 0.5 \
	-material frontandback specular 1 1 1 \
	-material frontandback shininess 50 \
	-shademodel smooth \
	-frontface cw\
	-lightmodel lightmodeltwoside 1 \
	-enable light0 \
	-enable lighting \
	-enable depthtest"

.gl main \
	-clear colorbuffer depthbuffer \
	-mapgrid2 20 0 1 20 0 1 \
	-evalmesh2 fill 0 20 0 20

set xrot 0
set yrot 0
set pmode fill

bind .gl <Button-1> { set x %x ; set y %y }
bind .gl <B1-Motion> { 
    incr xrot [expr %x - $x] 
    incr yrot [expr %y - $y] 
    set x %x
    set y %y
    .gl eval -matrixmode modelview \
            -loadidentity \
            -rotate $yrot 1 0 0\
            -rotate $xrot 0 1 0
    .gl redraw
}
bind .gl <Button-3> { 
    if {$pmode=="fill"} { set pmode line  } else { set pmode fill } 
    .gl eval -polygonmode frontandback $pmode
    .gl redraw
}
