package require Tkogl

proc createcheckerimg {} {
    image create photo tmp -width 2 -height 2
    image create photo img -width 64 -height 64
    tmp put {{#ffffff #ff0000} {#000000 #ffffff}} 
    img copy tmp -from 0 0 2 2 -zoom 4 4 -to 0 0 64 64
    rename tmp {}
}

proc redisplay {} {
    global yrot dlist
    .gl main -matrixmode projection \
	    -loadidentity \
	    -perspective 30 1 0.1 10 \
	    -matrixmode modelview \
	    -loadidentity \
	    -lookat -3 2 3  0 0 0  0 1 0 \
	    -clear depthbuffer colorbuffer\
	    -rotate $yrot 1 1 0 -call $dlist
    incr yrot 5
    after 10 redisplay
}

pack [OGLwin .gl -width 300 -height 300 ] -side left -expand yes -fill both
pack [frame .cmdframe] -side right -fill y

button .quit -text "Quit" -command exit
pack .quit -in .cmdframe -fill x

radiobutton .cyltex -text "Cylindrical Coordinates" -var texmode -value cyltex\
	-command {
    .gl eval -disable texturegens \
	    -disable texturegent 
}

radiobutton .objlinear -text "Object Linear" -var texmode -value objlinear\
	-command {
    .gl eval -texgen s texturegenmode objectlinear \
	    -texgen t texturegenmode objectlinear \
	    -enable texturegens \
	    -enable texturegent
}

radiobutton .eyelinear -text "Eye Linear" -var texmode -value eyelinear\
	-command {
    .gl eval -texgen s texturegenmode eyelinear \
	    -texgen t texturegenmode eyelinear \
	    -enable texturegens \
	    -enable texturegent
}

radiobutton .checker -text "Checkerboard texture" -var teximg -value checker\
	-command {
    catch {rename img {} }
    createcheckerimg
    .gl eval -teximage2d 0 0 img
}

radiobutton .teapot -text "Teapot Photo texture" -var teximg -value teapot\
	-command {
    global tk_library
    catch {rename img {} }
    image create photo img -file ${tk_library}/demos/images/teapot.ppm
    .gl eval -teximage2d 0 0 img
}



pack .cyltex .objlinear .eyelinear .checker .teapot -in .cmdframe \
	-anchor w

.checker invoke 
.cyltex invoke

.gl eval -teximage2d 0 0 img\
	-enable depthtest \
	-texparameter texture2d texturewraps repeat \
	-texparameter texture2d texturewrapt repeat \
	-texparameter texture2d texturemagfilter nearest \
	-texparameter texture2d textureminfilter nearest \
	-texenv textureenv textureenvmode modulate\
	-texgen s objectplane  1 0 0 0\
	-texgen t objectplane  0 0 1 0\
	-shademodel smooth \
	-enable texture2d \
	-light light0 ambient 1 1 1 1 \
	-light light0 diffuse 1 1 1 1 \
	-light light0 position 1 1 1 0 \
	-light light0 specular 1 1 1 1 \
	-enable lighting -enable light0 \
	-material front ambient 0.4 0.4 0.4 \
	-material front diffuse 0.5 0.5 0.5 \
	-material front specular 0.5 0.5 0.5 \
	-material front shininess 50 \
	-enable depthtest \
	-enable lighting

set info [.gl gencyl -texgen 0 1 0 1 -polygon 0.5 20 -plot -transl 0 0 1 -plot]
set dlist [lindex [lindex $info 0] 1]
set yrot 0
redisplay

